#!/usr/bin/env python

import sys
import shelve
import gtk
import pango
import socket
from nntplib import *
import cPickle
import time
import re
from os import remove, mkdir, sep
from urllib import quote as url_quote
from rfc822 import parsedate_tz, mktime_tz
from xpn_src.MenuBar import MainMenuBar
from xpn_src.ToolBar import MainToolBar
from xpn_src.Groups_Pane import Groups_Pane
from xpn_src.Threads_Pane import Threads_Pane
from xpn_src.Article_Pane import Article_Pane
from xpn_src.Groups_Win import Groups_Win
from xpn_src.Config_File import Config_File
from xpn_src.Config_Win import Config_Win
from xpn_src.Edit_Win import Edit_Win
from xpn_src.Edit_Mail_Win import Edit_Mail_Win
from xpn_src.Dialogs import About_Dialog, Dialog_YES_NO, Error_Dialog
from xpn_src.Article import Article
from xpn_src.Show_Logs import Logs_Window
from xpn_src.Newsrc import ImportNewsrc, ExportNewsrc
from xpn_src.Find_Win import Find_Win, Search_Win, GlobalSearch
from xpn_src.Score import Score_Rules, Score_Win
from xpn_src.UserDir import UserDir, userdir

VERSION="XPN/0.4.0 (Science ain't an exact science)"

def my_xover(self,start,end):
    """Process an XOVER command (optional server extension) Arguments:
    - start: start of range
    - end: end of range
    Returns:
    - resp: server response if successful
    - list: list of (art-nr, subject, poster, date,
                    id, references, size, lines,xref)"""

    resp, lines = self.longcmd('XOVER ' + start + '-' + end)
    xover_lines = []
    for line in lines:
        elem = line.split("\t")
        try:
            xover_lines.append((elem[0],
                                elem[1],
                                elem[2],
                                elem[3],
                                elem[4],
                                elem[5],
                                elem[6],
                                elem[7],
                                elem[8]))
        except IndexError:
            raise NNTPDataError(line)
    return resp,xover_lines


class MainWin:
    def open_logs_win(self,object):
        self.logs_win=Logs_Window(self.window)

    def open_groups_win(self,object):
        self.win2=Groups_Win(self.configs["server"],self.configs["port"],self.configs["username"],self.configs["password"],self)
        self.win2.show()

    def open_configure_win(self,object):
        self.win3=Config_Win(self.conf,self)
        self.win3.show()

    def open_rules_win(self,object):
        self.score_win=Score_Win(self.score_rules)
        self.score_win.show()

    def supersede_cancel_message(self,object,mode):
        model,iter=self.groups_pane.groups_list.get_selection().get_selected()
        if iter!=None:
            model,iter=self.threads_pane.threads_tree.get_selection().get_selected()
            subj=""
            if iter!=None:
                subj=model.get_value(iter,1).decode("utf-8")
                article=model.get_value(iter,4)
                try:
                    article.ngroups
                except AttributeError:
                    self.statusbar.push(1,"First you have to read the article")
                else:
                    nick=self.configs["nick"]
                    email=self.configs["email"]
                    user=nick+" <"+email+">"
                    if article.user_agent.startswith("XPN") and user==article.from_name:
                        if mode=="Supersede":
                            self.win4=Edit_Win(self.configs,article.ngroups,article,None,self.subscribed_groups,"Supersede")
                            self.win4.textview.modify_font(pango.FontDescription(self.configs["font_name"]))
                            self.win4.show()
                        else:
                            message=Dialog_YES_NO("Do you want to CANCEL this article?\n\nSubejct: "+article.subj+"\nMessage-ID: "+article.msgid)
                            if message.resp:
                                cancel_message="From: %s\nNewsgroups: %s\nSubject: cmsg cancel %s\nControl: cancel %s\nUser_Agent: %s\n\nCancel Message for %s" % (user,article.ngroups,article.msgid,article.msgid,VERSION,article.msgid)
                                f=open(userdir + sep + "article","wb")
                                f.write(cancel_message)
                                f.close()
                                self.try_connection()
                                if self.s!=None:
                                    f=open(userdir + sep + "article","rb")
                                    try:
                                        self.add_log("POST "+article.msgid, True)
                                        self.add_log(self.s.post(f), False)
                                    except :
                                        self.statusbar.push(1,"Server error: "+str(sys.exc_info()[1]))
                                        self.add_log(str(sys.exc_info()[0])+","+str(sys.exc_info()[1]),False)
                                        self.add_log("QUIT",True)
                                        self.add_log(self.server.quit(),False)
                                        f.close()
                                    else:
                                        f.close()
                                        remove(userdir + sep +"article")
                                        self.statusbar.push(1,"Cancel Article Send")
                    else:
                        self.statusbar.push(1,"You can Cancel/Supersede only your articles")

    def open_edit_win(self,object):
        group=""
        model,iter=self.groups_pane.groups_list.get_selection().get_selected()
        if iter!=None:
            group=model.get_value(iter,0)
        if object==self.menuitems["followup"] or object==self.buttons["followup"]:
            #this is a followup
            model,iter=self.threads_pane.threads_tree.get_selection().get_selected()
            subj=""
            if iter!=None:
                subj=model.get_value(iter,1).decode("utf-8")
                article=model.get_value(iter,4)
                group=article.original_group
                try:
                    article.ngroups
                except AttributeError:
                    self.statusbar.push(1,"First you have to read the article")
                else:
                    self.threads_pane.update_article_icon("fup")

                    bounds=self.article_pane.buffer.get_selection_bounds()
                    selected_text=None
                    if bounds:
                        start=bounds[0]
                        stop=bounds[1]
                        selected_text=self.article_pane.buffer.get_text(start,stop,gtk.TRUE).decode("utf-8").split("\n")

                    newsgroups=group
                    if group!=article.ngroups:
                        #this is a crosspost
                        crosspost=True
                        newsgroups=article.ngroups
                    else:
                        crosspost=False
                    if article.fup_to!="":
                        newsgroups=article.fup_to
                        followup_to=True
                    else:
                        followup_to=False

                    if crosspost and not followup_to:
                        message=Dialog_YES_NO("This is a crosspost! \n Do you want to send the article only on the original newsgroup ("+group+") ?")
                        if message.resp:
                            newsgroups=group
                    if followup_to:
                        if article.fup_to!="poster":
                            message=Dialog_YES_NO("Original Poster set \"Followup_to\" on "+article.fup_to+",\n\nDo you want to send your article on the original newsgroup ("+group+") ?")
                            if message.resp:
                                newsgroups=group
                        else:
                            message=Dialog_YES_NO("Original Poster set \"Followup_to: poster\",\n\nDo you want to reply by mail ?")
                            if message.resp:
                                self.open_edit_mail_win(None)
                                return None
                            else:
                                newsgroups=group
                    self.win4=Edit_Win(self.configs,newsgroups,article,selected_text,self.subscribed_groups)
                    self.win4.textview.modify_font(pango.FontDescription(self.configs["font_name"]))
                    self.win4.show()
        else:
            #this is a new post
            self.win4=Edit_Win(self.configs,group,None,None,self.subscribed_groups)
            self.win4.textview.modify_font(pango.FontDescription(self.configs["font_name"]))
            self.win4.show()


    def open_edit_mail_win(self,object):
        to_name=""

        model,iter=self.threads_pane.threads_tree.get_selection().get_selected()
        subj=""
        if iter!=None:
            subj=model.get_value(iter,1).decode("utf-8")
            article=model.get_value(iter,4)
            try:
                article.reply_to
            except AttributeError:
                self.statusbar.push(1,"First you have to read the article")
            else:
                self.threads_pane.update_article_icon("fup")
                if article.reply_to!="":
                    to_name=article.reply_to
                else:
                    to_name=article.from_name
                bounds=self.article_pane.buffer.get_selection_bounds()
                selected_text=None
                if bounds:
                    start=bounds[0]
                    stop=bounds[1]
                    selected_text=self.article_pane.buffer.get_text(start,stop,gtk.TRUE).decode("utf-8").split("\n")

                self.win4=Edit_Mail_Win(self.configs,to_name,article,selected_text)
                self.win4.textview.modify_font(pango.FontDescription(self.configs["font_name"]))
                self.win4.show()

    def open_about_dialog(self,object):
        self.about_dialog=About_Dialog()
        self.about_dialog.show()

    def delete_event(self,widget,event,data=None):
        self.mainwin_width,self.mainwin_height=self.window.get_size()
        self.mainwin_pos_x,self.mainwin_pos_y=self.window.get_position()
        return gtk.FALSE

    def save_sizes(self):
        try:
            f=open(userdir + sep + "dats/sizes.dat","rb")
        except IOError:
            sizes={}        
        else:
            sizes=cPickle.load(f)
        sizes["vpaned_pos"]=self.vpaned.get_position()
        sizes["hpaned_pos"]=self.hpaned.get_position()
        sizes["threads_col_status"]=self.threads_pane.column1.get_width()
        sizes["threads_col_subject"]=self.threads_pane.column2.get_width()
        sizes["threads_col_from"]=self.threads_pane.column3.get_width()
        sizes["threads_col_date"]=self.threads_pane.column4.get_width()
        sizes["threads_col_score"]=self.threads_pane.column5.get_width()
        sizes["groups_col1"]=self.groups_pane.column1.get_width()
        if not self.mainwin_width:
            sizes["mainwin_width"],sizes["mainwin_height"]=self.window.get_size()
        else:
            sizes["mainwin_width"]=self.mainwin_width
            sizes["mainwin_height"]=self.mainwin_height
        if not self.mainwin_pos_x:
            sizes["mainwin_pos_x"],sizes["mainwin_pos_y"]=self.window.get_position()
        else:
            sizes["mainwin_pos_x"]=self.mainwin_pos_x
            sizes["mainwin_pos_x"]=self.mainwin_pos_x
        try:
            f=open(userdir + sep + "dats/sizes.dat","wb")
        except IOError:
            pass
        else:
            cPickle.dump(sizes,f,1)
            f.close()

    def save_chekmenu_options(self):
        self.configs["fixed"]=str(bool(self.menuitems["fixed"].get_active()))
        self.configs["show_quote"]=str(bool(self.menuitems["show_quote"].get_active()))
        self.configs["show_sign"]=str(bool(self.menuitems["show_sign"].get_active()))
        self.configs["show_spoiler"]=str(bool(self.menuitems["spoiler"].get_active()))
        self.configs["show_read_articles"]=str(bool(self.menuitems["show_read_articles"].get_active()))
        self.configs["show_unread_articles"]=str(bool(self.menuitems["show_unread_articles"].get_active()))
        self.configs["show_kept_articles"]=str(bool(self.menuitems["show_kept_articles"].get_active()))
        self.configs["show_unkept_articles"]=str(bool(self.menuitems["show_unkept_articles"].get_active()))
        self.configs["show_watched_articles"]=str(bool(self.menuitems["show_watched_articles"].get_active()))
        self.configs["show_ignored_articles"]=str(bool(self.menuitems["show_ignored_articles"].get_active()))
        self.configs["show_unwatchedignored_articles"]=str(bool(self.menuitems["show_unwatchedignored_articles"].get_active()))
        self.configs["show_score_neg_articles"]=str(bool(self.menuitems["show_score_neg_articles"].get_active()))
        self.configs["show_score_pos_articles"]=str(bool(self.menuitems["show_score_pos_articles"].get_active()))
        self.conf.write_configs()

    def update_checkmenu_options(self):
        if self.configs["fixed"]=="True":
            self.menuitems["fixed"].set_active(gtk.TRUE)
        else:
            self.menuitems["fixed"].set_active(gtk.FALSE)
        if self.configs["show_quote"]=="True":
            self.menuitems["show_quote"].set_active(gtk.TRUE)
        else:
            self.menuitems["show_quote"].set_active(gtk.FALSE)
        if self.configs["show_sign"]=="True":
            self.menuitems["show_sign"].set_active(gtk.TRUE)
        else:
            self.menuitems["show_sign"].set_active(gtk.FALSE)
        if self.configs["show_spoiler"]=="True":
            self.menuitems["spoiler"].set_active(gtk.TRUE)
        else:
            self.menuitems["spoiler"].set_active(gtk.FALSE)
        if self.configs["show_read_articles"]=="True":
            self.menuitems["show_read_articles"].set_active(gtk.TRUE)
        else:
            self.menuitems["show_read_articles"].set_active(gtk.FALSE)
        if self.configs["show_unread_articles"]=="True":
            self.menuitems["show_unread_articles"].set_active(gtk.TRUE)
        else:
            self.menuitems["show_unread_articles"].set_active(gtk.FALSE)
        if self.configs["show_kept_articles"]=="True":
            self.menuitems["show_kept_articles"].set_active(gtk.TRUE)
        else:
            self.menuitems["show_kept_articles"].set_active(gtk.FALSE)
        if self.configs["show_unkept_articles"]=="True":
            self.menuitems["show_unkept_articles"].set_active(gtk.TRUE)
        else:
            self.menuitems["show_unkept_articles"].set_active(gtk.FALSE)
        if self.configs["show_watched_articles"]=="True":
            self.menuitems["show_watched_articles"].set_active(gtk.TRUE)
        else:
            self.menuitems["show_watched_articles"].set_active(gtk.FALSE)
        if self.configs["show_ignored_articles"]=="True":
            self.menuitems["show_ignored_articles"].set_active(gtk.TRUE)
        else:
            self.menuitems["show_ignored_articles"].set_active(gtk.FALSE)
        if self.configs["show_unwatchedignored_articles"]=="True":
            self.menuitems["show_unwatchedignored_articles"].set_active(gtk.TRUE)
        else:
            self.menuitems["show_unwatchedignored_articles"].set_active(gtk.FALSE)
        if self.configs["show_score_neg_articles"]=="True":
            self.menuitems["show_score_neg_articles"].set_active(gtk.TRUE)
        else:
            self.menuitems["show_score_neg_articles"].set_active(gtk.FALSE)
        if self.configs["show_score_pos_articles"]=="True":
            self.menuitems["show_score_pos_articles"].set_active(gtk.TRUE)
        else:
            self.menuitems["show_score_pos_articles"].set_active(gtk.FALSE)
      
    def destroy(self,widget):
        if self.s!=None:
            self.add_log("QUIT",True)
            self.add_log(self.s.quit(),False)
        self.save_sizes()
        self.save_chekmenu_options()
        self.purge_groups()
        gtk.main_quit()


    def show_subscribed(self):
        try:
            f=open(userdir + sep + "groups_info/subscribed.dat","rb")
        except IOError:
            self.statusbar.push(1,"No Subscribed Groups")
            self.groups_pane.show_list([])
        else:
            list=cPickle.load(f)
            new_list=[]
            for group in list:
                try:
                    f2=open(userdir + sep + "groups_info/"+group[0],"rb")
                except IOError:
                    self.statusbar.push(1,"Missing "+group[0]+" file")
                else:
                    f2.close()
                    articles=shelve.open(userdir + sep + "groups_info/"+group[0])
                    unread_number=0
                    total=len(articles.keys())
                    for article in articles.itervalues():
                        if not article.is_read:
                            unread_number=unread_number+1
                    articles.close()
                    new_list.append((group[0],str(unread_number)+" ("+str(total)+")"))
                    self.subscribed_groups.append(group[0])
            self.groups_pane.show_list(new_list,True)
            f.close()
        self.threads_pane.clear()
        self.article_pane.delete_all()
        self.article_pane.update_headers_labels("","","")

    def try_connection(self):
        if self.s==None:
            self.group_entered=""
            try:
                if self.configs["username"]!="":
                    self.add_log("AUTHINFO USER "+self.configs["username"],True)
                    self.add_log("AUTHINFO PASS "+self.configs["password"],True)
                self.add_log("MODE READER",True)

                self.s=NNTP(self.configs["server"],port=int(self.configs["port"]),user=self.configs["username"],password=self.configs["password"],readermode=True)
            except :
                message="No connection with server : "+self.configs["server"]+". Configure NNTP Server Address or try later."
                self.add_log(str(sys.exc_info()[0])+","+str(sys.exc_info()[1]),False)
            else:
                message="Connection with:"+self.configs["server"]
                self.add_log(self.s.getwelcome(),False)
            self.statusbar.push(1,message)
        else:
            try:
                # I use stat only to test if the connection is still up
                self.s.stat("<>")
            except NNTPPermanentError:
                # the connection is broken, I try to estabilish a new connection
                self.s=None
                self.try_connection()
            except NNTPTemporaryError:
                # This exception is raised because the article <> doesn't exist
                # I haven't to do anything
                pass



    def add_log(self,message,is_command):
        try:
            f=open(userdir + sep + "server_logs.dat","a")
        except IOError:
            pass
        else:
            if is_command:
                f.write(time.ctime(time.time())+" :: >> "+message+"\n")
            else:
                f.write(time.ctime(time.time())+" :: << "+message+"\n")
            f.close()


    def show_threads(self,group):
        art_fup=gtk.gdk.pixbuf_new_from_file("pixmaps/art_fup.xpm")
        art_body=gtk.gdk.pixbuf_new_from_file("pixmaps/art_body.xpm")
        art_unread=gtk.gdk.pixbuf_new_from_file("pixmaps/art_unread.xpm")
        art_read=gtk.gdk.pixbuf_new_from_file("pixmaps/art_read.xpm")
        art_mark=gtk.gdk.pixbuf_new_from_file("pixmaps/art_mark.xpm")
        art_keep=gtk.gdk.pixbuf_new_from_file("pixmaps/art_keep.xpm")
        art_unkeep=gtk.gdk.pixbuf_new_from_file("pixmaps/art_unkeep.xpm")
        art_watch=gtk.gdk.pixbuf_new_from_file("pixmaps/art_watch.xpm")
        art_unwatchignore=gtk.gdk.pixbuf_new_from_file("pixmaps/art_unwatchignore.xpm")
        art_ignore=gtk.gdk.pixbuf_new_from_file("pixmaps/art_ignore.xpm")


        self.threads_pane.clear()
        model=self.threads_pane.new_model()

        articles_shelve=shelve.open(userdir + sep + "groups_info/"+group)
        sorted=[(article.secs,article) for article in articles_shelve.itervalues()]
        sorted.sort()
        articles=sorted

        articles_shelve.close()
        article_dict={}

        j=0
        #Threading articles
        self.statusbar.push(1,"Please Wait. Building Threads")

        show_read_articles=bool(self.menuitems["show_read_articles"].get_active())
        show_unread_articles=bool(self.menuitems["show_unread_articles"].get_active())
        show_kept_articles=bool(self.menuitems["show_kept_articles"].get_active())
        show_unkept_articles=bool(self.menuitems["show_unkept_articles"].get_active())
        show_watched_articles=bool(self.menuitems["show_watched_articles"].get_active())
        show_ignored_articles=bool(self.menuitems["show_ignored_articles"].get_active())
        show_unwatchedignored_articles=bool(self.menuitems["show_unwatchedignored_articles"].get_active())
        show_score_neg_articles=bool(self.menuitems["show_score_neg_articles"].get_active())
        show_score_pos_articles=bool(self.menuitems["show_score_pos_articles"].get_active())


        for secs, xpn_article in articles:
            number=xpn_article.number
            msgid=xpn_article.msgid
            nick,from_name,ref,subj,date,date_parsed=xpn_article.get_headers()

            if xpn_article.keep:
                icon2=art_keep
                if not show_kept_articles:
                    continue
            else:
                icon2=art_unkeep
                if not show_unkept_articles:
                    continue

            if xpn_article.is_read:
                read_status=gtk.FALSE
                icon=art_read
                if not show_read_articles:
                    continue
            else:
                read_status=gtk.TRUE
                if xpn_article.body!=None:
                    icon=art_body
                elif xpn_article.marked_for_download:
                    icon=art_mark
                else:
                    icon=art_unread
                if not show_unread_articles:
                    continue

            if xpn_article.score<0:
                set_score_fg=gtk.TRUE
                if not show_score_neg_articles:
                    continue
            else:
                set_score_fg=gtk.FALSE
                if not show_score_pos_articles:
                    continue
            
            if xpn_article.watch:
                icon3=art_watch
                if not show_watched_articles:
                    continue
            elif xpn_article.ignore:
                icon3=art_ignore
                if not show_ignored_articles:
                    continue
            else:
                icon3=art_unwatchignore
                if not show_unwatchedignored_articles:
                    continue

            try:
                idx=ref.rindex("<")
            except ValueError:
                #Root node
                iter=self.threads_pane.insert(model,None,None,[icon,subj,nick,date_parsed,xpn_article,read_status,xpn_article.secs,xpn_article.score,set_score_fg,icon2,icon3])
            else:
                #Child node
                last_ref=ref[idx:]
                iter_mom=article_dict.get(last_ref,None)
                #return the iter of the parent if it's in list, else None
                iter=self.threads_pane.insert(model,iter_mom,None,[icon,subj,nick,date_parsed,xpn_article,read_status,xpn_article.secs,xpn_article.score,set_score_fg,icon2,icon3])
            article_dict[xpn_article.msgid]=iter

        message=group+" selected"
        self.statusbar.push(1,message)

        self.threads_pane.set_model(model)

    def view_group(self,*params):
        clicktype=params[-1]
        if self.configs["oneclick"]=="True" and clicktype=="doubleclick": return
        if self.configs["oneclick"]=="False" and clicktype=="oneclick": return
        if self.groups_lock==False:
            self.groups_lock=True
            treesel=self.groups_pane.groups_list.get_selection()
            model,iter=treesel.get_selected()
            if iter!=None:
                self.group_to_thread=model.get_value(iter,0)
                self.article_pane.delete_all()
                self.show_threads(self.group_to_thread)
            self.groups_lock=False

    def mark_for_download(self,article):
        #mark article for download
        msgid=article.msgid
        articles=shelve.open(userdir + sep + "groups_info/"+self.group_to_thread)
        xpn_article=articles.get(msgid,None)
        if xpn_article!=None:
            article.marked_for_download=not article.marked_for_download
            articles[msgid]=article
        articles.close()


    def set_keep(self,article):
        #set keep flag
        msgid=article.msgid
        articles=shelve.open(userdir + sep + "groups_info/"+self.group_to_thread)
        xpn_article=articles.get(msgid,None)
        if xpn_article!=None:
            article.keep=not article.keep
            articles[msgid]=article
        articles.close()

    def set_watch_icon_subthread(self,iter_parent,model,watch):
        if watch:
            icon=gtk.gdk.pixbuf_new_from_file("pixmaps/art_watch.xpm")
        else:
            icon=gtk.gdk.pixbuf_new_from_file("pixmaps/art_unwatchignore.xpm")
        if model.iter_has_child(iter_parent):
            number=model.iter_n_children(iter_parent)
            for i in xrange(number):
                iter_child=model.iter_nth_child(iter_parent,i)
                self.set_watch_icon_subthread(iter_child,model,watch)
                model.set_value(iter_child,10,icon)
        else:
            model.set_value(iter_parent,10,icon)

    def set_ignore_icon_subthread(self,iter_parent,model,ignore):
        if ignore:
            icon=gtk.gdk.pixbuf_new_from_file("pixmaps/art_ignore.xpm")
        else:
            icon=gtk.gdk.pixbuf_new_from_file("pixmaps/art_unwatchignore.xpm")
        if model.iter_has_child(iter_parent):
            number=model.iter_n_children(iter_parent)
            for i in xrange(number):
                iter_child=model.iter_nth_child(iter_parent,i)
                self.set_ignore_icon_subthread(iter_child,model,ignore)
                model.set_value(iter_child,10,icon)
        else:
            model.set_value(iter_parent,10,icon)

    def set_watch(self,article):
        #set watch flag
        msgid=article.msgid
        articles=shelve.open(userdir + sep + "groups_info/"+self.group_to_thread)
        xpn_article=articles.get(msgid,None)
        if xpn_article!=None:
            article.watch=not article.watch
            watched=self.get_watched()
            ignored=self.get_ignored()
            if article.watch:
                watched.add(msgid)
                ignored.discard(msgid)
                article.ignore=False
            else:
                watched.discard(msgid)

            for sub_article in articles.itervalues():
                #watching others articles in the subthread
                if article.msgid in sub_article.ref:
                    sub_article.watch=article.watch
                    if article.watch:
                        watched.add(sub_article.msgid)
                    else:
                        watched.discard(sub_article.msgid)
                    ignored.discard(sub_article.msgid)
                    sub_article.ignore=False
                    articles[sub_article.msgid]=sub_article

            model,iter_parent=self.threads_pane.threads_tree.get_selection().get_selected()
            self.set_watch_icon_subthread(iter_parent,model,article.watch)
            self.dump_watched(watched)
            self.dump_ignored(ignored)
            articles[msgid]=article
        articles.close()
    
    def set_ignore(self,article):
        #set ignore flag
        msgid=article.msgid
        articles=shelve.open(userdir + sep + "groups_info/"+self.group_to_thread)
        xpn_article=articles.get(msgid,None)
        if xpn_article!=None:
            article.ignore=not article.ignore
            watched=self.get_watched()
            ignored=self.get_ignored()
            if article.ignore:
                ignored.add(msgid)
                watched.discard(msgid)
                article.watch=False
            else:
                ignored.discard(msgid)

            for sub_article in articles.itervalues():
                #ignoring others articles in the subthread
                if article.msgid in sub_article.ref:
                    sub_article.ignore=article.ignore
                    if article.ignore:
                        ignored.add(sub_article.msgid)
                    else:
                        ignored.discard(sub_article.msgid)
                    watched.discard(sub_article.msgid)
                    sub_article.watch=False
                    articles[sub_article.msgid]=sub_article
            model,iter_parent=self.threads_pane.threads_tree.get_selection().get_selected()
            self.set_ignore_icon_subthread(iter_parent,model,article.ignore)
            self.dump_watched(watched)
            self.dump_ignored(ignored)
            articles[msgid]=article
        articles.close()

    def insert_in_unreads(self,article):
        #reinsert article in unreads
        msgid=article.msgid
        articles=shelve.open(userdir + sep + "groups_info/"+self.group_to_thread)
        xpn_article=articles.get(msgid,None)
        if xpn_article!=None:
            if xpn_article.is_read:
                #if the article is read we update the unreads number
                model,iter=self.groups_pane.groups_list.get_selection().get_selected()
                unread_vs_total_numbers=model.get_value(iter,1)
                num,tot=unread_vs_total_numbers.split(" ")
                number=int(num)+1
                model.set_value(iter,1,str(number)+" "+tot)
                if number>=1:
                    model.set_value(iter,2,gtk.TRUE)
            article.is_read=False
            articles[msgid]=article
        articles.close()


    def remove_from_unreads(self,article):
        #remove article from unreads
        msgid=article.msgid
        articles=shelve.open(userdir + sep + "groups_info/"+self.group_to_thread)
        xpn_article=articles.get(msgid,None)
        if xpn_article!=None:
            if not xpn_article.is_read:
                #if the article is unread we update the unreads number
                model,iter=self.groups_pane.groups_list.get_selection().get_selected()
                unread_vs_total_numbers=model.get_value(iter,1)
                num,tot=unread_vs_total_numbers.split(" ")
                number=int(num)-1
                model.set_value(iter,1,str(number)+" "+tot)
                if number<1:
                    model.set_value(iter,2,gtk.FALSE)
            article.is_read=True
            articles[msgid]=article
        articles.close()

    def show_article(self,article):
        self.article_pane.delete_all()
        vadj=self.article_pane.text_scrolledwin.get_vadjustment()
        vadj.set_value(0)
        is_sign=False
        is_quote=False
        line_number=0
        mute_quote=not bool(self.menubar.menuitems["show_quote"].get_active())
        mute_quote_text_inserted=False
        mute_sign=not bool(self.menubar.menuitems["show_sign"].get_active())
        mute_sign_text_inserted=False
        #RE_bold=r"(?:^|[.,:;\s])(\*\w+(?:\s?\w)*\*)(?=[.,:;\s]|$)"
        RE_bold=r"(?:^|.)(\*.+?\*)(?=.|$)"
        #RE_underline=r"(?:^|[.,:;\s(])(_[a-zA-Z0-9]+(?:\s?[a-zA-Z0-9])*_)(?=[.,:;\s)]|$)"
        RE_underline=r"(?:^|[.,:;\s(])(_.+?_)(?=[.,:;\s)]|$)"
        #RE_italic=r"(?:^|[.,:;\s])(/\w+(?:\s?\w)*/)(?=[.,:;\s]|$)"
        RE_italic=r"(?:^|[.,:;\s(])(/.+?/)(?=[.,:;\s)]|$)"
        RE_url=r"(https?://[-a-zA-Z0-9_$.+!*(),;:@%&=?~#'/]*[-a-zA-Z0-9_$+!*(@%&=?~#/])"
        compiled_bold=re.compile(RE_bold,re.UNICODE|re.DOTALL)
        compiled_underline=re.compile(RE_underline,re.UNICODE)
        compiled_italic=re.compile(RE_italic,re.UNICODE|re.DOTALL)
        compiled_url=re.compile(RE_url)

        def quote_depth(line):
            count=0
            for char in line:
                if char==">":
                    count=count+1
                else:
                    break
            if count>3:
                count=3
            return str(count)
            
        for line in article:
            line=line.replace("\r","") #this is needed for some strange articles
            insert_newline=True
            if len(line)>0:
                if line[0]==">":
                    is_quote=True
                elif (len(line)==2 and line[0:2]=="--") or (len(line)==3 and line[0:3]=="-- "):
                    is_sign=True
                    is_quote=False
                else:
                    is_quote=False
                tag_prefix=""

                if is_quote and not is_sign:
                    if mute_quote:
                        if mute_quote_text_inserted:
                            line=""
                            insert_newline=False
                        else:
                            line="> [...Muted Quote...]"
                            mute_quote_text_inserted=True
                    quote_level=quote_depth(line)
                    self.article_pane.insert_with_tags(line,"quote"+quote_level)
                    tag_prefix="quote"+quote_level

                elif is_sign:
                    if mute_sign:
                        if mute_sign_text_inserted:
                            line=""
                            insert_newline=False
                        else:
                            line="[...Muted Sign...]"
                            mute_sign_text_inserted=True
                    self.article_pane.insert_with_tags(line,"sign")
                    tag_prefix="sign"
                    mute_quote_text_inserted=False

                else:
                    self.article_pane.insert_with_tags(line,"text")
                    tag_prefix="text"
                    mute_quote_text_inserted=False

                matchs_bold=compiled_bold.finditer(line)
                matchs_underline=compiled_underline.finditer(line)
                matchs_italic=compiled_italic.finditer(line)
                match_url=compiled_url.finditer(line)

                for match in matchs_bold:
                    iter_start=self.article_pane.buffer.get_start_iter()
                    iter_start.set_line(line_number)
                    iter_stop=iter_start.copy()
                    iter_start.set_line_offset(match.start(1))
                    iter_stop.set_line_offset(match.end(1))
                    self.article_pane.buffer.delete(iter_start,iter_stop)
                    self.article_pane.insert_with_tags_at_iter(iter_start,match.group(1),tag_prefix+"_bold")
                for match in matchs_underline:
                    iter_start=self.article_pane.buffer.get_start_iter()
                    iter_start.set_line(line_number)
                    iter_stop=iter_start.copy()
                    iter_start.set_line_offset(match.start(1))
                    iter_stop.set_line_offset(match.end(1))
                    self.article_pane.buffer.delete(iter_start,iter_stop)
                    self.article_pane.insert_with_tags_at_iter(iter_start,match.group(1),tag_prefix+"_underline")
                for match in matchs_italic:
                    iter_start=self.article_pane.buffer.get_start_iter()
                    iter_start.set_line(line_number)
                    iter_stop=iter_start.copy()
                    iter_start.set_line_offset(match.start(1))
                    iter_stop.set_line_offset(match.end(1))
                    self.article_pane.buffer.delete(iter_start,iter_stop)
                    self.article_pane.insert_with_tags_at_iter(iter_start,match.group(1),tag_prefix+"_italic")
                for match in match_url:
                    iter_start=self.article_pane.buffer.get_start_iter()
                    iter_start.set_line(line_number)
                    iter_stop=iter_start.copy()
                    iter_start.set_line_offset(match.start(0))
                    iter_stop.set_line_offset(match.end(0))
                    self.article_pane.buffer.delete(iter_start,iter_stop)
                    self.article_pane.insert_with_tags_at_iter(iter_start,match.group(0),"url")

            if insert_newline:
                self.article_pane.insert("\n")
                line_number=line_number+1
        if self.menubar.menuitems["spoiler"].get_active()==gtk.FALSE:
            self.apply_spoiler()

    def apply_spoiler(self):
        bounds=self.article_pane.buffer.get_bounds()
        RE_spoiler=chr(12)+".+?"+chr(12)
        if bounds:
            start,stop=bounds
            text=self.article_pane.buffer.get_text(start,stop,gtk.TRUE).decode("utf-8")
            matchs_spoiler=re.compile(RE_spoiler,re.UNICODE|re.DOTALL).finditer(text)
            for match in matchs_spoiler:
                match_start,match_stop,match_text= match.start(), match.end(), match.group()

                iter_start=self.article_pane.buffer.get_iter_at_offset(match_start)
                iter_stop=self.article_pane.buffer.get_iter_at_offset(match_stop)
                self.article_pane.buffer.delete(iter_start,iter_stop)
                self.article_pane.insert_with_tags_at_iter(iter_start,match_text,"spoiler")

            if divmod(text.count(chr(12)),2)[1]!=0:
                #the number of spoiler chars is an odd number
                pos=text.rindex(chr(12))
                iter_start=self.article_pane.buffer.get_iter_at_offset(pos)
                iter_stop=self.article_pane.buffer.get_end_iter()
                match_text=self.article_pane.buffer.get_text(iter_start,iter_stop)
                self.article_pane.buffer.delete(iter_start,iter_stop)
                self.article_pane.insert_with_tags_at_iter(iter_start,match_text,"spoiler")

    def retrieve_body(self,article_to_read,group):
        body=article_to_read.get_body()
        self.article_pane.textview.grab_focus()
        if body==None:
            self.try_connection()
            body=[]
            if self.s!=None:
                if group!=self.group_entered:
                    #we have to send group command
                    try:
                        self.add_log("GROUP "+group,True)
                        resp,count,first,last,name=self.s.group(group)
                    except :
                        self.statusbar.push(1,"Server error: "+str(sys.exc_info()[1]))
                        self.add_log(str(sys.exc_info()[0])+","+str(sys.exc_info()[1]),False)
                        self.add_log("QUIT",True)
                        self.add_log(self.s.quit(),False)
                        self.s=None
                    else:
                        self.add_log(resp,False)
                        self.group_entered=group

                try:
                    self.add_log("HEAD "+article_to_read.number,True)
                    resp,number,msgid,header_list=self.s.head(article_to_read.number)
                except NNTPTemporaryError:
                    if str(sys.exc_info()[1])[:1]=="4":
                        #article is not on the server, we use a phantom article
                        link=r"http://groups.google.com/groups?ie=UTF-8&oe=UTF-8&as_umsgid="+url_quote(article_to_read.msgid[1:-1])
                        body=("Server Error: "+str(sys.exc_info()[1]),"","You can try on Google:","",link)
                    else:
                        self.statusbar.push(1,"Server Error: str(sys.exc_info()[1])")
                        #VALUTARE SE BISOGNA GESTIRE LA SITUAZIONE!!!
                else:
                    self.add_log(resp,False)
                    article_to_read.parse_header_list(header_list)
                    self.add_log("BODY "+article_to_read.number,True)
                    resp,number,id,list=self.s.body(article_to_read.number)
                    self.add_log(resp,False)
                    article_to_read.set_body(list)
                    body=article_to_read.get_body()
                    article_to_read.marked_for_download=False
        return body

    def view_article(self,*params):
        #params=obj,path,column,clicktype
        clicktype=params[-1]
        treesel=self.threads_pane.threads_tree.get_selection()
        model,iter=treesel.get_selected()
        if iter!=None:
            article_to_read=model.get_value(iter,4)
            if self.configs["oneclick"]=="True" and clicktype=="doubleclick": return
            if self.configs["oneclick"]=="False" and clicktype=="oneclick":
                self.article_pane.update_headers_labels(article_to_read.from_name.encode("utf-8"),article_to_read.subj.encode("utf-8"),article_to_read.date.encode("utf-8"))
                self.article_pane.delete_all()
                if (article_to_read.is_read) and (article_to_read.get_body()!=None):
                    self.show_article(article_to_read.get_body())
                    
                return
            model.set_value(iter,5,gtk.FALSE)
            self.article_pane.textview.grab_focus()
            body=self.retrieve_body(article_to_read,article_to_read.original_group)
            self.threads_pane.update_article_icon("read")
            self.remove_from_unreads(article_to_read)
            self.article_pane.update_headers_labels(article_to_read.from_name.encode("utf-8"),article_to_read.subj.encode("utf-8"),article_to_read.date.encode("utf-8"))
            self.show_article(body)
            self.raw=False

    def view_raw_article(self,obj):
        if not self.raw:
            treesel=self.threads_pane.threads_tree.get_selection()
            model,iter=treesel.get_selected()
            if iter!=None:
                article_to_read=model.get_value(iter,4)
                path=model.get_path(iter)
                raw_article=article_to_read.get_raw()
                if raw_article==None:
                    self.try_connection()
                    raw_article=[]
                    if self.s!=None:
                        if article_to_read.original_group!=self.group_entered:
                            #we have to send group command
                            try:
                                self.add_log("GROUP "+article_to_read.original_group,True)
                                resp,count,first,last,name=self.s.group(article_to_read.original_group)
                            except :
                                self.statusbar.push(1,"Server error: "+str(sys.exc_info()[1]))
                                self.add_log(str(sys.exc_info()[0])+","+str(sys.exc_info()[1]),False)
                                self.add_log("QUIT",True)
                                self.add_log(self.s.quit(),False)
                                self.s=None #Quando arrivo qua dopo il self.s.article mi fallisce!!
                            else:
                                self.add_log(resp,False)
                                self.group_entered=article_to_read.original_group
                        
                        try:
                            self.add_log("HEAD "+article_to_read.number,True)
                            resp,number,msgid,header_list=self.s.head(article_to_read.number)
                        except NNTPTemporaryError:
                            if str(sys.exc_info()[1])[:1]=="4":
                                link=r"http://groups.google.com/groups?ie=UTF-8&oe=UTF-8&as_umsgid="+url_quote(article_to_read.msgid[1:-1])
                                raw_article=("Server Error: "+str(sys.exc_info()[1]),"","You can try on Google:","",link)
                            else:
                                self.statusbar.push(1,"Server Error: str(sys.exc_info()[1])")
                                #VALUTARE SE BISOGNA GESTIRE LA SITUAZIONE!!!
                        else:
                            self.add_log(resp,False)
                            article_to_read.parse_header_list(header_list)
                            self.add_log("ARTICLE "+article_to_read.number,True)
                            resp,number,id,list=self.s.article(article_to_read.number)
                            self.add_log(resp,False)
                            article_to_read.set_raw(list)
                            raw_article=article_to_read.get_raw()
                article_to_read.marked_for_download=False
                self.remove_from_unreads(article_to_read)
                self.threads_pane.update_article_icon("read")
                model.set_value(iter,5,gtk.FALSE)
                self.show_article(raw_article)
                self.raw=True
        else:
            if self.configs["oneclick"]=="True":
                clicktype="oneclick"
            else:
                clicktype="doubleclick"
            self.view_article(None,None,None,clicktype)


    def view_next_article(self,obj):
        treesel=self.threads_pane.threads_tree.get_selection()
        model,iter=treesel.get_selected()
        column=self.threads_pane.threads_tree.get_column(0)
        if iter==None:
            iter_new=model.get_iter_first()
        else:
            iter_new=self.threads_pane.find_next_row(model,iter)
        if iter_new!=None:
            path=model.get_path(iter_new)
            self.threads_pane.threads_tree.expand_row(path,gtk.FALSE)
            self.threads_pane.threads_tree.scroll_to_cell(path,None,gtk.TRUE,0.4,0.0)
            self.threads_pane.threads_tree.set_cursor(path,None,gtk.FALSE)
            self.threads_pane.threads_tree.row_activated(path,column)

    def view_next_unread_article(self,obj):
        treesel=self.threads_pane.threads_tree.get_selection()
        model,iter=treesel.get_selected()
        column=self.threads_pane.threads_tree.get_column(0)
        if iter==None:
            iter=model.get_iter_first()
        if iter!=None:
            read_status=model.get_value(iter,5)
        else:
            read_status=False
        while (not read_status) and (iter!=None):
            iter=self.threads_pane.find_next_row(model,iter)
            if iter!=None:
                read_status=model.get_value(iter,5)
            else:
                read_status=False
        if read_status:
            path=model.get_path(iter)
            root_path=[]
            root_path.append(path[0])
            root_path=tuple(root_path)
            self.threads_pane.threads_tree.expand_row(root_path,gtk.TRUE)
            self.threads_pane.threads_tree.grab_focus()
            self.threads_pane.threads_tree.scroll_to_cell(path,None,gtk.TRUE,0.4,0.0)
            self.threads_pane.threads_tree.set_cursor(path,None,gtk.FALSE)
            self.threads_pane.threads_tree.row_activated(path,column)




    def view_previous_article(self,obj):
        treesel=self.threads_pane.threads_tree.get_selection()
        model,iter=treesel.get_selected()
        column=self.threads_pane.threads_tree.get_column(0)
        if iter==None:
            iter_new=model.get_iter_first()
        else:
            iter_new=self.threads_pane.find_previous_row(model,iter)
        if iter_new!=None:
            path=model.get_path(iter_new)
            self.threads_pane.threads_tree.set_cursor(path,None,gtk.FALSE)
            self.threads_pane.threads_tree.row_activated(path,column)

    def view_parent_article(self,obj):
        model,iter_son=self.threads_pane.threads_tree.get_selection().get_selected()
        if iter_son!=None:
            article_son=model.get_value(iter_son,4)
            references=article_son.ref
            if references=="":
                self.statusbar.push(1,"This is root article")
            else:
                idx=references.rindex("<")
                last_ref=references[idx:]

                #First search the parent in the threaded articles
                iter=model.get_iter_first()
                success=False
                while iter!=None and not success:
                    article_mom=model.get_value(iter,4)
                    if article_mom.msgid==last_ref:
                        #It is in the threads, let's show the article selecting its row
                        path=model.get_path(iter)
                        self.threads_pane.threads_tree.set_cursor(path,None,gtk.FALSE)
                        self.threads_pane.threads_tree.row_activated(path,self.threads_pane.column1)
                        self.statusbar.push(1,"Article Found")
                        success=True
                    else:
                        iter=self.threads_pane.find_next_row(model,iter)

                if not success:
                    #Let' search the article on the server
                    self.try_connection()
                    if self.s!=None:
                        if article_son.original_group!=self.group_entered:
                            #we have to send group command
                            try:
                                self.add_log("GROUP "+article_son.original_group,True)
                                resp,count,first,last,name=self.s.group(article_son.original_group)
                            except :
                                self.statusbar.push(1,"Server error: "+str(sys.exc_info()[1]))
                                self.add_log(str(sys.exc_info()[0])+","+str(sys.exc_info()[1]),False)
                                self.add_log("QUIT",True)
                                self.add_log(self.s.quit(),False)
                                self.s=None
                            else:
                                self.add_log(resp,False)
                                self.group_entered=article_son.original_group

                        try:
                            resp,number,msgid,header_list=self.s.head(last_ref) #I use this only to test if the article is on the server
                            self.add_log("XOVER "+str(number)+"-"+str(number),True)
                            resp,headers=self.s.my_xover(number,number)
                        except NNTPTemporaryError:
                            self.statusbar.push(1,"This article is not available on the server")
                        else:
                            number,subj,from_name,date,msgid,ref,bytes,lines,xref=headers[0]
                            self.add_log(resp,False)
                            #If it is not in the threaded articles, let's insert a node for this article
                            article=Article(number,msgid,from_name,ref,subj,date,self.configs["fallback_charset"],article_son.original_group)
                            #applying score rules
                            score=self.score_rules.apply_score_rules(article,article.original_group,xref,bytes,lines)
                            article.set_score(score)
                            nick,from_name,ref,subj,date,date_parsed=article.get_headers()
                            art_unread=gtk.gdk.pixbuf_new_from_file("pixmaps/art_unread.xpm")
                            art_unkeep=gtk.gdk.pixbuf_new_from_file("pixmaps/art_unkeep.xpm")

                            if score<0:
                                set_score_fg=gtk.TRUE
                            else:
                                set_score_fg=gtk.FALSE
                            iter=self.threads_pane.insert(model,None,iter_son,[art_unread,subj,nick,date_parsed,article,gtk.TRUE,article.secs,article.score,set_score_fg,art_unkeep])
                            path=model.get_path(iter)
                            self.threads_pane.threads_tree.set_cursor(path,None,gtk.FALSE)
                            self.threads_pane.threads_tree.row_activated(path,self.threads_pane.column1)
                            self.statusbar.push(1,"Article loaded")

    def get_new_headers(self,obj):
        "Download new headers for the subscribed"
        try:
            f=open(userdir + sep + "groups_info/subscribed.dat","rb")
        except IOError:
            self.statusbar.push(1,"No subscribed groups")
        else:
            subscribed=cPickle.load(f)
            f.close()
            f=open(userdir + sep + "groups_info/subscribed.dat","wb")
            for group in subscribed:
                group[1]=self.download_headers(group[0],group[1])
            cPickle.dump(subscribed,f,1)
            f.close()
            self.statusbar.push(1,"Dowload completed")
            model,iter_selected=self.groups_pane.groups_list.get_selection().get_selected()
            if iter_selected: 
                path=model.get_path(iter_selected)
            self.show_subscribed()
            if iter_selected:
                self.groups_pane.groups_list.set_cursor(path,None,gtk.FALSE)
                self.groups_pane.groups_list.row_activated(path,self.groups_pane.groups_list.get_column(0))
    
    def get_new_headers_selected(self,obj):
        "Dowload new headers for selected group"
        try:
            f=open(userdir + sep + "groups_info/subscribed.dat","rb")
        except IOError:
            self.statusbar.push(1,"No subscribed groups")
        else:
            subscribed=cPickle.load(f)
            f.close()
            model,iter_selected=self.groups_pane.groups_list.get_selection().get_selected()
            if iter_selected:
                path=model.get_path(iter_selected)
                group_name=model.get_value(iter_selected,0)
                for group in subscribed:
                    if group[0]==group_name:
                        group[1]=self.download_headers(group[0],group[1])
                f=open(userdir + sep + "groups_info/subscribed.dat","wb")
                cPickle.dump(subscribed,f,1)
                f.close()
                self.show_subscribed()
                self.groups_pane.groups_list.set_cursor(path,None,gtk.FALSE)
                self.groups_pane.groups_list.row_activated(path,self.groups_pane.groups_list.get_column(0)) 


    def download_headers(self,group,last_number):
        self.try_connection()
        self.group_entered=""
        if self.s!=None:
            try:
                self.add_log("GROUP "+group,True)
                resp,count,first,last,name=self.s.group(group)
            except :
                self.statusbar.push(1,"Server error: "+str(sys.exc_info()[1]))
                self.add_log(str(sys.exc_info()[0])+","+str(sys.exc_info()[1]),False)
                self.add_log("QUIT",True)
                self.add_log(self.s.quit(),False)
                self.s=None
            else:
                watched=self.get_watched()
                ignored=self.get_ignored()
                self.add_log(resp,False)
                old_last=int(last_number)
                if (old_last+1)<=int(last):
                    last_number=last
                    first=repr(old_last+1)
                    articles=shelve.open(userdir + sep + "groups_info/"+group)

                    #Downloading headers
                    self.progressbar.set_text("Fetching Headers")
                    self.progressbar.set_fraction(1/float(2))
                    while gtk.events_pending():
                        gtk.main_iteration(gtk.FALSE)
                    self.add_log("XOVER "+first+"-"+last,True)
                    resp,total_headers=self.s.my_xover(first,last)
                    self.add_log(resp,False)
                    self.statusbar.push(1,self.configs["server"]+" response : "+resp)

                    self.progressbar.set_text("Building Articles")
                    self.progressbar.set_fraction(2/float(2))
                    while gtk.events_pending():
                        gtk.main_iteration(gtk.FALSE)
                    for headers in total_headers:
                        number,subject,from_name,date,msgid,references,bytes,lines,xref=headers
                        xpn_article=Article(number,msgid,from_name,references,subject,date,self.configs["fallback_charset"],group)
                        try:
                            index=references.rindex("<")
                        except ValueError:
                            last_ref=""
                        else:
                            last_ref=references[index:]
                        #applying score rules
                        score=self.score_rules.apply_score_rules(xpn_article,group,xref,bytes,lines)
                        xpn_article.set_score(score)

                        #applying score actions
                        xpn_article,actions,watched,ignored=self.score_rules.apply_action_rules(xpn_article,group,xref,bytes,lines,watched,ignored)
                        if not "kill" in actions:
                            if ((self.configs["download_bodies"]=="True" and not "markread" in actions) or ("retrieve" in actions) or (last_ref in watched)) and not last_ref in ignored:
                                body=self.retrieve_body(xpn_article,group)
                            if last_ref in ignored:
                                xpn_article.is_read=True
                                xpn_article.ignore=True
                                ignored.add(xpn_article.msgid)
                                watched.discard(xpn_article.msgid)
                                xpn_article.watch=False
                            if last_ref in watched:
                                xpn_article.watch=True
                                watched.add(xpn_article.msgid)
                                ignored.discard(xpn_article.msgid)
                                xpn_article.ignore=False
                            articles[xpn_article.msgid]=xpn_article
                    articles.close()
                self.dump_watched(watched)
                self.dump_ignored(ignored)
        self.progressbar.set_fraction(0)
        self.progressbar.set_text("")

        return last_number


    def get_bodies(self,obj):
        "Download bodies for marked articles"
        try:
            f=open(userdir + sep + "groups_info/subscribed.dat","rb")
        except IOError:
            self.statusbar.push(1,"No subscribed groups")
        else:
            subscribed=cPickle.load(f)
            f.close()
            for group in subscribed:
                self.download_bodies(group[0])
            self.threads_pane.clear()
            self.article_pane.delete_all()
            self.progressbar.set_fraction(0)
            self.progressbar.set_text("")
            self.statusbar.push(1,"Download Completed")
            model,iter_selected=self.groups_pane.groups_list.get_selection().get_selected()
            if iter_selected:
                path=model.get_path(iter_selected)
                self.show_subscribed()
                self.groups_pane.groups_list.set_cursor(path,None,gtk.FALSE)
                self.groups_pane.groups_list.row_activated(path,self.groups_pane.groups_list.get_column(0))
    
    def get_bodies_selected(self,obj):
        "Download bodies for marked articles in selected group"
        try:
            f=open(userdir + sep + "groups_info/subscribed.dat","rb")
        except IOError:
            self.statusbar.push(1,"No subscribed groups")
        else:
            subscribed=cPickle.load(f)
            f.close()
            model,iter_selected=self.groups_pane.groups_list.get_selection().get_selected()
            if iter_selected:
                path=model.get_path(iter_selected)
                group_name=model.get_value(iter_selected,0)
                for group in subscribed:
                    if group[0]==group_name:
                        self.download_bodies(group[0])
                self.threads_pane.clear()
                self.article_pane.delete_all()
                self.progressbar.set_fraction(0)
                self.progressbar.set_text("")
                self.statusbar.push(1,"Download Completed")
                self.groups_pane.groups_list.set_cursor(path,None,gtk.FALSE)
                self.groups_pane.groups_list.row_activated(path,self.groups_pane.groups_list.get_column(0)) 
                        
    def download_bodies(self,group):
        articles=shelve.open(userdir + sep + "groups_info/"+group)
        self.statusbar.push(1,"Downloading Bodies from "+group)
        marked_articles=[article for article in articles.itervalues() if article.marked_for_download==True]
        j=0
        length=len(marked_articles)
        for article in marked_articles:
            j=j+1
            body=self.retrieve_body(article,group)
            articles[article.msgid]=article
            self.progressbar.set_fraction(j/float(length))
            self.progressbar.set_text("Downloading %s of %s" % (j,length))
            while gtk.events_pending():
                gtk.main_iteration(gtk.FALSE)
        articles.close()
    
    def one_key_reading(self,obj):
        #increment=80
        vadj=self.article_pane.text_scrolledwin.get_vadjustment()
        increment= vadj.page_increment * int(self.configs["scroll_fraction"]) / 100
        value= vadj.get_value()
        if value+increment+vadj.page_size<vadj.upper:
            vadj.set_value(value+increment)
        else:
            if vadj.upper-vadj.page_size==vadj.get_value():
                self.view_next_unread_article(None)
            else:
                vadj.set_value(vadj.upper-vadj.page_size)

    def expand_all_threads(self,obj):
        self.threads_pane.threads_tree.expand_all()

    def collapse_all_threads(self,obj):
        self.threads_pane.threads_tree.collapse_all()

    def mark_group(self,obj):
        "Mark group read"
        treesel=self.groups_pane.groups_list.get_selection()
        model,iter=treesel.get_selected()
        if iter!=None:
            group_to_mark=model.get_value(iter,0)
            try:
                f=open(userdir + sep + "groups_info/"+group_to_mark,"rb")
            except IOError:
                pass
            else:
                f.close()
                articles=shelve.open(userdir + sep + "groups_info/"+group_to_mark)
                for article in articles.itervalues():
                    if not article.is_read:
                        article.is_read=True
                        articles[article.msgid]=article
                articles.close()
                self.show_subscribed()



    def mark_all_groups(self,obj):
        "Mark all groups read"
        try:
            f=open(userdir + sep + "groups_info/subscribed.dat","rb")
        except IOError:
            pass
        else:
            subscribed=cPickle.load(f)
            f.close()
            for i in range(len(subscribed)):
                try:
                    f=open(userdir + sep + "groups_info/"+subscribed[i][0],"rb")
                except IOError:
                    pass
                else:
                    f.close()
                    articles=shelve.open(userdir + sep + "groups_info/"+subscribed[i][0])
                    for article in articles.itervalues():
                        if not article.is_read:
                            article.is_read=True
                            articles[article.msgid]=article
                    articles.close()
            self.show_subscribed()


    def rot13(self,text):
        "Rot13 the string passed"
        string_coded = ""
        dic={'a':'n','b':'o','c':'p','d':'q','e':'r','f':'s','g':'t',
             'h':'u','i':'v','j':'w','k':'x','l':'y','m':'z',
             'n':'a','o':'b','p':'c','q':'d','r':'e','s':'f','t':'g',
             'u':'h','v':'i','w':'j','x':'k','y':'l','z':'m',
             'A':'N','B':'O','C':'P','D':'Q','E':'R','F':'S','G':'T',
             'H':'U','I':'V','J':'W','K':'X','L':'Y','M':'Z',
             'N':'A','O':'B','P':'C','Q':'D','R':'E','S':'F','T':'G',
             'U':'H','V':'I','W':'J','X':'K','Y':'L','Z':'M'}
        for c in text:
            char=dic.get(c,c)
            string_coded=string_coded+char
        return string_coded

    def apply_rot13(self,obj):
        bounds=self.article_pane.buffer.get_selection_bounds()
        if bounds:
            #rot selected text
            start=bounds[0]
            stop=bounds[1]
            self.article_pane.buffer.create_mark("start_rot13",start,gtk.TRUE)

            text=self.article_pane.buffer.get_text(start,stop,gtk.TRUE).decode("utf-8")
            text_rotted=self.rot13(text)
            self.article_pane.buffer.delete_selection(gtk.FALSE,gtk.FALSE)
            self.article_pane.insert(text_rotted)

            start=self.article_pane.buffer.get_iter_at_mark(self.article_pane.buffer.get_mark("start_rot13"))
            self.article_pane.buffer.move_mark_by_name("insert",start)
        else:
            #rot the article
            bounds=self.article_pane.buffer.get_bounds()
            if bounds:
                start,stop=bounds
                text=self.article_pane.buffer.get_text(start,stop,gtk.TRUE).decode("utf-8")
                text_rotted=self.rot13(text)
                self.show_article(text_rotted.split("\n"))


    def set_fixed_pitch(self,obj):
        monospace=pango.FontDescription("Monospace 9")
        user=pango.FontDescription(self.configs["font_name"])
        style=self.article_pane.textview.get_style().copy()
        if style.font_desc.get_family()!=monospace.get_family():
            self.article_pane.textview.modify_font(monospace)
        else:
            self.article_pane.textview.modify_font(user)


    def show_hide_headers(self,obj):
        self.article_pane.show_hide_headers(self.article_pane.button_show_hide_headers)

    def export_newsrc(self,obj):
        def dispatch_response(dialog,id):
            if id==gtk.RESPONSE_OK:
                self.save_newsrc(None)
            if id==gtk.RESPONSE_CANCEL:
                self.file_dialog.destroy()
        self.file_dialog=gtk.FileChooserDialog("Select Newsrc Export Path",None,gtk.FILE_CHOOSER_ACTION_SAVE,(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_SAVE,gtk.RESPONSE_OK))
        self.file_dialog.set_local_only(gtk.TRUE)
        self.file_dialog.set_current_name("newsrc")
        self.file_dialog.connect("response",dispatch_response)
        path=self.file_dialog.get_current_folder()
        self.file_dialog.set_current_folder(path)
        self.file_dialog.show()

    def import_newsrc(self,obj):
        def dispatch_response(dialog,id):
            if id==gtk.RESPONSE_OK:
                self.load_newsrc(None)
            if id==gtk.RESPONSE_CANCEL:
                self.file_dialog.destroy()

        def show_hide_hidden(obj):
            self.file_dialog.set_property("show_hidden",obj.get_active())

        self.file_dialog=gtk.FileChooserDialog("Select Newsrc File",None,gtk.FILE_CHOOSER_ACTION_OPEN,(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
        hidden_checkbutton=gtk.CheckButton("Show Hidden Files")
        self.file_dialog.set_extra_widget(hidden_checkbutton)
        hidden_checkbutton.connect("clicked",show_hide_hidden)
        self.file_dialog.set_local_only(gtk.TRUE)
        self.file_dialog.connect("response",dispatch_response)
        path=self.file_dialog.get_current_folder()
        self.file_dialog.set_current_folder(path)
        self.file_dialog.show()

    def save_newsrc(self,obj):
        path=self.file_dialog.get_filename()
        newsrc_file=ExportNewsrc()
        newsrc_file.save_newsrc(path)
        self.file_dialog.destroy()
        self.statusbar.push(1,newsrc_file.message)

    def load_newsrc(self,obj):
        path=self.file_dialog.get_filename()
        self.file_dialog.destroy()
        try:
            f=open(path,"rb")
        except IOError:
            self.statusbar.push(1,"File does not exist")
        else:
            newsrc_file=f.readlines()
            imp_newsrc=ImportNewsrc(newsrc_file,self,self.configs)
            self.show_subscribed()
            self.progressbar.set_fraction(0.0)
            self.progressbar.set_text("")
            self.statusbar.push(1,"Newsrc successful imported")

    def context_mark_read(self,obj):
        treesel=self.threads_pane.threads_tree.get_selection()
        model,iter=treesel.get_selected()
        if iter!=None:
            article=model.get_value(iter,4)
            self.remove_from_unreads(article)
            self.threads_pane.update_article_icon("read")
            model.set_value(iter,5,gtk.FALSE)

    def context_mark_unread(self,obj):
        treesel=self.threads_pane.threads_tree.get_selection()
        model,iter=treesel.get_selected()
        if iter!=None:
            article=model.get_value(iter,4)
            self.insert_in_unreads(article)
            model.set_value(iter,5,gtk.TRUE)
            if article.body==None:
                self.threads_pane.update_article_icon("unread")
            else:
                self.threads_pane.update_article_icon("body")

    def context_keep(self,obj):
        treesel=self.threads_pane.threads_tree.get_selection()
        model,iter=treesel.get_selected()
        if iter!=None:
            article=model.get_value(iter,4)
            self.set_keep(article)
            if article.keep:
                self.threads_pane.update_article_icon("keep")
            else:
                self.threads_pane.update_article_icon("unkeep")

    
    def context_watch(self,obj):
        treesel=self.threads_pane.threads_tree.get_selection()
        model,iter=treesel.get_selected()
        if iter!=None:
            article=model.get_value(iter,4)
            self.set_watch(article)
            if article.watch:
                self.threads_pane.update_article_icon("watch")
            else:
                self.threads_pane.update_article_icon("unwatchignore")
   
    def context_ignore(self,obj):
        treesel=self.threads_pane.threads_tree.get_selection()
        model,iter=treesel.get_selected()
        if iter!=None:
            article=model.get_value(iter,4)
            self.set_ignore(article)
            if article.ignore:
                self.threads_pane.update_article_icon("ignore")
            else:
                self.threads_pane.update_article_icon("unwatchignore")

    def context_modify_score(self,obj,action):
        treesel=self.threads_pane.threads_tree.get_selection()
        model,iter=treesel.get_selected()
        if iter!=None:
            article=model.get_value(iter,4)
            newsgroup=self.group_to_thread
            from_name=article.from_name
            self.score_win=Score_Win(self.score_rules)
            self.score_win.header_opt_menu.set_active(0)
            self.score_win.scope_combo.child.set_text("["+newsgroup+"]")
            self.score_win.match_type_opt_menu.set_active(0)
            self.score_win.match_value_entry.set_text(from_name.encode("utf-8"))
            self.score_win.case_checkbutton.set_active(gtk.TRUE)
            self.score_win.score_mod_spinbutton.set_value(100)
            self.score_win.action_type_opt_menu.set_active(action)
            self.score_win.show()
            self.score_win.notebook.set_current_page(1)

    def context_mark_download(self,obj):
        treesel=self.threads_pane.threads_tree.get_selection()
        model,iter=treesel.get_selected()
        if iter!=None:
            article=model.get_value(iter,4)
            if article.body==None:
                self.mark_for_download(article)
                if article.marked_for_download:
                    self.threads_pane.update_article_icon("download")
                elif article.body!=None:
                    self.threads_pane.update_article_icon("body")
                else:
                    self.threads_pane.update_article_icon("unread")




    def threads_context_menu(self,obj,event):
        if event.button==3:

            menu=self.menubar.submenu_flags
            menu.popup(None,None,None,event.button,event.time)

    def find_article(self,obj):
        self.find_win=Find_Win(self)
        self.find_win.show()

    def global_search(self,obj):
        self.GlobalSearch=GlobalSearch(self)
        self.GlobalSearch.show()

    def search_in_the_article(self,obj):
        self.search_win=Search_Win(self)
        self.search_win.show()

    def connect_signals(self):
        #menuitems signals
        self.menuitems=self.menubar.get_menuitems()
        self.menuitems["groups"].connect("activate",self.open_groups_win)
        self.menuitems["logs"].connect("activate",self.open_logs_win)
        self.menuitems["post"].connect("activate",self.open_edit_win)
        self.menuitems["followup"].connect("activate",self.open_edit_win)
        self.menuitems["reply"].connect("activate",self.open_edit_mail_win)
        self.menuitems["one_key"].connect("activate",self.one_key_reading)
        self.menuitems["conf"].connect("activate",self.open_configure_win)
        self.menuitems["about"].connect("activate",self.open_about_dialog)
        self.menuitems["exit"].connect("activate",self.destroy)
        self.menuitems["group"].connect("activate",self.groups_pane.view_next_group)
        self.menuitems["next"].connect("activate",self.view_next_article)
        self.menuitems["next_unread"].connect("activate",self.view_next_unread_article)
        self.menuitems["previous"].connect("activate",self.view_previous_article)
        self.menuitems["parent"].connect("activate",self.view_parent_article)
        self.menuitems["gethdrs"].connect("activate",self.get_new_headers)
        self.menuitems["gethdrssel"].connect("activate",self.get_new_headers_selected)
        self.menuitems["getbodies"].connect("activate",self.get_bodies)
        self.menuitems["getbodiessel"].connect("activate",self.get_bodies_selected)
        self.menuitems["raw"].connect("activate",self.view_raw_article)
        self.menuitems["expand"].connect("activate",self.expand_all_threads)
        self.menuitems["collapse"].connect("activate",self.collapse_all_threads)
        self.menuitems["mark"].connect("activate",self.mark_group)
        self.menuitems["markall"].connect("activate",self.mark_all_groups)
        self.menuitems["rot13"].connect("activate",self.apply_rot13)
        self.menuitems["spoiler"].connect("activate",self.view_article)
        self.menuitems["show_quote"].connect("activate",self.view_article)
        self.menuitems["show_sign"].connect("activate",self.view_article)
        self.menuitems["fixed"].connect("activate",self.set_fixed_pitch)
        self.menuitems["show_hide_headers"].connect("activate",self.show_hide_headers)
        self.menuitems["exp_newsrc"].connect("activate",self.export_newsrc)
        self.menuitems["imp_newsrc"].connect("activate",self.import_newsrc)
        self.menuitems["find"].connect("activate",self.find_article)
        self.menuitems["global"].connect("activate",self.global_search)
        self.menuitems["search"].connect("activate",self.search_in_the_article)
        self.menuitems["rules"].connect("activate",self.open_rules_win)
        self.menuitems["show_read_articles"].connect("activate",self.view_group,None,None)
        self.menuitems["show_unread_articles"].connect("activate",self.view_group,None,None)
        self.menuitems["show_kept_articles"].connect("activate",self.view_group,None,None)
        self.menuitems["show_unkept_articles"].connect("activate",self.view_group,None,None)
        self.menuitems["show_watched_articles"].connect("activate",self.view_group,None,None)
        self.menuitems["show_ignored_articles"].connect("activate",self.view_group,None,None)
        self.menuitems["show_unwatchedignored_articles"].connect("activate",self.view_group,None,None)
        self.menuitems["show_score_neg_articles"].connect("activate",self.view_group,None,None)
        self.menuitems["show_score_pos_articles"].connect("activate",self.view_group,None,None)
        self.menuitems["supersede"].connect("activate",self.supersede_cancel_message,"Supersede")
        self.menuitems["cancel"].connect("activate",self.supersede_cancel_message,"Cancel")
        self.menuitems["mark_download"].connect("activate",self.context_mark_download)
        self.menuitems["mark_read"].connect("activate",self.context_mark_read)
        self.menuitems["mark_unread"].connect("activate",self.context_mark_unread)
        self.menuitems["keep"].connect("activate",self.context_keep)
        self.menuitems["watch"].connect("activate",self.context_watch)
        self.menuitems["ignore"].connect("activate",self.context_ignore)
        self.menuitems["raise_score"].connect("activate",self.context_modify_score,0)
        self.menuitems["lower_score"].connect("activate",self.context_modify_score,1)
        self.menuitems["set_score"].connect("activate",self.context_modify_score,2)
        #buttons_toolbar signals
        self.buttons=self.toolbar.get_buttons()
        self.buttons["groups"].connect("clicked",self.open_groups_win)
        self.buttons["conf"].connect("clicked",self.open_configure_win)
        self.buttons["next"].connect("clicked",self.view_next_article)
        self.buttons["next_unread"].connect("clicked",self.view_next_unread_article)
        self.buttons["previous"].connect("clicked",self.view_previous_article)
        self.buttons["post"].connect("clicked",self.open_edit_win)
        self.buttons["followup"].connect("clicked",self.open_edit_win)
        self.buttons["reply"].connect("clicked",self.open_edit_mail_win)
        self.buttons["gethdrs"].connect("clicked",self.get_new_headers)
        self.buttons["getbodies"].connect("clicked",self.get_bodies)
        self.buttons["raw"].connect("clicked",self.view_raw_article)
        self.buttons["expand"].connect("clicked",self.expand_all_threads)
        self.buttons["collapse"].connect("clicked",self.collapse_all_threads)
        self.buttons["mark"].connect("clicked",self.mark_group)
        self.buttons["markall"].connect("clicked",self.mark_all_groups)
        self.buttons["rot13"].connect("clicked",self.apply_rot13)
        self.buttons["score"].connect("clicked",self.open_rules_win)

        #groups_pane signals
        self.groups_pane.groups_list.connect("row_activated",self.view_group,"doubleclick")
        self.groups_pane.groups_list.get_selection().connect("changed",self.view_group,"oneclick")

        #threads_pane signals
        self.threads_pane.threads_tree.connect("button_release_event",self.threads_context_menu)
        self.threads_pane.threads_tree.connect("row_activated",self.view_article,"doubleclick")
        self.threads_pane.threads_tree.get_selection().connect("changed",self.view_article, "oneclick")

    def build_panes(self):
        self.groups_pane=Groups_Pane("Newsgroups","UnRead",gtk.TRUE,self.configs)
        self.threads_pane=Threads_Pane(self.configs)
        if self.configs["show_headers"]=="True":
            show_headers=True
        else:
            show_headers=False
        self.article_pane=Article_Pane(show_headers,self.configs)

    def set_sizes(self):
        try:
            f=open(userdir + sep + "dats/sizes.dat","rb")
        except IOError:
            vpaned_pos=120
            hpaned_pos=200
            self.window.maximize()
        else:
            sizes=cPickle.load(f)
            f.close()
            vpaned_pos=sizes.get("vpaned_pos",120)
            hpaned_pos=sizes.get("hpaned_pos",200)
            mainwin_width=sizes.get("mainwin_width",640)
            mainwin_height=sizes.get("mainwin_height",480)
            mainwin_pos_x=sizes.get("mainwin_pos_x",0)
            mainwin_pos_y=sizes.get("mainwin_pos_y",0)
            self.window.resize(int(mainwin_width),int(mainwin_height))
            self.window.move(int(mainwin_pos_x),int(mainwin_pos_y))
        self.hpaned.set_position(int(hpaned_pos))
        self.vpaned.set_position(int(vpaned_pos))


    def build_layout_1(self):
        #Vpaned
        self.vpaned=gtk.VPaned()
        self.vbox1.pack_start(self.vpaned,gtk.TRUE,gtk.TRUE,0)
        self.vpaned.show()

        #HPaned
        self.hpaned=gtk.HPaned()
        self.vpaned.add(self.hpaned)
        self.hpaned.show()

        #Groups Pane
        groups_parent=self.groups_pane.get_widget().get_parent()
        if groups_parent!=None:
            groups_parent.remove(self.groups_pane.get_widget())
        self.hpaned.add(self.groups_pane.get_widget())
        self.groups_pane.show()

        #Threads Pane
        threads_parent=self.threads_pane.get_widget().get_parent()
        if threads_parent!=None:
            threads_parent.remove(self.threads_pane.get_widget())
        self.hpaned.add(self.threads_pane.get_widget())
        self.threads_pane.show()

        #Article Pane
        article_parent=self.article_pane.get_widget().get_parent()
        if article_parent!=None:
            article_parent.remove(self.article_pane.get_widget())
        self.vpaned.add(self.article_pane.get_widget())
        self.article_pane.show()

        if article_parent!=None and threads_parent!=None and groups_parent!=None:
            article_parent.get_parent().remove(article_parent)
            if groups_parent!=article_parent:
                groups_parent.get_parent().remove(groups_parent)
            if threads_parent!=article_parent and threads_parent!=groups_parent:
                threads_parent.get_parent().remove(threads_parent)


    def build_layout_2(self):
        #Vpaned
        self.vpaned=gtk.VPaned()
        self.vbox1.pack_start(self.vpaned,gtk.TRUE,gtk.TRUE,0)
        self.vpaned.show()

        #Threads Pane
        threads_parent=self.threads_pane.get_widget().get_parent()
        if threads_parent!=None:
            threads_parent.remove(self.threads_pane.get_widget())
        self.vpaned.add(self.threads_pane.get_widget())
        self.threads_pane.show()

        #HPaned
        self.hpaned=gtk.HPaned()
        self.vpaned.add(self.hpaned)
        self.hpaned.show()

        #Groups Pane
        groups_parent=self.groups_pane.get_widget().get_parent()
        if groups_parent!=None:
            groups_parent.remove(self.groups_pane.get_widget())
        self.hpaned.add(self.groups_pane.get_widget())
        self.groups_pane.show()

        #Article Pane
        article_parent=self.article_pane.get_widget().get_parent()
        if article_parent!=None:
            article_parent.remove(self.article_pane.get_widget())
        self.hpaned.add(self.article_pane.get_widget())
        self.article_pane.show()

        if article_parent!=None and threads_parent!=None and groups_parent!=None:
            article_parent.get_parent().remove(article_parent)
            if groups_parent!=article_parent:
                groups_parent.get_parent().remove(groups_parent)
            if threads_parent!=article_parent and threads_parent!=groups_parent:
                threads_parent.get_parent().remove(threads_parent)

    def build_layout_3(self):
        #HPaned
        self.hpaned=gtk.HPaned()
        self.vbox1.pack_start(self.hpaned,gtk.TRUE,gtk.TRUE,0)
        self.hpaned.show()

        #Groups Pane
        groups_parent=self.groups_pane.get_widget().get_parent()
        if groups_parent!=None:
            groups_parent.remove(self.groups_pane.get_widget())
        self.hpaned.add(self.groups_pane.get_widget())
        self.groups_pane.show()

        #Vpaned
        self.vpaned=gtk.VPaned()
        self.hpaned.add(self.vpaned)
        self.vpaned.show()

        #Threads Pane
        threads_parent=self.threads_pane.get_widget().get_parent()
        if threads_parent!=None:
            threads_parent.remove(self.threads_pane.get_widget())
        self.vpaned.add(self.threads_pane.get_widget())
        self.threads_pane.show()

        #Article Pane
        article_parent=self.article_pane.get_widget().get_parent()
        if article_parent!=None:
            article_parent.remove(self.article_pane.get_widget())
        self.vpaned.add(self.article_pane.get_widget())
        self.article_pane.show()

        if article_parent!=None and threads_parent!=None and groups_parent!=None:
            article_parent.get_parent().remove(article_parent)
            if groups_parent!=article_parent:
                groups_parent.get_parent().remove(groups_parent)
            if threads_parent!=article_parent and threads_parent!=groups_parent:
                threads_parent.get_parent().remove(threads_parent)

    def purge_groups(self):
        purge_read_limit=int(self.configs["purge_read"])
        purge_read_limit_secs=purge_read_limit*24*60*60
        purge_unread_limit=int(self.configs["purge_unread"])
        purge_unread_limit_secs=purge_unread_limit*24*60*60

        time_now=mktime_tz(parsedate_tz(time.ctime()))
        try:
            f=open(userdir + sep + "groups_info/subscribed.dat","rb")
        except IOError:
            pass
        else:
            subscribed=cPickle.load(f)
            f.close()
            watched=set()
            ignored=set()
            for group in subscribed:
                try:
                    f=open(userdir + sep + "groups_info/"+group[0],"rb")
                except IOError:
                    pass
                else:
                    f.close()
                    articles=shelve.open(userdir + sep + "groups_info/"+group[0])
                    to_remove=[]
                    for article in articles.itervalues():
                        if not article.keep:
                            if article.is_read:
                                #this is a read article
                                if time_now-article.secs>purge_read_limit_secs and purge_read_limit_secs>0:
                                    #we have to purge the article
                                    to_remove.append(article)
                            else:
                                #this is an unread article
                                if time_now-article.secs>purge_unread_limit_secs and purge_unread_limit_secs>0:
                                    #we have to purge the article
                                    to_remove.append(article)
                        
                        if article.watch:
                            #refresh the watched/ignored files
                            watched.add(article.msgid)
                        if article.ignore:
                            ignored.add(article.msgid)

                    self.statusbar.push(1,"Purging Group: "+group[0])
                    while gtk.events_pending():
                        gtk.main_iteration(gtk.FALSE)

                    for article in to_remove:
                        #purging watched/ignored
                        articles.pop(article.msgid)
                        if article.msgid in watched:
                            watched.discard(article.msgid)
                        if article.msgid in ignored:
                            ignored.discard(article.msgid)

                    articles.close()
            self.dump_watched(watched)
            self.dump_ignored(ignored)

    def zoom_article(self,obj):
        if self.zoom_article_button.get_active()==gtk.TRUE:
            self.vpaned.set_position(0)
            self.article_pane.show()
            self.threads_pane.hide()
            self.groups_pane.hide()
        else:
            self.threads_pane.show()
            self.groups_pane.show()
            try:
                f=open(userdir + sep + "dats/sizes.dat","rb")
            except IOError:
                vpaned_pos=200
            else:
                sizes=cPickle.load(f)
                f.close()
                vpaned_pos=int(sizes["vpaned_pos"])
            self.vpaned.set_position(vpaned_pos)


    def zoom_groups(self,obj):
        if self.zoom_groups_button.get_active()==gtk.TRUE:
            self.hpaned.set_position(self.window.get_size()[0])
            self.groups_pane.show()
            self.threads_pane.hide()
            self.article_pane.hide()
        else:
            self.threads_pane.show()
            self.article_pane.show()
            try:
                f=open(userdir + sep + "dats/sizes.dat","rb")
            except IOError:
                hpaned_pos=200
            else:
                sizes=cPickle.load(f)
                f.close()
                hpaned_pos=int(sizes["hpaned_pos"])
            self.hpaned.set_position(hpaned_pos)

    def zoom_threads(self,obj):
        if self.zoom_threads_button.get_active()==gtk.TRUE:
            self.vpaned.set_position(self.window.get_size()[1])
            self.threads_pane.show()
            self.article_pane.hide()
            self.groups_pane.hide()
        else:
            self.article_pane.show()
            self.groups_pane.show()
            try:
                f=open(userdir + sep + "dats/sizes.dat","rb")
            except IOError:
                vpaned_pos=200
            else:
                sizes=cPickle.load(f)
                f.close()
                vpaned_pos=int(sizes["vpaned_pos"])
            self.vpaned.set_position(vpaned_pos)

    def gb_show_subscribed(self,obj):
        self.show_subscribed()
        self.gb_show_subscribed_button.hide()

    def get_watched(self):
        try:
            f=open(userdir + sep + "dats/watch.dat","rb")
        except IOError:
            watched=set()
        else:
            watched=cPickle.load(f)
            f.close()
        return watched

    def dump_watched(self,watched):
        f=open(userdir + sep + "dats/watch.dat","wb")
        cPickle.dump(watched,f,1)
        f.close()

    def get_ignored(self):
        try:
            f=open(userdir + sep + "dats/ignore.dat","rb")
        except IOError:
            ignored=set()
        else:
            ignored=cPickle.load(f)
            f.close()
        return ignored

    def dump_ignored(self,ignored):
        f=open(userdir + sep + "dats/ignore.dat","wb")
        cPickle.dump(ignored,f,1)
        f.close()
          
    def __init__(self):
        NNTP.my_xover=my_xover
        Edit_Win.VERSION=VERSION
        Edit_Mail_Win.VERSION=VERSION
	
	ud=UserDir() #create if it does not exist
	ret=ud.Create()
	if ret>0: sys.exit(ret)  

	try: remove(userdir + sep +"server_logs.dat")
        except: pass

        try: remove(userdir + sep +"error_logs.dat")
        except: pass

        try: remove(userdir + sep +"groups_info/global.search.results")
        except: pass

        try: mkdir(userdir + sep +"groups_info")
        except: pass
        
        try: mkdir(userdir + sep +"dats")
        except: pass

        self.s=None
        self.conf=Config_File()
        self.configs=self.conf.get_configs()
        self.groups_lock=False
        self.group_to_thread=""
        self.group_entered=""
        self.subscribed_groups=[]

        #loading score rules
        self.score_rules=Score_Rules()

        #MainMenuBar
        self.window=gtk.Window (gtk.WINDOW_TOPLEVEL)
        self.window.connect("delete_event",self.delete_event)
        self.window.connect("destroy",self.destroy)
        self.window.set_title("XPN 0.4.0")
        self.window.set_icon(gtk.gdk.pixbuf_new_from_file("pixmaps/xpn.xpm"))

        #self.window.maximize()

        #main vbox
        self.vbox1 = gtk.VBox(gtk.FALSE,0)
        self.vbox1.set_border_width(2)
        self.window.add(self.vbox1)
        self.vbox1.show()

        self.menubar=MainMenuBar(self.window)
        self.vbox1.pack_start(self.menubar.get_widget(),gtk.FALSE,gtk.TRUE,0)
        self.menubar.show()

        #Handlebox
        self.toolbar=MainToolBar()
        self.vbox1.pack_start(self.toolbar.get_widget(),gtk.FALSE,gtk.TRUE,0)
        self.toolbar.show()

        self.build_panes()

        layout_methods = {"1":self.build_layout_1,
                          "2":self.build_layout_2,
                          "3":self.build_layout_3
                         }
        layout_builder = layout_methods.get(self.configs["layout"], None)
        if layout_builder: layout_builder()
        else: self.build_layout_1()   # If there is no layout associated to
                                      # self.configs["layout"] then build 1


        #Show subscribed after closing Global Search
        self.gb_show_subscribed_button=gtk.Button("Show Subscribed Groups")
        self.vbox1.pack_start(self.gb_show_subscribed_button,gtk.FALSE,gtk.TRUE,2)
        self.vbox1.reorder_child(self.gb_show_subscribed_button,2)
        self.gb_show_subscribed_button.connect("clicked",self.gb_show_subscribed)

        #hbox_bottom
        hbox_bottom=gtk.HBox()
        self.vbox1.pack_end(hbox_bottom,gtk.FALSE,gtk.FALSE,0)
        hbox_bottom.show()

        #progressbar
        self.progressbar=gtk.ProgressBar()
        hbox_bottom.pack_start(self.progressbar,gtk.FALSE,gtk.FALSE,0)
        self.progressbar.show()

        #Zoom Buttons
        self.zoom_article_button=gtk.ToggleButton("A")
        self.zoom_threads_button=gtk.ToggleButton("H")
        self.zoom_groups_button=gtk.ToggleButton("G")
        self.zoom_article_button.set_relief(gtk.RELIEF_NONE)
        self.zoom_threads_button.set_relief(gtk.RELIEF_NONE)
        self.zoom_groups_button.set_relief(gtk.RELIEF_NONE)
        self.zoom_article_button.connect("clicked",self.zoom_article)
        self.zoom_threads_button.connect("clicked",self.zoom_threads)
        self.zoom_groups_button.connect("clicked",self.zoom_groups)
        zoom_article_tip=gtk.Tooltips()
        zoom_threads_tip=gtk.Tooltips()
        zoom_groups_tip=gtk.Tooltips()
        zoom_article_tip.set_tip(self.zoom_article_button,"Zoom Article Pane")
        zoom_threads_tip.set_tip(self.zoom_threads_button,"Zoom Headers Pane")
        zoom_groups_tip.set_tip(self.zoom_groups_button,"Zoom Groups Pane")
        hbox_bottom.pack_start(self.zoom_article_button,gtk.FALSE,gtk.FALSE,0)
        hbox_bottom.pack_start(self.zoom_threads_button,gtk.FALSE,gtk.FALSE,0)
        hbox_bottom.pack_start(self.zoom_groups_button,gtk.FALSE,gtk.FALSE,0)
        self.zoom_article_button.show()
        self.zoom_threads_button.show()
        self.zoom_groups_button.show()

        separator=gtk.VSeparator()
        separator.show()
        hbox_bottom.pack_start(separator,gtk.FALSE,gtk.FALSE,0)


        #statusbar
        self.statusbar=gtk.Statusbar()
        hbox_bottom.pack_start(self.statusbar,gtk.TRUE,gtk.TRUE,0)
        self.statusbar.show()


        self.window.show()

        self.connect_signals()

        self.raw=False
        if not self.conf.found_config_file:
            dia=Dialog_YES_NO("Missing Config File.\n\nDo you want to Configure XPN now?")
            if dia.resp:
                self.open_configure_win(None)
        self.show_subscribed()

        self.update_checkmenu_options()

        monospace=pango.FontDescription("Monospace 9")
        user=pango.FontDescription(self.configs["font_name"])
        if self.configs["fixed"]=="True":
            self.article_pane.textview.modify_font(monospace)
        else:
            self.article_pane.textview.modify_font(user)
        self.article_pane.textview.set_indent(5)
        self.set_sizes()
        self.mainwin_width=None  #I must use these because if I close the window with the [x]
        self.mainwin_height=None #I loose window sizes
        self.mainwin_pos_x=None
        self.mainwin_pos_y=None

def hook(et,ev,eb):
    import traceback
    ex_list=traceback.format_exception(et,ev,eb)
    message="\n"+"".join(ex_list)
    log=message
    try:
        f=open(userdir + sep + "error_logs.dat","a")
    except IOError:
        pass
    else:
        f.write(":::: "+time.ctime(time.time())+" :::: \n"+message+"\n\n")
        f.close()
    try:
        f=open(userdir + sep + "error_logs.dat","rb")
    except IOError:
        pass
    else:
        log=f.read()
    error_dialog=Error_Dialog(message,log)
    error_dialog.show()


main=MainWin()
reload(sys)
sys.setdefaultencoding("ascii")
sys.excepthook=hook
gtk.main()
