from rfc822 import parsedate,parsedate_tz,mktime_tz
from time import ctime
import email.Header
import quopri
from StringIO import *
from string import find,replace

class Article:

    def my_decode_header(self,header):
        parts=email.Header.decode_header(header)
        header_decoded=""
        for i in range(len(parts)):
            charset=parts[i][1]
            if parts[i][1]!=None:
                charset=parts[i][1]
            else:
                charset=self.fallback_cset
            try:
                header_decoded=header_decoded+" "+unicode(parts[i][0],charset,"replace").strip(" ")
            except LookupError:
                header_decoded=header_decoded+" "+unicode(parts[i][0],self.fallback_cset).strip(" ")
        header_decoded=header_decoded.strip()
        return header_decoded

    def parse_header_list(self,list):
        ref=""
        fup_to=""
        reply_to=""
        ct_enc=""
        cset=""
        user_agent=""
        i=0
        while i in range(len(list)):
            ind=list[i].find(":")
            header_name=list[i][:ind].strip().lower()
            if header_name=="from":
                from_name=self.my_decode_header(list[i][ind+1:].strip())
            elif header_name=="subject":
                subject=list[i][ind+1:].strip()
                j=i+1
                while (list[j][0]==" " or  list[j][0]=="\t"):
                    subject=subject+" "+list[j].strip()
                    j=j+1
                    i=i+1
                subj=self.my_decode_header(subject.strip())
            elif header_name=="date":
                date=list[i][ind+1:].strip()
            elif header_name=="newsgroups":
                newsgroups=list[i][ind+1:].strip()
            elif header_name=="references":
                ref=list[i][ind+1:].strip()
                j=i+1
                while (list[j][0]==" " or list[j][0]=="<" or list[j][0]=="\t"):
                    #the references is splitted among 2 lines or more
                    ref=ref+" "+list[j].strip()
                    j=j+1
                    i=i+1
            elif header_name=="followup-to":
                fup_to=unicode(list[i][ind+1:].strip(),"iso-8859-1","replace").encode("us-ascii","replace")
            elif header_name=="reply-to":
                reply_to=self.my_decode_header(list[i][ind+1:].strip())
            elif header_name=="user-agent":
                user_agent=list[i][ind+1:].strip()
            elif header_name=="content-transfer-encoding":
                ct_enc=list[i][ind+1:].strip()
            elif header_name=="content-type":
                ctype=list[i][ind+1:].strip()
                j=i+1
                while (list[j][0]==" " or  list[j][0]=="\t"):
                    ctype=ctype+" "+list[j].strip()
                    j=j+1
                    i=i+1
                sub_parts=ctype.split(";")
                if len(sub_parts)>1:
                    for part in sub_parts:
                        if len(part)>0:
                            if part.find("charset")==1:
                                cset=part.split("=")
                                cset=cset[1]
                                if cset.startswith("\""):
                                    cset=cset[1:-1]
            i=i+1
        nick,email=self.parse_from(from_name)
        date_parsed=self.parse_date(date)
        self.nick=nick
        self.email=email
        self.from_name=from_name
        self.ngroups=newsgroups
        self.ref=ref
        self.fup_to=fup_to
        self.reply_to=reply_to
        self.user_agent=user_agent
        self.ct_enc=ct_enc
        self.cset=cset
        if self.cset=="":
            self.cset=self.fallback_cset
        self.subj=subj
        self.date=date
        self.date_parsed=date_parsed

    def parse_from(self,from_name):
        left=from_name.rfind("<")
        if left!=-1:
            # It is like "nick" <email> or nick <email>
            if from_name[0]=="\"":
                #It is like "nick" <email>
                nick=from_name[1:left-2].strip()
            else:
                #it is like nick <email>
                nick=from_name[0:left].strip()
            email=from_name[left+1:-1]
        else:
            left=from_name.rfind("(")
            if left!=-1:
                #it is like email (nick)
                right=from_name.rfind(")")
                nick=from_name[left+1:right].strip()
                email=from_name[0:left-1]
            else:
                #ther is only the email
                nick=""
                email=from_name
        if nick=="":
            nick=from_name
        return nick,email.strip()


    def parse_date(self,date):
        #data=parsedate(date)
        secs=mktime_tz(parsedate_tz(date))
        self.secs=secs
        data=parsedate(ctime(secs))
        if data[3]<10:
            ora="0"+repr(data[3])
        else:
            ora=repr(data[3])
        if data[4]<10:
            minuti="0"+repr(data[4])
        else:
            minuti=repr(data[4])
        return repr(data[2])+"/"+repr(data[1])+"/"+repr(data[0])+" "+ora+":"+minuti

    def decode_qp_article(self,article):
        i=0
        j=0
        body=[]
        while i in range(len(article)):
            body.append(article[i])
            if i<len(article)-1:
                if article[i][-1:]=="=":
                    body[j]=body[j][:-1]+article[i+1]
                    i=i+1
            i=i+1
            j=j+1
        out=[]
        for i in range(len(body)):
            line_encoded=StringIO(body[i])
            line_decoded=StringIO("")
            quopri.decode(line_encoded,line_decoded)
            out.append(line_decoded.getvalue())
            out[i]=replace(out[i],"\r","")
            line_encoded.close()
            line_decoded.close()
        return out

    def get_all_headers(self):
        return self.nick,self.email,self.from_name,self.ngroups,self.ref,self.fup_to,self.reply_to,self.ct_enc,self.cset,self.subj,self.date,self.date_parsed,self.user_agent

    def get_headers(self):
        return self.nick,self.from_name,self.ref,self.subj,self.date,self.date_parsed

    def get_body(self):
        return self.body

    def set_body(self,list):
        if self.ct_enc.lower()=="quoted-printable":
            list=self.decode_qp_article(list)
        try:
            list=[unicode(line,self.cset,"replace") for line in list]
        except LookupError:
            list=[unicode(line,self.fallback_cset,"replace") for line in list]
        self.body=list

    def get_raw(self):
        return self.raw

    def set_raw(self,list):
        try:
            list=[unicode(line,self.cset,"replace") for line in list]
        except LookupError:
            list=[unicode(line,self.fallback_cset,"replace") for line in list]
        self.raw=list

    def set_score(self,score):
        self.score=score

    def get_score(self):
        return self.score

    def __init__(self,number,msgid,from_name,ref,subj,date,fallback_charset,original_group):
        self.score=0
        self.number=number
        self.fallback_cset=fallback_charset
        self.msgid=msgid
        self.from_name=self.my_decode_header(from_name)
        self.nick,self.email=self.parse_from(self.from_name)
        self.ref=ref
        self.subj=self.my_decode_header(subj)
        self.date=date
        self.date_parsed=self.parse_date(date)
        self.body=None
        self.raw=None
        self.is_read=False
        self.marked_for_download=False
        self.keep=False
        self.watch=False
        self.ignore=False
        self.original_group=original_group

class Article_To_Send:
    def best_enc(self,text):
        for best_enc in self.ordered_list:
            try:
                text.encode(best_enc,"strict")
            except:
                pass
            else:
                break
        return best_enc

    def my_encode_header(self,header):
        usascii=True
        for j in range(len(header)):
            if ord(header[j])>127:
                #String is not us-ascii
                usascii=False
                break
        if usascii:
            header_encoded=header
        else:
            #let's search the beginning of the word
            i=j
            char=header[i]
            while char!=" " and i>=0:
                i=i-1
                char=header[i]
            best_enc=self.best_enc(header)
            if i==0:
                head_new=header.encode(best_enc,"replace")
                header_encoded=str(email.Header.Header(head_new,best_enc))
            else:
                head_new=header[i+1:].encode(best_enc,"replace")
                header_new_encoded=str(email.Header.Header(head_new,best_enc))
                header_encoded=header[:i+1]+header_new_encoded
        return header_encoded.strip()


    def encode_body(self,body,output_charset):
        body_encoded=""
        for line in body:
            #string=unicode(list[i]+"\n",input_charset)
            line=line+"\n"
            line_encoded=line.encode(output_charset,"replace")
            body_encoded=body_encoded+line_encoded
        return body_encoded

    def get_article(self):
        article="Newsgroups: "+self.newsgroups+"\n"
        article=article+"From: "+self.nick_encoded+" <"+self.email+">\n"
        article=article+"Subject: "+self.subject_encoded+"\n"
        if self.references!="":
            article=article+"References: "+self.references+"\n"
        self.references=""
        article=article+"User-Agent: "+self.user_agent+"\n"
        article=article+"MIME-Version: 1.0\n"
        article=article+"Content-Type: text/plain; charset="+self.output_charset+"\n"
        if self.output_charset.lower()=="us-ascii":
            article=article+"Content-Transfer-Encoding: 7bit\n"
        else:
            article=article+"Content-Transfer-Encoding: 8bit\n"
        for header in self.custom_headers:
            article=article+header+"\n"
        article=article+"\n"
        article=article.encode("utf-8")+self.body_encoded
        return article

    def parse_from(self,from_name):
        left=from_name.rfind("<")
        if left!=-1:
            # It is like "nick" <email> or nick <email>
            if from_name[0]=="\"":
                #It is like "nick" <email>
                nick=from_name[1:left-2].strip()
            else:
                #it is like nick <email>
                nick=from_name[0:left].strip()
            email=from_name[left+1:-1]
        else:
            left=from_name.rfind("(")
            if left!=-1:
                #it is like email (nick)
                right=from_name.rfind(")")
                nick=from_name[left+1:right].strip()
                email=from_name[0:left-1]
            else:
                #ther is only the email
                nick=""
                email=from_name
        return nick.strip(),email.strip()

    def __init__(self,newsgroups,from_name,subject,references,user_agent,output_charset,ordered_list,body,custom_names,custom_values):
        self.newsgroups=newsgroups
        self.ordered_list=ordered_list
        nick,self.email=self.parse_from(from_name)
        self.nick_encoded=self.my_encode_header(nick)
        self.subject_encoded=self.my_encode_header(subject)
        self.references=references
        self.user_agent=user_agent
        self.output_charset=output_charset
        self.body_encoded=self.encode_body(body,output_charset)
        self.custom_headers=[]
        for i in range(len(custom_names)):
            custom_header=custom_names[i].encode("us-ascii","replace")+": "+self.my_encode_header(custom_values[i])
            self.custom_headers.append(custom_header)


class Mail_To_Send:
    def best_enc(self,text):
        for best_enc in self.ordered_list:
            try:
                text.encode(best_enc,"strict")
            except:
                pass
            else:
                break
        return best_enc

    def my_encode_header(self,header):
        usascii=True
        for j in range(len(header)):
            if ord(header[j])>127:
                #String is not us-ascii
                usascii=False
                break
        if usascii:
            header_encoded=header
        else:
            #let's search the beginning of the word
            i=j
            char=header[i]
            while char!=" " and i>=0:
                i=i-1
                char=header[i]
            best_enc=self.best_enc(header)
            if i==0:
                head_new=header.encode(best_enc,"replace")
                header_encoded=str(email.Header.Header(head_new,best_enc))
            else:
                head_new=header[i+1:].encode(best_enc,"replace")
                header_new_encoded=str(email.Header.Header(head_new,best_enc))
                header_encoded=header[:i+1]+header_new_encoded
        return header_encoded.strip()


    def encode_body(self,body,output_charset):
        body_encoded=""
        for line in body:
            #string=unicode(list[i]+"\n",input_charset)
            line=line+"\n"
            line_encoded=line.encode(output_charset,"replace")
            body_encoded=body_encoded+line_encoded
        return body_encoded

    def get_article(self):
        article="To: "+self.to_name+"\n"
        article=article+"From: "+self.nick_encoded+" <"+self.email+">\n"
        article=article+"Subject: "+self.subject_encoded+"\n"
        article=article+"Date: "+self.date+"\n"
        if self.references!="":
            article=article+"References: "+self.references+"\n"
        self.references=""
        article=article+"User-Agent: "+self.user_agent+"\n"
        article=article+"MIME-Version: 1.0\n"
        article=article+"Content-Type: text/plain; charset="+self.output_charset+"\n"
        if self.output_charset.lower()=="us-ascii":
            article=article+"Content-Transfer-Encoding: 7bit\n"
        else:
            article=article+"Content-Transfer-Encoding: 8bit\n"
        article=article+"\n"
        article=article.encode("utf-8")+self.body_encoded
        return article

    def parse_from(self,from_name):
        left=from_name.rfind("<")
        if left!=-1:
            # It is like "nick" <email> or nick <email>
            if from_name[0]=="\"":
                #It is like "nick" <email>
                nick=from_name[1:left-2].strip()
            else:
                #it is like nick <email>
                nick=from_name[0:left].strip()
            email=from_name[left+1:-1]
        else:
            left=from_name.rfind("(")
            if left!=-1:
                #it is like email (nick)
                right=from_name.rfind(")")
                nick=from_name[left+1:right].strip()
                email=from_name[0:left-1]
            else:
                #ther is only the email
                nick=""
                email=from_name
        return nick.strip(),email.strip()

    def __init__(self,to_name,from_name,date,subject,references,user_agent,output_charset,ordered_list,body):
        self.to_name=to_name
        self.date=date
        self.ordered_list=ordered_list
        nick,self.email=self.parse_from(from_name)
        self.nick_encoded=self.my_encode_header(nick)
        self.subject_encoded=self.my_encode_header(subject)
        self.references=references
        self.user_agent=user_agent
        self.output_charset=output_charset
        self.body_encoded=self.encode_body(body,output_charset)
