import gtk
import pango
import webbrowser

class Article_Pane:
    def show(self):
        self.vbox.show()

    def hide(self):
        self.vbox.hide()

    def unparent(self):
        self.vbox.unparent()

    def get_widget(self):
        return self.vbox

    def show_hide_headers(self,button):
        if self.frame_shown:
            self.headers_frame.hide()
            button.remove(self.button_image_hide)
            button.add(self.button_image_show)
            self.button_image_show.show()
            self.button_tooltip.set_tip(button,"Show Headers")
            self.frame_shown=False
        else:
            self.headers_frame.show()
            button.remove(self.button_image_show)
            button.add(self.button_image_hide)
            self.button_image_hide.show()
            self.button_tooltip.set_tip(button,"Hide Headers")
            self.frame_shown=True

    def update_headers_labels(self,from_name,subj,date):
        self.from_value.set_text(from_name)
        self.subj_value.set_text(subj)
        self.date_value.set_text(date)


    def delete_all(self):
        start,end=self.buffer.get_bounds()
        self.buffer.delete(start,end)

    def insert(self,string):
        mark=self.buffer.get_insert()
        iter=self.buffer.get_iter_at_mark(mark)
        self.buffer.insert(iter,string.encode("utf-8"))

    def insert_with_tags(self,string,tag):
        self.buffer.insert_with_tags_by_name(self.buffer.get_end_iter(),string.encode("utf-8"),tag)

    def insert_with_tags_at_iter(self,iter,string,tag):
        self.buffer.insert_with_tags_by_name(iter,string.encode("utf-8"),tag)

    def set_url_color(self,color):
        url_color=gtk.gdk.color_parse(color)
        self.tag_table=self.buffer.get_tag_table()
        if not self.tag_url:
            self.tag_url=gtk.TextTag("url")
            self.tag_table.add(self.tag_url)
            self.tag_url.set_property("underline",pango.UNDERLINE_SINGLE)
        self.tag_url.set_property("foreground-gdk",url_color)

    def set_spoiler_color(self):
        spoiler_color=gtk.gdk.color_parse("#FF0000")
        self.tag_table=self.buffer.get_tag_table()
        if not self.tag_spoiler:
            self.tag_spoiler=gtk.TextTag("spoiler")
            self.tag_table.add(self.tag_spoiler)
        self.tag_spoiler.set_property("foreground-gdk",spoiler_color)
        self.tag_spoiler.set_property("background-gdk",spoiler_color)


    def set_text_color(self,color):
        text_color=gtk.gdk.color_parse(color)
        self.tag_table=self.buffer.get_tag_table()
        if not self.text_tag:
            self.text_tag=gtk.TextTag("text")
            self.tag_table.add(self.text_tag)
        self.text_tag.set_property("foreground-gdk",text_color)
        if not self.text_tag_bold:
            self.text_tag_bold=gtk.TextTag("text_bold")
            self.tag_table.add(self.text_tag_bold)
            self.text_tag_bold.set_property("weight",800)
        self.text_tag_bold.set_property("foreground-gdk",text_color)
        if not self.text_tag_italic:
            self.text_tag_italic=gtk.TextTag("text_italic")
            self.tag_table.add(self.text_tag_italic)
            self.text_tag_italic.set_property("style",pango.STYLE_ITALIC)
        self.text_tag_italic.set_property("foreground-gdk",text_color)
        if not self.text_tag_underline:
            self.text_tag_underline=gtk.TextTag("text_underline")
            self.tag_table.add(self.text_tag_underline)
            self.text_tag_underline.set_property("underline",pango.UNDERLINE_SINGLE)
        self.text_tag_underline.set_property("foreground-gdk",text_color)


    def set_quote_color(self,color,level):
        if level==1:
            quote1_color=gtk.gdk.color_parse(color)
            self.tag_table=self.buffer.get_tag_table()
            if not self.quote1_tag:
                self.quote1_tag=gtk.TextTag("quote1")
                self.tag_table.add(self.quote1_tag)
            self.quote1_tag.set_property("foreground-gdk",quote1_color)
            if not self.quote1_tag_bold:
                self.quote1_tag_bold=gtk.TextTag("quote1_bold")
                self.tag_table.add(self.quote1_tag_bold)
            self.quote1_tag_bold.set_property("weight",1000)
            self.quote1_tag_bold.set_property("foreground-gdk",quote1_color)
            if not self.quote1_tag_italic:
                self.quote1_tag_italic=gtk.TextTag("quote1_italic")
                self.tag_table.add(self.quote1_tag_italic)
            self.quote1_tag_italic.set_property("style",pango.STYLE_ITALIC)
            self.quote1_tag_italic.set_property("foreground-gdk",quote1_color)
            if not self.quote1_tag_underline:
                self.quote1_tag_underline=gtk.TextTag("quote1_underline")
                self.tag_table.add(self.quote1_tag_underline)
            self.quote1_tag_underline.set_property("underline",pango.UNDERLINE_SINGLE)
            self.quote1_tag_underline.set_property("foreground-gdk",quote1_color)

            
        elif level==2: 
            quote2_color=gtk.gdk.color_parse(color)
            self.tag_table=self.buffer.get_tag_table()
            if not self.quote2_tag:
                self.quote2_tag=gtk.TextTag("quote2")
                self.tag_table.add(self.quote2_tag)
            self.quote2_tag.set_property("foreground-gdk",quote2_color)
            if not self.quote2_tag_bold:
                self.quote2_tag_bold=gtk.TextTag("quote2_bold")
                self.tag_table.add(self.quote2_tag_bold)
            self.quote2_tag_bold.set_property("weight",1000)
            self.quote2_tag_bold.set_property("foreground-gdk",quote2_color)
            if not self.quote2_tag_italic:
                self.quote2_tag_italic=gtk.TextTag("quote2_italic")
                self.tag_table.add(self.quote2_tag_italic)
            self.quote2_tag_italic.set_property("style",pango.STYLE_ITALIC)
            self.quote2_tag_italic.set_property("foreground-gdk",quote2_color)
            if not self.quote2_tag_underline:
                self.quote2_tag_underline=gtk.TextTag("quote2_underline")
                self.tag_table.add(self.quote2_tag_underline)
            self.quote2_tag_underline.set_property("underline",pango.UNDERLINE_SINGLE)
            self.quote2_tag_underline.set_property("foreground-gdk",quote2_color)
            
        else:    
            quote3_color=gtk.gdk.color_parse(color)
            self.tag_table=self.buffer.get_tag_table()
            if not self.quote3_tag:
                self.quote3_tag=gtk.TextTag("quote3")
                self.tag_table.add(self.quote3_tag)
            self.quote3_tag.set_property("foreground-gdk",quote3_color)
            if not self.quote3_tag_bold:
                self.quote3_tag_bold=gtk.TextTag("quote3_bold")
                self.tag_table.add(self.quote3_tag_bold)
            self.quote3_tag_bold.set_property("weight",1000)
            self.quote3_tag_bold.set_property("foreground-gdk",quote3_color)
            if not self.quote3_tag_italic:
                self.quote3_tag_italic=gtk.TextTag("quote3_italic")
                self.tag_table.add(self.quote3_tag_italic)
            self.quote3_tag_italic.set_property("style",pango.STYLE_ITALIC)
            self.quote3_tag_italic.set_property("foreground-gdk",quote3_color)
            if not self.quote3_tag_underline:
                self.quote3_tag_underline=gtk.TextTag("quote3_underline")
                self.tag_table.add(self.quote3_tag_underline)
            self.quote3_tag_underline.set_property("underline",pango.UNDERLINE_SINGLE)
            self.quote3_tag_underline.set_property("foreground-gdk",quote3_color)
            

    def set_sign_color(self,color):
        sign_color=gtk.gdk.color_parse(color)
        self.tag_table=self.buffer.get_tag_table()
        if not self.sign_tag:
            self.sign_tag=gtk.TextTag("sign")
            self.tag_table.add(self.sign_tag)
        self.sign_tag.set_property("foreground-gdk",sign_color)
        if not self.sign_tag_bold:
            self.sign_tag_bold=gtk.TextTag("sign_bold")
            self.tag_table.add(self.sign_tag_bold)
            self.sign_tag_bold.set_property("weight",800)
        self.sign_tag_bold.set_property("foreground-gdk",sign_color)
        if not self.sign_tag_italic:
            self.sign_tag_italic=gtk.TextTag("sign_italic")
            self.tag_table.add(self.sign_tag_italic)
            self.sign_tag_italic.set_property("style",pango.STYLE_ITALIC)
        self.sign_tag_italic.set_property("foreground-gdk",sign_color)
        if not self.sign_tag_underline:
            self.sign_tag_underline=gtk.TextTag("sign_underline")
            self.tag_table.add(self.sign_tag_underline)
            self.sign_tag_underline.set_property("underline",pango.UNDERLINE_SINGLE)
        self.sign_tag_underline.set_property("foreground-gdk",sign_color)

    def set_background(self,color):
        color=gtk.gdk.color_parse(color)
        self.textview.modify_base(gtk.STATE_NORMAL,color)

    def get_url_at_coords(self,old_x,old_y):
        x,y=self.textview.window_to_buffer_coords(gtk.TEXT_WINDOW_TEXT,int(old_x),int(old_y))
        iter=self.textview.get_iter_at_location(x,y)
        is_url=iter.has_tag(self.tag_url)
        url=""
        if is_url:
            #let's get the url
            start=iter.copy()
            stop=iter.copy()
            start.backward_to_tag_toggle(self.tag_url)
            stop.forward_to_tag_toggle(self.tag_url)
            url=self.buffer.get_text(start,stop,gtk.TRUE)
        return url

    def mouse_move(self,obj,event):
        cursor_std=gtk.gdk.Cursor(gtk.gdk.XTERM)
        cursor_url=gtk.gdk.Cursor(gtk.gdk.HAND2)
        if event.is_hint:
            x,y,state=event.window.get_pointer()
        else:
            x,y=event.get_coords()
        url=self.get_url_at_coords(x,y)
        if url!="":
            event.window.set_cursor(cursor_url)
        else:
            event.window.set_cursor(cursor_std)

    def button_press(self,obj,event):
        if (event.button==1):
            url=self.get_url_at_coords(event.x,event.y)
            if url!="":
                if self.use_custom_browser:
                    launcher=webbrowser.get("xpn_launcher")
                    launcher.open(url)
                else:
                    webbrowser.open(url)


    def __init__(self,show_headers,configs):
        #VBox
        self.vbox=gtk.VBox()

        #MiddleHeadersFrame
        hbox=gtk.HBox()
        self.vbox.pack_start(hbox,gtk.FALSE,gtk.TRUE,0)

        self.button_show_hide_headers=gtk.Button()
        self.button_show_hide_headers.set_relief(gtk.RELIEF_NONE)
        self.button_show_hide_headers.connect("clicked",self.show_hide_headers)
        hbox.pack_start(self.button_show_hide_headers,gtk.FALSE,gtk.FALSE,0)

        self.button_image_hide=gtk.Image()
        self.button_image_hide.set_from_file("pixmaps/hide_headers.xpm")
        self.button_image_show=gtk.Image()
        self.button_image_show.set_from_file("pixmaps/show_headers.xpm")

        self.headers_frame=gtk.Frame("Info")
        hbox.pack_start(self.headers_frame,gtk.TRUE,gtk.TRUE,0)

        self.button_tooltip=gtk.Tooltips()

        if show_headers==True:
            self.button_show_hide_headers.add(self.button_image_hide)
            self.button_image_hide.show()
            self.button_show_hide_headers.show()
            self.button_tooltip.set_tip(self.button_show_hide_headers,"Hide Headers")
            self.frame_shown=True
            self.headers_frame.show()
        else:
            self.button_show_hide_headers.add(self.button_image_show)
            self.button_image_show.show()
            self.button_show_hide_headers.show()
            self.button_tooltip.set_tip(self.button_show_hide_headers,"Show Headers")
            self.frame_shown=False

        hbox.show()

        headers_table=gtk.Table(3,2,gtk.FALSE)
        headers_table.set_border_width(2)
        self.headers_frame.add(headers_table)
        headers_table.show()

        from_label=gtk.Label("<b>From:</b>")
        from_label.set_use_markup(gtk.TRUE)
        from_label.set_alignment(1,0.5)
        date_label=gtk.Label("<b>Date:</b>")
        date_label.set_use_markup(gtk.TRUE)
        date_label.set_alignment(1,0.5)
        subj_label=gtk.Label("<b>Subject:</b>")
        subj_label.set_use_markup(gtk.TRUE)
        subj_label.set_alignment(1,0.5)
        self.from_value=gtk.Label("")
        self.from_value.set_alignment(0,0.5)
        self.from_value.set_padding(5,1)
        self.date_value=gtk.Label("")
        self.date_value.set_alignment(0,0.5)
        self.date_value.set_padding(5,1)
        self.subj_value=gtk.Label("")
        self.subj_value.set_alignment(0,0.5)
        self.subj_value.set_padding(5,1)

        headers_table.attach(from_label,0,1,0,1,gtk.FILL,gtk.FILL)
        headers_table.attach(date_label,0,1,1,2,gtk.FILL,gtk.FILL)
        headers_table.attach(subj_label,0,1,2,3,gtk.FILL,gtk.FILL)
        headers_table.attach(self.from_value,1,2,0,1)
        headers_table.attach(self.date_value,1,2,1,2)
        headers_table.attach(self.subj_value,1,2,2,3)
        from_label.show()
        date_label.show()
        subj_label.show()
        self.from_value.show()
        self.date_value.show()
        self.subj_value.show()


        #TextScrolledWindow
        self.text_scrolledwin=gtk.ScrolledWindow()
        self.text_scrolledwin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_AUTOMATIC)
        self.text_scrolledwin.set_shadow_type(gtk.SHADOW_OUT)
        self.vbox.pack_start(self.text_scrolledwin,gtk.TRUE,gtk.TRUE,0)
        self.text_scrolledwin.show()

        #TextBuffer
        self.buffer=gtk.TextBuffer()

        #TextView
        self.textview=gtk.TextView(self.buffer)
        self.text_scrolledwin.add(self.textview)
        self.textview.set_wrap_mode(gtk.WRAP_WORD)
        self.textview.set_editable(gtk.FALSE)
        self.textview.set_cursor_visible(gtk.FALSE)
        self.textview.show()
        self.textview.add_events(gtk.gdk.POINTER_MOTION_MASK|gtk.gdk.POINTER_MOTION_HINT_MASK)
        self.textview.connect("motion-notify-event",self.mouse_move)
        self.textview.connect("button-press-event",self.button_press)

        self.quote1_tag=None
        self.quote1_tag_bold=None
        self.quote1_tag_italic=None
        self.quote1_tag_underline=None
        self.quote2_tag=None
        self.quote2_tag_bold=None
        self.quote2_tag_italic=None
        self.quote2_tag_underline=None
        self.quote3_tag=None
        self.quote3_tag_bold=None
        self.quote3_tag_italic=None
        self.quote3_tag_underline=None
        self.sign_tag=None
        self.sign_tag_bold=None
        self.sign_tag_italic=None
        self.sign_tag_underline=None
        self.text_tag=None
        self.text_tag_bold=None
        self.text_tag_italic=None
        self.text_tag_underline=None
        self.tag_url=None
        self.tag_spoiler=None

        color=configs["text_color"]
        self.set_text_color(color)
        color=configs["quote1_color"]
        self.set_quote_color(color,1)
        color=configs["quote2_color"]
        self.set_quote_color(color,2)
        color=configs["quote3_color"]
        self.set_quote_color(color,3)
        color=configs["sign_color"]
        self.set_sign_color(color)
        color=configs["background_color"]
        self.set_background(color)
        color=configs["url_color"]
        self.set_url_color(color)
        self.set_spoiler_color()

        if configs["custom_browser"]=="True":
            self.use_custom_browser=True
            webbrowser.register("xpn_launcher",None,webbrowser.GenericBrowser(configs["browser_launcher"]))
        else:
            self.use_custom_browser=False
