import gtk
import pango
import webbrowser
import os
from xpn_src.Config_File import Config_File
from xpn_src.add_tag import Tags_Window
from xpn_src.Charset_List import encodings_list, encodings_tip, CharsetList

class Config_Win:
    def show(self):
        self.win.show_all()

    def delete_event(self,widget,event,data=None):
        return gtk.FALSE

    def destroy(self,obj):
        self.win.destroy()
    
         
    def open_filesel_dialog(self,obj):
        def dispatch_response(dialog,id):
            if id==gtk.RESPONSE_OK:
                self.update_sign_entry(None)
            if id==gtk.RESPONSE_CANCEL:
                self.file_dialog.destroy()

        def show_hide_hidden(obj):
            self.file_dialog.set_property("show_hidden",obj.get_active())

        self.file_dialog=gtk.FileChooserDialog("Select Signature File",None,gtk.FILE_CHOOSER_ACTION_OPEN,(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
        hidden_checkbutton=gtk.CheckButton("Show Hidden Files")
        self.file_dialog.set_extra_widget(hidden_checkbutton)
        hidden_checkbutton.connect("clicked",show_hide_hidden)
        self.file_dialog.set_local_only(gtk.TRUE)
        self.file_dialog.connect("response",dispatch_response)
        path=self.file_dialog.get_current_folder()
        self.file_dialog.set_current_folder(path)
        self.file_dialog.show()


    def update_sign_entry(self,obj):
        filename=self.file_dialog.get_filename()
        self.sign_entry.set_text(filename)
        self.file_dialog.destroy()

    def gdkcolor_to_hex(self,gdk_color):
        colors=[gdk_color.red,gdk_color.green,gdk_color.blue]
        colors= [("0"+str(hex(col*255/65535))[2:])[-2:].upper() for col in (colors)]
        color = "#"+colors[0]+colors[1]+colors[2]
        return color

    def update_text_color_entry(self,obj):
        color=obj.get_color()
        color=self.gdkcolor_to_hex(color)
        if obj==self.text_color_button:
            self.apply_text_color(self.text_color_entry,obj,color)
        elif obj==self.quote1_color_button:
            self.apply_text_color(self.quote1_color_entry,obj,color)
        elif obj==self.quote2_color_button:
            self.apply_text_color(self.quote2_color_entry,obj,color)
        elif obj==self.quote3_color_button:
            self.apply_text_color(self.quote3_color_entry,obj,color)
        elif obj==self.sign_color_button:
            self.apply_text_color(self.sign_color_entry,obj,color)
        else:
            self.apply_text_color(self.url_color_entry,obj,color)

    def update_back_color_entry(self,obj):
        color=obj.get_color()
        color=self.gdkcolor_to_hex(color)
        self.apply_back_color(obj,color)

    def apply_text_color(self,widget,button,color):
        style=widget.get_style().copy()
        gdk_color=gtk.gdk.color_parse(color)
        style.text[gtk.STATE_NORMAL]=gdk_color
        button.set_color(gdk_color)
        widget.set_style(style)

    def apply_back_color(self,button,color):
        style=self.text_color_entry.get_style().copy()
        gdk_color=gtk.gdk.color_parse(color)
        style.base[gtk.STATE_NORMAL]=gdk_color
        self.text_color_entry.set_style(style)
        style=self.quote1_color_entry.get_style().copy()
        style.base[gtk.STATE_NORMAL]=gdk_color
        self.quote1_color_entry.set_style(style)
        style=self.quote2_color_entry.get_style().copy()
        style.base[gtk.STATE_NORMAL]=gdk_color
        self.quote2_color_entry.set_style(style)
        style=self.quote3_color_entry.get_style().copy()
        style.base[gtk.STATE_NORMAL]=gdk_color
        self.quote3_color_entry.set_style(style)
        style=self.sign_color_entry.get_style().copy()
        style.base[gtk.STATE_NORMAL]=gdk_color
        self.sign_color_entry.set_style(style)
        self.background2_color_label.set_text(color)
        style=self.url_color_entry.get_style().copy()
        style.base[gtk.STATE_NORMAL]=gdk_color
        self.url_color_entry.set_style(style)
        button.set_color(gdk_color)


    def get_text_color(self,widget):
        style=widget.get_style().copy()
        gdk_color=style.text[gtk.STATE_NORMAL]
        color=self.gdkcolor_to_hex(gdk_color)
        return color

    def get_back_color(self,widget):
        style=widget.get_style().copy()
        gdk_color=style.base[gtk.STATE_NORMAL]
        color=self.gdkcolor_to_hex(gdk_color)
        return color


    def update_all(self,configs):
        self.server_entry.set_text(configs["server"])
        self.port_entry.set_text(configs["port"])
        if configs["auth"]=="True":
            self.server_auth_checkbutton.set_active(True)
        else:
            self.server_auth_checkbutton.set_active(False)
            self.server_username.set_sensitive(gtk.FALSE)
            self.server_password.set_sensitive(gtk.FALSE)
            self.username_label.set_sensitive(gtk.FALSE)
            self.password_label.set_sensitive(gtk.FALSE)
        self.server_username.set_text(configs["username"])
        self.server_password.set_text(configs["password"])

        self.mail_server_entry.set_text(configs["smtp_server"])
        self.mail_port_entry.set_text(configs["smtp_port"])
        if configs["smtp_auth"]=="True":
            self.mail_server_auth_checkbutton.set_active(True)
        else:
            self.mail_server_auth_checkbutton.set_active(False)
            self.mail_server_username.set_sensitive(gtk.FALSE)
            self.mail_server_password.set_sensitive(gtk.FALSE)
            self.mail_username_label.set_sensitive(gtk.FALSE)
            self.mail_password_label.set_sensitive(gtk.FALSE)
        self.mail_server_username.set_text(configs["smtp_username"])
        self.mail_server_password.set_text(configs["smtp_password"])

        self.nick_entry.set_text(configs["nick"].encode("utf-8"))
        self.email_entry.set_text(configs["email"].encode("utf-8"))
        self.sign_entry.set_text(configs["sign"].encode("utf-8"))
        self.tags_checkbutton.set_active(configs.get("use_tags","False")=="True")
        self.font_button.set_font_name(configs["font_name"].encode("utf-8"))
        self.apply_back_color(self.background_color_button,configs["background_color"])
        self.text_color_entry.set_text("Text Color")
        self.apply_text_color(self.text_color_entry,self.text_color_button,configs["text_color"])
        self.quote1_color_entry.set_text(">Quoted Text Level 1 Color")
        self.apply_text_color(self.quote1_color_entry,self.quote1_color_button,configs["quote1_color"])
        self.quote2_color_entry.set_text(">Quoted Text Level 2 Color")
        self.apply_text_color(self.quote2_color_entry,self.quote2_color_button,configs["quote2_color"])
        self.quote3_color_entry.set_text(">Quoted Text Level 3 Color")
        self.apply_text_color(self.quote3_color_entry,self.quote3_color_button,configs["quote3_color"])
        self.sign_color_entry.set_text("Sign Color")
        self.apply_text_color(self.sign_color_entry,self.sign_color_button,configs["sign_color"])
        self.url_color_entry.set_text("http://xpn.altervista.org")
        self.apply_text_color(self.url_color_entry,self.url_color_button,configs["url_color"])
        if self.configs["layout"]=="1":
            self.layout1_radiobutton.set_active(True)
        elif configs["layout"]=="2":
            self.layout2_radiobutton.set_active(True)
        elif configs["layout"]=="3":
            self.layout3_radiobutton.set_active(True)
        else:
            self.layout1_radiobutton.set_active(True)
        self.headers_checkbutton.set_active(configs.get("show_headers","False")=="True")
        self.oneclick_checkbutton.set_active(configs.get("oneclick","False")=="True")
        self.one_key_spin.set_value(int(configs["scroll_fraction"]))
        self.fallback_charset_combo.child.set_text(configs["fallback_charset"])
        self.wrap_spinbutton.set_value(int(configs["wrap"]))
        self.attribution_entry.set_text(configs["attribution"].encode("utf-8"))
        self.reply_to_entry.set_text(configs["reply-to"].encode("utf-8"))
        self.organization_entry.set_text(configs["organization"].encode("utf-8"))
        self.mail_copies_to_entry.set_text(configs["mail-copies-to"].encode("utf-8"))
        try:
            f=open("custom_headers.txt","r")
        except IOError:
            pass
        else:
            headers=f.read().decode("utf-8")
            self.custom_headers_buffer.set_text(headers.encode("utf-8"))
            f.close()
        if configs["custom_browser"]=="True":
            self.browser_checkbutton.set_active(gtk.TRUE)
            self.browser_entry.set_text(configs["browser_launcher"].encode("utf-8"))
        else:
            self.browser_checkbutton.set_active(gtk.FALSE)
            self.browser_entry.set_sensitive(gtk.FALSE)

        if configs["external_editor"]=="True":
            self.editor_checkbutton.set_active(gtk.TRUE)
        else:
            self.editor_checkbutton.set_active(gtk.FALSE)
        self.editor_entry.set_text(configs["editor_launcher"].encode("utf-8"))

        self.purge_read_spinbutton.set_value(int(configs["purge_read"]))
        self.purge_unread_spinbutton.set_value(int(configs["purge_unread"]))



        if configs["download_bodies"]=="True":
            self.download_bodies_checkbutton.set_active(gtk.TRUE)
        else:
            self.download_bodies_checkbutton.set_active(gtk.FALSE)





    def save_custom_headers(self):
        bounds=self.custom_headers_buffer.get_bounds()
        if bounds:
            start,stop=bounds
            f=open("custom_headers.txt","w")
            headers=self.custom_headers_buffer.get_text(start,stop,gtk.TRUE).decode("utf-8").split("\n")
            for header in headers:
                if ":" in header:
                    f.write(header.encode("utf-8")+"\n")
            f.close()

    def save_configs(self,object,conf):
        conf.configs["server"]=self.server_entry.get_text()
        conf.configs["port"]=self.port_entry.get_text()
        if self.server_auth_checkbutton.get_active():
            conf.configs["auth"]="True"
            conf.configs["username"]=self.server_username.get_text()
            conf.configs["password"]=self.server_password.get_text()
        else:
            conf.configs["auth"]="False"
            conf.configs["username"]=""
            conf.configs["password"]=""

        conf.configs["smtp_server"]=self.mail_server_entry.get_text().decode("utf-8")
        conf.configs["smtp_port"]=self.mail_port_entry.get_text()
        if self.mail_server_auth_checkbutton.get_active():
            conf.configs["smtp_auth"]="True"
            conf.configs["smtp_username"]=self.mail_server_username.get_text()
            conf.configs["smtp_password"]=self.mail_server_password.get_text()
        else:
            conf.configs["smtp_auth"]="False"
            conf.configs["smtp_username"]=""
            conf.configs["smtp_password"]=""

        conf.configs["nick"]=self.nick_entry.get_text().decode("utf-8")
        conf.configs["email"]=self.email_entry.get_text().decode("utf-8")
        conf.configs["sign"]=self.sign_entry.get_text().decode("utf-8")
        conf.configs["use_tags"]=str(bool(self.tags_checkbutton.get_active()))
        conf.configs["font_name"]=self.font_button.get_font_name()
        conf.configs["text_color"]=self.get_text_color(self.text_color_entry)
        conf.configs["quote1_color"]=self.get_text_color(self.quote1_color_entry)
        conf.configs["quote2_color"]=self.get_text_color(self.quote2_color_entry)
        conf.configs["quote3_color"]=self.get_text_color(self.quote3_color_entry)
        conf.configs["sign_color"]=self.get_text_color(self.sign_color_entry)
        conf.configs["background_color"]=self.get_back_color(self.text_color_entry)
        conf.configs["url_color"]=self.get_text_color(self.url_color_entry)
        if self.layout1_radiobutton.get_active():
            conf.configs["layout"]="1"
        elif self.layout2_radiobutton.get_active():
            conf.configs["layout"]="2"
        else:
            conf.configs["layout"]="3"
        conf.configs["show_headers"]=str(bool(self.headers_checkbutton.get_active()))
        conf.configs["oneclick"]=str(bool(self.oneclick_checkbutton.get_active()))
        conf.configs["scroll_fraction"]=repr(self.one_key_spin.get_value_as_int())
        conf.configs["fallback_charset"]=self.fallback_charset_combo.child.get_text()
        conf.configs["wrap"]=repr(self.wrap_spinbutton.get_value_as_int())
        conf.configs["attribution"]=self.attribution_entry.get_text().decode("utf-8")
        conf.configs["reply-to"]=self.reply_to_entry.get_text().decode("utf-8")
        conf.configs["organization"]=self.organization_entry.get_text().decode("utf-8")
        conf.configs["mail-copies-to"]=self.mail_copies_to_entry.get_text().decode("utf-8")
        self.save_custom_headers()
        if self.browser_checkbutton.get_active() and self.browser_entry.get_text().strip() and \
           self.exists(self.browser_entry.get_text().strip()):
            conf.configs["custom_browser"]="True"
            conf.configs["browser_launcher"]=self.browser_entry.get_text().decode("utf-8")
        else:
            conf.configs["custom_browser"]="False"
            conf.configs["broser_launcher"]=""
        if self.exists(self.editor_entry.get_text().strip()):
            conf.configs["editor_launcher"]=self.editor_entry.get_text().decode("utf-8")
        else:
            conf.configs["editor_launcher"]=""
        conf.configs["external_editor"]=str(bool(self.editor_checkbutton.get_active()))

        conf.configs["purge_read"]=repr(self.purge_read_spinbutton.get_value_as_int())
        conf.configs["purge_unread"]=repr(self.purge_unread_spinbutton.get_value_as_int())
        conf.configs["download_bodies"]=repr(bool(self.download_bodies_checkbutton.get_active()))

        conf.write_configs()
        self.win.destroy()
        self.apply_changes(conf.configs)


    def exists(self, text):
        result=text.rfind("%s")
        ## if the string doesn't exist result=-1, we return 0
        return result+1

    def apply_changes(self,configs):
        #change the font
        self.main_win.article_pane.textview.modify_font(pango.FontDescription(configs["font_name"]))
        #show-hide headers
        shown= self.main_win.article_pane.frame_shown
        to_show = configs["show_headers"]=="True"
        if (not shown and to_show) or (shown and not to_show):
            self.main_win.article_pane.show_hide_headers(self.main_win.article_pane.button_show_hide_headers)
        #update_colors
        self.main_win.article_pane.set_text_color(configs["text_color"])
        self.main_win.article_pane.set_quote_color(configs["quote1_color"],1)
        self.main_win.article_pane.set_quote_color(configs["quote2_color"],2)
        self.main_win.article_pane.set_quote_color(configs["quote3_color"],3)
        self.main_win.article_pane.set_sign_color(configs["sign_color"])
        self.main_win.article_pane.set_background(configs["background_color"])
        self.main_win.article_pane.set_url_color(configs["url_color"])
        self.main_win.groups_pane.set_background(configs["background_color"])
        self.main_win.groups_pane.set_foreground(configs["text_color"])
        self.main_win.threads_pane.set_background(configs["background_color"])
        self.main_win.threads_pane.set_foreground(configs["text_color"])


        #update_layout
        if configs["layout"]=="1":
            self.main_win.build_layout_1()
        elif configs["layout"]=="2":
            self.main_win.build_layout_2()
        else:
            self.main_win.build_layout_3()
        self.main_win.set_sizes()
        #update browser launcher
        if configs["custom_browser"]=="True":
            self.main_win.article_pane.use_custom_browser=True
            webbrowser.register("xpn_launcher",None,webbrowser.GenericBrowser(configs["browser_launcher"]))
        else:
            self.main_win.article_pane.use_custom_browser=False




    def change_auth_status(self,obj):
        if self.server_auth_checkbutton.get_active():
            self.server_username.set_sensitive(gtk.TRUE)
            self.server_password.set_sensitive(gtk.TRUE)
            self.username_label.set_sensitive(gtk.TRUE)
            self.password_label.set_sensitive(gtk.TRUE)
        else:
            self.server_username.set_sensitive(gtk.FALSE)
            self.server_password.set_sensitive(gtk.FALSE)
            self.username_label.set_sensitive(gtk.FALSE)
            self.password_label.set_sensitive(gtk.FALSE)

    def change_mail_auth_status(self,obj):
        if self.mail_server_auth_checkbutton.get_active():
            self.mail_server_username.set_sensitive(gtk.TRUE)
            self.mail_server_password.set_sensitive(gtk.TRUE)
            self.mail_username_label.set_sensitive(gtk.TRUE)
            self.mail_password_label.set_sensitive(gtk.TRUE)
        else:
            self.mail_server_username.set_sensitive(gtk.FALSE)
            self.mail_server_password.set_sensitive(gtk.FALSE)
            self.mail_username_label.set_sensitive(gtk.FALSE)
            self.mail_password_label.set_sensitive(gtk.FALSE)

    def change_browser_status(self,obj):
        if self.browser_checkbutton.get_active():
            self.browser_label.set_sensitive(gtk.TRUE)
            self.browser_entry.set_sensitive(gtk.TRUE)
        else:
            self.browser_label.set_sensitive(gtk.FALSE)
            self.browser_entry.set_sensitive(gtk.FALSE)

    def add_tag_line(self,obj):
        tag_win=Tags_Window()

    def open_charset_list_win(self,obj):
        charset_list_win=CharsetList()

    def __init__(self,conf,main_win):
        self.configs=conf.get_configs()
        self.main_win=main_win
        self.win=gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.win.connect("delete_event",self.delete_event)
        self.win.set_title("XPN Preferences")
        self.win.set_icon(gtk.gdk.pixbuf_new_from_file("pixmaps/conf.xpm"))
        self.win.set_default_size(470,400)
        self.win.set_position(gtk.WIN_POS_CENTER)

        #main_vbox
        self.main_vbox=gtk.VBox()
        self.win.add(self.main_vbox)

        #notebook_page user profile
        self.notebook=gtk.Notebook()
        self.label_user_profile=gtk.Label("<b>User Profile</b>")
        self.label_user_profile.set_use_markup(gtk.TRUE)

        #user_profile_vbox
        self.user_profile_vbox=gtk.VBox()

        #server frame
        self.server_frame=gtk.Frame("NNTP Server")
        self.server_frame.set_border_width(4)
        self.server_table=gtk.Table(4,2,gtk.FALSE)
        self.server_table.set_border_width(4)

        self.server_entry=gtk.Entry()
        self.port_entry=gtk.Entry()
        self.port_entry.set_size_request(30,-1)
        self.server_port_hbox=gtk.HBox()
        self.server_port_hbox.pack_start(self.server_entry,gtk.TRUE,gtk.TRUE)
        self.server_port_hbox.pack_start(self.port_entry,gtk.FALSE,gtk.FALSE,4)
        self.server_username=gtk.Entry()
        self.server_password=gtk.Entry()
        self.server_password.set_visibility(gtk.FALSE)
        self.server_auth_checkbutton=gtk.CheckButton("Server requires authentication")
        self.server_auth_checkbutton.connect("clicked",self.change_auth_status)

        self.server_entry_label=gtk.Label("NNTP Server Address | Port Number")
        self.server_entry_label.set_size_request(230,-1)
        self.username_label=gtk.Label("Username")
        self.username_label.set_size_request(230,-1)
        self.password_label=gtk.Label("Password")
        self.auth_label=gtk.Label("")

        self.server_table.attach(self.server_port_hbox,0,1,0,1,gtk.EXPAND|gtk.FILL,gtk.FILL)
        self.server_table.attach(self.server_auth_checkbutton,0,1,1,2,gtk.EXPAND|gtk.FILL,gtk.FILL)
        self.server_table.attach(self.server_username,0,1,2,3,gtk.EXPAND|gtk.FILL,gtk.FILL)
        self.server_table.attach(self.server_password,0,1,3,4,gtk.EXPAND|gtk.FILL,gtk.FILL)
        self.server_table.attach(self.server_entry_label,1,2,0,1,gtk.EXPAND|gtk.FILL)
        self.server_table.attach(self.auth_label,1,2,1,2,gtk.EXPAND|gtk.FILL)
        self.server_table.attach(self.username_label,1,2,2,3,gtk.EXPAND|gtk.FILL)
        self.server_table.attach(self.password_label,1,2,3,4,gtk.EXPAND|gtk.FILL)
        self.server_frame.add(self.server_table)

        self.user_profile_vbox.pack_start(self.server_frame,gtk.TRUE,gtk.TRUE)

        self.mail_server_frame=gtk.Frame("SMTP Server")
        self.mail_server_frame.set_border_width(4)
        self.mail_server_table=gtk.Table(1,2,gtk.FALSE)
        self.mail_server_table.set_border_width(4)

        self.mail_port_entry=gtk.Entry()
        self.mail_port_entry.set_size_request(30,-1)
        self.mail_server_entry=gtk.Entry()
        self.mail_server_port_hbox=gtk.HBox()
        self.mail_server_port_hbox.pack_start(self.mail_server_entry,gtk.TRUE,gtk.TRUE)
        self.mail_server_port_hbox.pack_start(self.mail_port_entry,gtk.FALSE,gtk.FALSE,4)
        self.mail_server_username=gtk.Entry()
        self.mail_server_password=gtk.Entry()
        self.mail_server_password.set_visibility(gtk.FALSE)
        self.mail_server_auth_checkbutton=gtk.CheckButton("Server requires authentication")
        self.mail_server_auth_checkbutton.connect("clicked",self.change_mail_auth_status)

        self.mail_server_entry_label=gtk.Label("SMTP Server Address | Port Number")
        self.mail_server_entry_label.set_size_request(230,-1)
        self.mail_username_label=gtk.Label("Username")
        self.mail_username_label.set_size_request(230,-1)
        self.mail_password_label=gtk.Label("Password")
        self.mail_auth_label=gtk.Label("")

        self.mail_server_table.attach(self.mail_server_port_hbox,0,1,0,1,gtk.EXPAND|gtk.FILL,gtk.FILL)
        self.mail_server_table.attach(self.mail_server_auth_checkbutton,0,1,1,2,gtk.EXPAND|gtk.FILL,gtk.FILL)
        self.mail_server_table.attach(self.mail_server_username,0,1,2,3,gtk.EXPAND|gtk.FILL,gtk.FILL)
        self.mail_server_table.attach(self.mail_server_password,0,1,3,4,gtk.EXPAND|gtk.FILL,gtk.FILL)
        self.mail_server_table.attach(self.mail_server_entry_label,1,2,0,1,gtk.EXPAND|gtk.FILL)
        self.mail_server_table.attach(self.mail_auth_label,1,2,1,2,gtk.EXPAND|gtk.FILL)
        self.mail_server_table.attach(self.mail_username_label,1,2,2,3,gtk.EXPAND|gtk.FILL)
        self.mail_server_table.attach(self.mail_password_label,1,2,3,4,gtk.EXPAND|gtk.FILL)
        self.mail_server_frame.add(self.mail_server_table)

        self.user_profile_vbox.pack_start(self.mail_server_frame,gtk.TRUE,gtk.TRUE)

        #personal informations frame
        self.personal_frame=gtk.Frame("Personal Informations")
        self.personal_frame.set_border_width(4)

        self.personal_table=gtk.Table(2,2,gtk.FALSE)
        self.personal_table.set_border_width(4)
        self.nick_entry=gtk.Entry()
        self.email_entry=gtk.Entry()
        self.nick_label=gtk.Label("Name or NickName")
        self.nick_label.set_size_request(200,-1)
        self.email_label=gtk.Label("E-Mail address")

        self.personal_table.attach(self.nick_entry,0,1,0,1,gtk.EXPAND|gtk.FILL,gtk.FILL)
        self.personal_table.attach(self.email_entry,0,1,1,2,gtk.EXPAND|gtk.FILL,gtk.FILL)
        self.personal_table.attach(self.nick_label,1,2,0,1,gtk.EXPAND|gtk.FILL)
        self.personal_table.attach(self.email_label,1,2,1,2,gtk.EXPAND|gtk.FILL)

        self.personal_frame.add(self.personal_table)
        self.user_profile_vbox.pack_start(self.personal_frame,gtk.TRUE,gtk.TRUE)
        self.notebook.append_page(self.user_profile_vbox,self.label_user_profile)


        #notebook_page dispay profile
        self.display_profile_vbox=gtk.VBox()
        self.label_display_profile=gtk.Label("<b>Display Profile</b>")
        self.label_display_profile.set_use_markup(gtk.TRUE)

        self.font_frame=gtk.Frame("Font")
        self.font_frame.set_border_width(2)
        self.font_hbox=gtk.HBox()
        self.font_hbox.set_border_width(4)
        self.font_article_label=gtk.Label("Article")
        self.font_hbox.pack_start(self.font_article_label,gtk.FALSE,gtk.FALSE,8)
        self.font_button=gtk.FontButton(None)
        self.font_button.set_use_font(gtk.TRUE)
        self.font_button.set_use_size(gtk.TRUE)
        self.font_hbox.pack_start(self.font_button,gtk.TRUE,gtk.TRUE,0)
        self.font_frame.add(self.font_hbox)

        self.colors_frame=gtk.Frame("Colors")
        self.colors_frame.set_border_width(2)
        self.colors_table=gtk.Table(5,3,gtk.FALSE)
        self.colors_table.set_border_width(4)
        self.text_color_label=gtk.Label("Text")
        self.text_color_label.set_alignment(0,0.5)
        self.quote1_color_label=gtk.Label("Quote Level 1")
        self.quote1_color_label.set_alignment(0,0.5)
        self.quote2_color_label=gtk.Label("Quote Level 2")
        self.quote2_color_label.set_alignment(0,0.5)
        self.quote3_color_label=gtk.Label("Quote Level 3")
        self.quote3_color_label.set_alignment(0,0.5)
        self.sign_color_label=gtk.Label("Sign")
        self.sign_color_label.set_alignment(0,0.5)
        self.background_color_label=gtk.Label("Background")
        self.background_color_label.set_alignment(0,0.5)
        self.background2_color_label=gtk.Label("")
        self.url_color_label=gtk.Label("Url")
        self.url_color_label.set_alignment(0,0.5)
        self.text_color_entry=gtk.Entry()
        self.text_color_entry.set_editable(gtk.FALSE)
        self.quote1_color_entry=gtk.Entry()
        self.quote1_color_entry.set_editable(gtk.FALSE)
        self.quote2_color_entry=gtk.Entry()
        self.quote2_color_entry.set_editable(gtk.FALSE)
        self.quote3_color_entry=gtk.Entry()
        self.quote3_color_entry.set_editable(gtk.FALSE)
        self.sign_color_entry=gtk.Entry()
        self.sign_color_entry.set_editable(gtk.FALSE)
        self.url_color_entry=gtk.Entry()
        self.url_color_entry.set_editable(gtk.FALSE)
        self.text_color_button=gtk.ColorButton(gtk.gdk.Color(0,0,0))
        self.text_color_button.set_size_request(-1,25)
        self.text_color_button.set_title("Select Text Color")
        self.text_color_button.connect("color_set",self.update_text_color_entry)
        self.quote1_color_button=gtk.ColorButton(gtk.gdk.Color(0,0,0))
        self.quote1_color_button.set_size_request(-1,25)
        self.quote1_color_button.set_title("Select Quote Level 1 Color")
        self.quote1_color_button.connect("color_set",self.update_text_color_entry)
        self.quote2_color_button=gtk.ColorButton(gtk.gdk.Color(0,0,0))
        self.quote2_color_button.set_size_request(-1,25)
        self.quote2_color_button.set_title("Select Quote Level 2 Color")
        self.quote2_color_button.connect("color_set",self.update_text_color_entry)
        self.quote3_color_button=gtk.ColorButton(gtk.gdk.Color(0,0,0))
        self.quote3_color_button.set_size_request(-1,25)
        self.quote3_color_button.set_title("Select Quote Level 3 Color")
        self.quote3_color_button.connect("color_set",self.update_text_color_entry)
        self.sign_color_button=gtk.ColorButton(gtk.gdk.Color(0,0,0))
        self.sign_color_button.set_size_request(-1,25)
        self.sign_color_button.set_title("Select Sign Color")
        self.sign_color_button.connect("color_set",self.update_text_color_entry)
        self.background_color_button=gtk.ColorButton(gtk.gdk.Color(0,0,0))
        self.background_color_button.set_size_request(-1,25)
        self.background_color_button.set_title("Select Background Color")
        self.background_color_button.connect("color_set",self.update_back_color_entry)
        self.url_color_button=gtk.ColorButton(gtk.gdk.Color(0,0,0))
        self.url_color_button.set_size_request(-1,25)
        self.url_color_button.set_title("Select Url Color")
        self.url_color_button.connect("color_set",self.update_text_color_entry)
        self.colors_table.attach(self.text_color_label,0,1,0,1,gtk.FILL,gtk.FILL,2)
        self.colors_table.attach(self.quote1_color_label,0,1,1,2,gtk.FILL,gtk.FILL,2)
        self.colors_table.attach(self.quote2_color_label,0,1,2,3,gtk.FILL,gtk.FILL,2)
        self.colors_table.attach(self.quote3_color_label,0,1,3,4,gtk.FILL,gtk.FILL,2)
        self.colors_table.attach(self.sign_color_label,0,1,4,5,gtk.FILL,gtk.FILL,2)
        self.colors_table.attach(self.url_color_label,0,1,5,6,gtk.FILL,gtk.FILL,2)
        self.colors_table.attach(self.background_color_label,0,1,6,7,gtk.FILL,gtk.FILL,2)
        self.colors_table.attach(self.text_color_entry,1,2,0,1,gtk.EXPAND|gtk.FILL,gtk.SHRINK,2)
        self.colors_table.attach(self.quote1_color_entry,1,2,1,2,gtk.EXPAND|gtk.FILL,gtk.SHRINK,2)
        self.colors_table.attach(self.quote2_color_entry,1,2,2,3,gtk.EXPAND|gtk.FILL,gtk.SHRINK,2)
        self.colors_table.attach(self.quote3_color_entry,1,2,3,4,gtk.EXPAND|gtk.FILL,gtk.SHRINK,2)
        self.colors_table.attach(self.sign_color_entry,1,2,4,5,gtk.EXPAND|gtk.FILL,gtk.SHRINK,2)
        self.colors_table.attach(self.url_color_entry,1,2,5,6,gtk.EXPAND|gtk.FILL,gtk.SHRINK,2)
        self.colors_table.attach(self.background2_color_label,1,2,6,7,gtk.EXPAND|gtk.FILL,gtk.SHRINK,2)
        self.colors_table.attach(self.text_color_button,2,3,0,1,gtk.EXPAND|gtk.FILL,gtk.SHRINK)
        self.colors_table.attach(self.quote1_color_button,2,3,1,2,gtk.EXPAND|gtk.FILL,gtk.SHRINK)
        self.colors_table.attach(self.quote2_color_button,2,3,2,3,gtk.EXPAND|gtk.FILL,gtk.SHRINK)
        self.colors_table.attach(self.quote3_color_button,2,3,3,4,gtk.EXPAND|gtk.FILL,gtk.SHRINK)
        self.colors_table.attach(self.sign_color_button,2,3,4,5,gtk.EXPAND|gtk.FILL,gtk.SHRINK)
        self.colors_table.attach(self.url_color_button,2,3,5,6,gtk.EXPAND|gtk.FILL,gtk.SHRINK)
        self.colors_table.attach(self.background_color_button,2,3,6,7,gtk.EXPAND|gtk.FILL,gtk.SHRINK)
        self.colors_frame.add(self.colors_table)

        self.layout_frame=gtk.Frame("Layout")
        self.layout_frame.set_border_width(2)
        self.layout_hbox=gtk.HBox()
        self.layouts_vbox=gtk.VBox()
        self.layout_vbox=gtk.VBox()
        self.layout1_radiobutton=gtk.RadioButton()
        self.layout1_image=gtk.Image()
        self.layout1_image.set_from_file("pixmaps/layout1.xpm")
        self.layout1_radiobutton.add(self.layout1_image)
        self.layout2_radiobutton=gtk.RadioButton(self.layout1_radiobutton)

        self.layout2_image=gtk.Image()
        self.layout2_image.set_from_file("pixmaps/layout2.xpm")
        self.layout2_radiobutton.add(self.layout2_image)
        self.layout3_radiobutton=gtk.RadioButton(self.layout2_radiobutton)

        self.layout3_image=gtk.Image()
        self.layout3_image.set_from_file("pixmaps/layout3.xpm")
        self.layout3_radiobutton.add(self.layout3_image)
        self.layouts_vbox.pack_start(self.layout1_radiobutton,gtk.TRUE,gtk.TRUE,2)
        self.layouts_vbox.pack_start(self.layout2_radiobutton,gtk.TRUE,gtk.TRUE,2)
        self.layouts_vbox.pack_start(self.layout3_radiobutton,gtk.TRUE,gtk.TRUE,2)
        self.layout_hbox.pack_start(self.layouts_vbox,gtk.TRUE,gtk.FALSE,2)
        self.layout_label=gtk.Label("1:  Groups Pane\n\n2:  Headers Pane\n\n3:  Article Pane")
        self.layout_hbox.pack_start(self.layout_label,gtk.TRUE,gtk.FALSE,4)
        self.layout_vbox.pack_start(self.layout_hbox,gtk.TRUE,gtk.TRUE,4)
        self.layout_frame.add(self.layout_vbox)


        self.display_profile_vbox.pack_start(self.font_frame,gtk.FALSE,gtk.TRUE)
        self.display_profile_vbox.pack_start(self.colors_frame,gtk.TRUE,gtk.TRUE)
        self.display_profile_vbox.pack_start(self.layout_frame,gtk.TRUE,gtk.TRUE)

        self.notebook.append_page(self.display_profile_vbox,self.label_display_profile)


        #notebook_page posting profile
        self.label_posting_profile=gtk.Label("<b>Posting Profile</b>")
        self.label_posting_profile.set_use_markup(gtk.TRUE)
        self.posting_profile_vbox=gtk.VBox()

        self.compose_frame=gtk.Frame("Compose")
        self.compose_frame.set_border_width(4)
        self.compose_table=gtk.Table(2,2,gtk.FALSE)
        self.compose_table.set_border_width(4)

        self.wrap_label=gtk.Label("  Wrap column")
        self.wrap_spinbutton=gtk.SpinButton(gtk.Adjustment(value=72,lower=0,upper=79,step_incr=1,page_incr=10))
        self.wrap_fake_hbox=gtk.HBox()
        self.wrap_fake_label=gtk.Label("")
        self.wrap_fake_hbox.pack_start(self.wrap_spinbutton,gtk.FALSE,gtk.FALSE)
        self.wrap_fake_hbox.pack_start(self.wrap_label,gtk.FALSE,gtk.TRUE)
        self.attribution_label=gtk.Label("Attribution line")
        self.attribution_entry=gtk.Entry()
        self.attribution_label.set_size_request(230,-1)
        self.attribution_tooltip=gtk.Tooltips()
        self.attribution_tooltip.set_tip(self.attribution_entry,"%s = Subject\n%g = Newsgroups\n%f = From\n%n = Nick\n%e = Email\n%d = Date")

        self.compose_table.attach(self.wrap_fake_hbox,0,1,0,1,gtk.EXPAND|gtk.FILL,gtk.SHRINK)
        self.compose_table.attach(self.attribution_entry,0,1,1,2,gtk.EXPAND|gtk.FILL,gtk.SHRINK)
        self.compose_table.attach(self.wrap_fake_label,1,2,0,1,gtk.SHRINK,gtk.EXPAND|gtk.FILL)
        self.compose_table.attach(self.attribution_label,1,2,1,2,gtk.FILL,gtk.EXPAND|gtk.FILL,4)

        self.compose_frame.add(self.compose_table)

        self.posting_profile_vbox.pack_start(self.compose_frame,gtk.TRUE,gtk.TRUE,2)

        self.sign_frame=gtk.Frame("Signature")
        self.sign_frame.set_border_width(4)
        self.sign_table=gtk.Table(2,2,gtk.FALSE)
        self.sign_table.set_border_width(4)

        self.sign_entry=gtk.Entry()

        self.tags_checkbutton=gtk.CheckButton("Use random taglines")
        self.sign_button=gtk.Button("Change Signature Path")
        self.sign_button.set_size_request(230,-1)

        self.sign_button.connect("clicked",self.open_filesel_dialog)
        self.tags_button=gtk.Button("Add a Tagline")
        self.tags_button.connect("clicked",self.add_tag_line)

        self.sign_table.attach(self.sign_entry,0,1,0,1,gtk.EXPAND|gtk.FILL,gtk.FILL|gtk.EXPAND)
        self.sign_table.attach(self.tags_checkbutton,0,1,1,2,gtk.SHRINK|gtk.FILL,gtk.FILL|gtk.EXPAND)
        self.sign_table.attach(self.sign_button,1,2,0,1,gtk.FILL,gtk.SHRINK,4)
        self.sign_table.attach(self.tags_button,1,2,1,2,gtk.FILL,gtk.SHRINK,4)

        self.sign_frame.add(self.sign_table)
        self.posting_profile_vbox.pack_start(self.sign_frame,gtk.TRUE,gtk.TRUE,2)

        #optional headers frame
        self.opt_headers_frame=gtk.Frame("Optional Headers")
        self.opt_headers_frame.set_border_width(4)

        self.opt_headers_table=gtk.Table(3,2,gtk.FALSE)
        self.opt_headers_table.set_border_width(4)

        self.reply_to_entry=gtk.Entry()
        self.organization_entry=gtk.Entry()
        self.mail_copies_to_entry=gtk.Entry()

        self.reply_to_label=gtk.Label("Reply-To")
        self.reply_to_label.set_size_request(110,-1)
        self.organization_label=gtk.Label("Organization")
        self.mail_copies_to_label=gtk.Label("Mail-Copies-To")

        self.opt_headers_table.attach(self.reply_to_entry,0,1,0,1,gtk.EXPAND|gtk.FILL,gtk.FILL)
        self.opt_headers_table.attach(self.organization_entry,0,1,1,2,gtk.EXPAND|gtk.FILL,gtk.FILL)
        self.opt_headers_table.attach(self.mail_copies_to_entry,0,1,2,3,gtk.EXPAND|gtk.FILL,gtk.FILL)
        self.opt_headers_table.attach(self.reply_to_label,1,2,0,1,gtk.EXPAND|gtk.FILL)
        self.opt_headers_table.attach(self.organization_label,1,2,1,2,gtk.EXPAND|gtk.FILL)
        self.opt_headers_table.attach(self.mail_copies_to_label,1,2,2,3,gtk.EXPAND|gtk.FILL)

        self.opt_headers_frame.add(self.opt_headers_table)
        self.posting_profile_vbox.pack_start(self.opt_headers_frame,gtk.TRUE,gtk.TRUE)

        self.custom_headers_frame=gtk.Frame("Custom Headers (X-Headers)")
        self.custom_headers_frame.set_border_width(4)
        self.custom_headers_scrolledwin=gtk.ScrolledWindow()
        self.custom_headers_scrolledwin.set_border_width(4)
        self.custom_headers_scrolledwin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_AUTOMATIC)
        self.custom_headers_scrolledwin.set_shadow_type(gtk.SHADOW_OUT)
        self.custom_headers_buffer=gtk.TextBuffer()
        self.custom_headers_textview=gtk.TextView(self.custom_headers_buffer)

        self.custom_headers_scrolledwin.add(self.custom_headers_textview)
        self.custom_headers_frame.add(self.custom_headers_scrolledwin)
        self.posting_profile_vbox.pack_start(self.custom_headers_frame,gtk.TRUE,gtk.TRUE)

        self.notebook.append_page(self.posting_profile_vbox,self.label_posting_profile)

        #groups properties
        self.label_groups=gtk.Label("<b>Groups Properties</b>")
        self.label_groups.set_use_markup(gtk.TRUE)
        self.groups_vbox=gtk.VBox()
        self.purge_frame=gtk.Frame("Purge Options")
        self.purge_frame.set_border_width(4)
        self.purge_vbox=gtk.VBox()
        self.purge_vbox.set_border_width(4)
        self.purge_read_hbox=gtk.HBox()
        self.purge_read_hbox.set_border_width(4)
        self.purge_read_spinbutton=gtk.SpinButton(gtk.Adjustment(value=5,lower=0,upper=1000,step_incr=1,page_incr=10))
        self.purge_read_tooltip=gtk.Tooltips()
        self.purge_read_tooltip.set_tip(self.purge_read_spinbutton,"""Number of days. "0" means never purge read articles""")
        self.purge_read_label=gtk.Label("Purge read articles")
        self.purge_unread_hbox=gtk.HBox()
        self.purge_unread_hbox.set_border_width(4)
        self.purge_unread_spinbutton=gtk.SpinButton(gtk.Adjustment(value=10,lower=0,upper=1000,step_incr=1,page_incr=10))
        self.purge_unread_tooltip=gtk.Tooltips()
        self.purge_unread_tooltip.set_tip(self.purge_unread_spinbutton,"""Number of days. "0" means never purge unread articles""")
        self.purge_unread_label=gtk.Label("Purge unread articles")


        self.purge_read_hbox.pack_start(self.purge_read_spinbutton,gtk.FALSE,gtk.TRUE)
        self.purge_read_hbox.pack_start(self.purge_read_label,gtk.FALSE,gtk.FALSE,4)
        self.purge_unread_hbox.pack_start(self.purge_unread_spinbutton,gtk.FALSE,gtk.TRUE)
        self.purge_unread_hbox.pack_start(self.purge_unread_label,gtk.FALSE,gtk.FALSE,4)
        self.purge_vbox.pack_start(self.purge_read_hbox,gtk.FALSE,gtk.TRUE)
        self.purge_vbox.pack_start(self.purge_unread_hbox,gtk.FALSE,gtk.TRUE)
        self.purge_frame.add(self.purge_vbox)

        self.groups_vbox.pack_start(self.purge_frame,gtk.TRUE,gtk.TRUE,2)

        self.bodies_frame=gtk.Frame("Bodies")
        self.bodies_frame.set_border_width(4)
        self.download_bodies_checkbutton=gtk.CheckButton("Retrieve Bodies for all new articles")
        self.download_bodies_checkbutton.set_border_width(4)
        self.bodies_frame.add(self.download_bodies_checkbutton)
        self.groups_vbox.pack_start(self.bodies_frame,gtk.TRUE,gtk.TRUE,2)

        self.charset_frame=gtk.Frame("Charsets")
        self.charset_frame.set_border_width(4)
        self.fallback_charset_hbox=gtk.HBox()
        self.fallback_charset_hbox.set_border_width(4)
        self.fallback_charset_label=gtk.Label("Fallback Charset (Reading)")
        self.fallback_charset_combo=gtk.combo_box_entry_new_text()
        self.fallback_charset_combo.set_size_request(130,-1)
        for encoding in encodings_list:
            self.fallback_charset_combo.append_text(encoding)
        self.fallback_charset_tooltip=gtk.Tooltips()
        self.fallback_charset_tooltip.set_tip(self.fallback_charset_combo.child,encodings_tip)

        self.fallback_charset_combo.child.set_editable(False)
        self.fallback_charset_hbox.pack_start(self.fallback_charset_combo,gtk.FALSE,gtk.TRUE,2)
        self.fallback_charset_hbox.pack_start(self.fallback_charset_label,gtk.FALSE,gtk.TRUE,2)

        self.charset_list_hbox=gtk.HBox()
        self.charset_list_hbox.set_border_width(4)
        self.charset_list_button=gtk.Button("Charsets List")
        self.charset_list_button.connect("clicked",self.open_charset_list_win)
        self.charset_list_button.set_size_request(130,-1)
        self.charset_list_tooltip=gtk.Tooltips()
        self.charset_list_tooltip.set_tip(self.charset_list_button,"XPN will try to use the charsets in this order")
        self.charset_list_label=gtk.Label("Ordered List (Writing)")
        self.charset_list_hbox.pack_start(self.charset_list_button,gtk.FALSE,gtk.TRUE,2)
        self.charset_list_hbox.pack_start(self.charset_list_label,gtk.FALSE,gtk.TRUE,2)
        self.charset_vbox=gtk.VBox()
        self.charset_vbox.pack_start(self.fallback_charset_hbox,gtk.FALSE,gtk.TRUE,2)
        self.charset_vbox.pack_start(self.charset_list_hbox,gtk.FALSE,gtk.TRUE,2)
        self.charset_frame.add(self.charset_vbox)


        self.groups_vbox.pack_start(self.charset_frame,gtk.FALSE,gtk.TRUE,2)
        self.notebook.append_page(self.groups_vbox,self.label_groups)

        #notebook_page miscellaneous profile
        self.label_miscellaneous=gtk.Label("<b>Miscellaneous</b>")
        self.label_miscellaneous.set_use_markup(gtk.TRUE)
        self.miscellaneous_vbox=gtk.VBox()
        self.browser_vbox=gtk.VBox()
        self.browser_vbox.set_border_width(4)
        self.browser_frame=gtk.Frame("Web Browser")
        self.browser_frame.set_border_width(4)
        self.browser_checkbutton=gtk.CheckButton("Use Custom Web Browser Launcher")
        self.browser_checkbutton.connect("clicked",self.change_browser_status)
        self.browser_vbox.pack_start(self.browser_checkbutton,gtk.FALSE,gtk.FALSE,2)
        self.browser_hbox=gtk.HBox()
        self.browser_entry=gtk.Entry()
        self.browser_tooltip=gtk.Tooltips()
        self.browser_tooltip.set_tip(self.browser_entry,"Type your custom command, %s represents the url.\nExamples:\n\nmozilla %s &\nxterm -e links %s")

        self.browser_label=gtk.Label("Web Browser Launcher")
        self.browser_hbox.add(self.browser_entry)
        self.browser_hbox.add(self.browser_label)
        self.browser_vbox.pack_start(self.browser_hbox,gtk.FALSE,gtk.FALSE,2)
        self.browser_frame.add(self.browser_vbox)

        self.editor_vbox=gtk.VBox()
        self.editor_vbox.set_border_width(4)
        self.editor_frame=gtk.Frame("External Editor")
        self.editor_frame.set_border_width(4)
        self.editor_checkbutton=gtk.CheckButton("Always Use External Editor")
        self.editor_vbox.pack_start(self.editor_checkbutton,gtk.FALSE,gtk.FALSE,2)
        self.editor_hbox=gtk.HBox()
        self.editor_entry=gtk.Entry()
        self.editor_tooltip=gtk.Tooltips()
        self.editor_tooltip.set_tip(self.editor_entry,"Type the editor launcher, %s represents the filename.\nExamples:\n\nxterm -e vim %s\ngvim -f %s\nnotepad.exe %s\n\nNOTE: This feature works only with *Nix and Windows systems")

        self.editor_label=gtk.Label("External Editor Command")
        self.editor_hbox.add(self.editor_entry)
        self.editor_hbox.add(self.editor_label)
        self.editor_vbox.pack_start(self.editor_hbox,gtk.FALSE,gtk.FALSE,2)
        self.editor_frame.add(self.editor_vbox)



        self.misc_frame=gtk.Frame("Miscellaneous")
        self.misc_frame.set_border_width(4)
        self.misc_vbox=gtk.VBox()
        self.misc_vbox.set_border_width(4)
        self.headers_checkbutton=gtk.CheckButton("Display Headers in the Article Pane")
        self.oneclick_checkbutton=gtk.CheckButton("One Click Enter Group/Article")
        self.one_key_label=gtk.Label("Scroll Text (% of page)")
        self.one_key_hbox=gtk.HBox()
        self.one_key_spin=gtk.SpinButton(gtk.Adjustment(value=50,lower=1,upper=100,step_incr=1,page_incr=10))
        self.one_key_hbox.pack_start(self.one_key_spin,gtk.FALSE,gtk.TRUE,2)
        self.one_key_hbox.pack_start(self.one_key_label,gtk.FALSE,gtk.FALSE,2)
        self.misc_vbox.pack_start(self.headers_checkbutton,gtk.FALSE,gtk.FALSE,4)
        self.misc_vbox.pack_start(self.oneclick_checkbutton,gtk.FALSE,gtk.FALSE,4)
        self.misc_vbox.pack_start(self.one_key_hbox,gtk.FALSE,gtk.FALSE,4)
        self.misc_frame.add(self.misc_vbox)

        self.miscellaneous_vbox.add(self.browser_frame)
        self.miscellaneous_vbox.add(self.editor_frame)
        self.miscellaneous_vbox.add(self.misc_frame)
        self.notebook.append_page(self.miscellaneous_vbox,self.label_miscellaneous)

        self.main_vbox.pack_start(self.notebook,gtk.TRUE,gtk.TRUE,4)
        self.notebook.set_border_width(5)

        #buttons hbox
        self.buttons_hbox=gtk.HBox()
        self.main_vbox.pack_start(self.buttons_hbox,gtk.TRUE,gtk.TRUE,0)

        #cancel_button
        self.cancel_button=gtk.Button(None,gtk.STOCK_CANCEL)
        self.cancel_button_tooltip=gtk.Tooltips()
        self.cancel_button_tooltip.set_tip(self.cancel_button,"Close window. Discard changes")
        self.cancel_button.connect("clicked",self.destroy)
        self.buttons_hbox.pack_start(self.cancel_button,gtk.TRUE,gtk.TRUE,0)
        #ok_button
        self.ok_button=gtk.Button(None,gtk.STOCK_OK)
        self.ok_button.connect("clicked",self.save_configs,conf)
        self.ok_button_tooltip=gtk.Tooltips()
        self.ok_button_tooltip.set_tip(self.ok_button,"Close window and save settings")
        self.buttons_hbox.pack_start(self.ok_button,gtk.TRUE,gtk.TRUE,0)
        self.ok_button.set_border_width(5)
        self.cancel_button.set_border_width(5)

        self.update_all(self.configs)
