import gtk

class About_Dialog:
    def delete_event(self,widget,event,data=None):
        return gtk.FALSE

    def destroy(self,widget,event):
        self.dialog.destroy()

    def show(self):
        self.dialog.show_all()

    def __init__(self):
        self.dialog=gtk.Dialog("About",None,0,(gtk.STOCK_OK,gtk.RESPONSE_OK))
        self.dialog.set_default_size(250,100)
        self.dialog.connect("delete_event",self.delete_event)
        self.dialog.connect("response",self.destroy)
        self.dialog.set_has_separator(gtk.TRUE)
        self.dialog.set_position(gtk.WIN_POS_CENTER)
        hbox=gtk.HBox()
        self.separator1=gtk.HSeparator()
        self.separator2=gtk.HSeparator()
        self.image=gtk.Image()
        self.image.set_from_file("pixmaps/xpn-logo.png")
        hbox.pack_start(self.separator1,gtk.TRUE,gtk.TRUE,4)
        hbox.pack_start(self.image,gtk.FALSE,gtk.FALSE,0)
        hbox.pack_start(self.separator2,gtk.TRUE,gtk.TRUE,4)
        self.dialog.vbox.pack_start(hbox,gtk.TRUE,gtk.FALSE,0)
        self.buffer=gtk.TextBuffer()
        string="XPN 0.4.0\n\nWritten by Antonio 'Nemesis' Caputo\nxpn@altervista.org\n\nhttp://xpn.altervista.org"
        self.buffer.set_text(string)
        self.view=gtk.TextView(self.buffer)
        self.view.set_wrap_mode(gtk.WRAP_WORD)
        self.view.set_justification(gtk.JUSTIFY_CENTER)
        self.view.set_cursor_visible(gtk.FALSE)
        self.view.set_border_width(5)
        self.view.set_editable(gtk.FALSE)
        self.dialog.vbox.pack_start(self.view,gtk.TRUE,gtk.TRUE,0)

class Dialog_YES_NO:

    def delete_event(self,widget,event,data=None):
        return gtk.FALSE

    def __init__(self,message):
        self.resp=""
        self.dialog=gtk.MessageDialog(None,0,gtk.MESSAGE_QUESTION,gtk.BUTTONS_YES_NO,message)
        self.dialog.connect("delete_event",self.delete_event)
        self.dialog.set_position(gtk.WIN_POS_CENTER)
        resp=self.dialog.run()
        if resp==gtk.RESPONSE_YES:
            self.resp=True
        else:
            self.resp=False
        self.dialog.destroy()

class Dialog_OK:

    def delete_event(self,widget,event,data=None):
        return gtk.FALSE

    def __init__(self,message):
        self.resp=""
        self.dialog=gtk.MessageDialog(None,0,gtk.MESSAGE_INFO,gtk.BUTTONS_OK,message)
        self.dialog.connect("delete_event",self.delete_event)
        self.dialog.set_position(gtk.WIN_POS_CENTER)
        self.dialog.label.set_use_markup(gtk.TRUE)
        self.resp=self.dialog.run()
        self.dialog.destroy()


class Error_Dialog:
    def delete_event(self,widget,event,data=None):
        return gtk.FALSE

    def destroy(self,widget,event):
        self.dialog.destroy()

    def show(self):
        self.dialog.show_all()

    def __init__(self,string,log):
        self.dialog=gtk.Dialog("Error Dialog",None,0,(gtk.STOCK_OK,gtk.RESPONSE_OK))
        self.dialog.set_default_size(350,350)
        self.dialog.set_icon(gtk.gdk.pixbuf_new_from_file("pixmaps/dialog-error.xpm"))

        self.dialog.connect("delete_event",self.delete_event)
        self.dialog.connect("response",self.destroy)
        self.dialog.set_has_separator(gtk.TRUE)
        self.dialog.set_position(gtk.WIN_POS_CENTER)
        self.buffer=gtk.TextBuffer()
        self.buffer.set_text(string)
        self.view=gtk.TextView(self.buffer)
        self.view.set_wrap_mode(gtk.WRAP_WORD)
        self.view.set_cursor_visible(gtk.FALSE)
        self.view.set_border_width(5)
        self.view.set_editable(gtk.FALSE)
        self.scrolled_win=gtk.ScrolledWindow()
        self.scrolled_win.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_AUTOMATIC)
        self.scrolled_win.set_shadow_type(gtk.SHADOW_OUT)
        self.scrolled_win.add(self.view)
        self.buffer_log=gtk.TextBuffer()
        self.buffer_log.set_text(log)
        self.view_log=gtk.TextView(self.buffer_log)
        self.view_log.set_wrap_mode(gtk.WRAP_WORD)
        self.view_log.set_cursor_visible(gtk.FALSE)
        self.view_log.set_border_width(5)
        self.view_log.set_editable(gtk.FALSE)
        self.scrolled_win_log=gtk.ScrolledWindow()
        self.scrolled_win_log.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_AUTOMATIC)
        self.scrolled_win_log.set_shadow_type(gtk.SHADOW_OUT)
        self.scrolled_win_log.add(self.view_log)
        self.notebook=gtk.Notebook()
        self.label_error=gtk.Label("<b>Last Error</b>")
        self.label_error.set_use_markup(gtk.TRUE)
        self.label_error_log=gtk.Label("<b>Errors Log</b>")
        self.label_error_log.set_use_markup(gtk.TRUE)
        self.notebook.append_page(self.scrolled_win,self.label_error)
        self.notebook.append_page(self.scrolled_win_log,self.label_error_log)

        self.dialog.vbox.pack_start(self.notebook,gtk.TRUE,gtk.TRUE,0)
