import gtk
import sys
import time
import cPickle 
from nntplib import *
from os import remove, system, popen2, sep
from random import randint,seed
from locale import getdefaultlocale
from xpn_src.MenuBar import EditMenuBar
from xpn_src.ToolBar import EditToolBar
from xpn_src.Article import Article_To_Send
from xpn_src.Dialogs import Dialog_YES_NO
from xpn_src.Charset_List import encodings_list, guess_list, encodings_tip, load_ordered_list
from xpn_src.UserDir import userdir

class Edit_Win:
    def show(self):
        self.win.show_all()
        #setting the focus
        if self.is_fup:
            self.textview.grab_focus()
        else:
            if self.newsgroups_entry.child.get_text()=="":
                self.newsgroups_entry.grab_focus()
            else:
                self.subj_entry.grab_focus()

    def delete_event(self,widget,event,data=None):
        self.editwin_width,self.editwin_height=self.win.get_size()
        self.save_sizes()
        return gtk.FALSE

    def destroy(self,obj):
        if self.server!=None:
            self.add_log("QUIT",True)
            self.add_log(self.server.quit(),False)
            self.server=None
        self.save_sizes()
        self.win.destroy()

    def guess_encoding(self,text):
        for best_enc in guess_list:
            try:
                unicode(text,best_enc,"strict")
            except:
                pass
            else:
                break
        return best_enc

    def external_editor(self,obj,command):
        body=""
        bounds=self.buffer.get_bounds()
        if bounds:
            start,stop=bounds
            body=self.buffer.get_text(start,stop,gtk.TRUE).decode("utf-8")
            self.buffer.delete(start,stop)
        system_enc=getdefaultlocale()[1]
        body=body.encode(system_enc,"replace")
        filename=(userdir + sep +"temp_article.txt")
        f=open(filename,"w")
        f.write(body)
        f.close()

        command=command.replace("%s",filename)
        result=system(command)
        if result==0:
            f=open(filename,"r")
            body=f.read().split("\n")
            f.close()
            remove(filename)
            best_enc=self.guess_encoding("".join(body))
            body=[unicode(line,best_enc,"strict") for line in body]
            self.show_article(body)
        else:
            self.statusbar.push(1,"Error while opening external editor")

    def update_newsgroups_entry(self,value,subscribed):
        for group in subscribed:
            self.newsgroups_entry.append_text(group)
        newsgroups=value
        self.newsgroups_entry.child.set_text(newsgroups.encode("utf-8"))


    def update_subject_entry(self,subj):
        if subj[0:3].lower()!="re:":
            subj="Re: "+subj
        self.subj_entry.set_text(subj.encode("utf-8"))

    def update_references(self,article_references):
        mom=article_references.split()
        if len(mom)>21:
            #The number of References is greater than 21
            for i in range(0,len(mom)-21):
                mom.remove(mom[1])
            refs=""
            for i in range(len(mom)):
                refs=refs+mom[i]+" "
            article_references=refs.strip()

        refs_len=len(article_references)
        if refs_len>998:
            #References excedes 998 octets
            mom=article_references.split()
            while refs_len>998:
                mom_len=len(mom[1])
                mom.remove(mom[1])
                refs_len=refs_len-mom_len
            refs=""
            for i in range(len(mom)):
                refs=refs+mom[i]+" "
            article_references=refs.strip()
        article_references=article_references.strip()
        return article_references

    def wrap_line(self,string_to_wrap):
        split_string=string_to_wrap.split()
        new_line=""
        lines=[]
        for word in split_string:
            if len(new_line)+len(word)+1<73:
                new_line=new_line+word+" "
            else:
                lines.append(new_line.strip())
                new_line=word+" "
        lines.append(new_line.strip())
        return lines

    def add_attribution_line(self,art,configs):
        attribution_line=configs["attribution"].replace("%n",art.nick).replace("%e",art.email).replace("%f",art.from_name).replace("%d",art.date_parsed).replace("%g",art.ngroups).replace("%s",art.subj)
        line_splitted=self.wrap_line(attribution_line)
        for line in line_splitted:
            self.insert(line+"\n")
        self.insert("\n")
        start,insert_point=self.buffer.get_bounds()
        self.buffer.create_mark("insert_point",insert_point,gtk.TRUE)

    def update_body(self,article,selected_text):
        if selected_text==None:
            body=article.get_body()
        else:
            body=selected_text
        quoted_body=[]
        sign=0
        for line in body:
            if (len(line)==2 and line[0:2]=="--") or (len(line)==3 and line=="-- "):
                sign=1
            if sign!=1:
                if len(line)>0:
                    if line[0]!=">":
                        quoted_body.append("> "+line)
                    else:
                        quoted_body.append(">"+line)
                else:
                    quoted_body.append(">"+line)

        self.show_article(quoted_body)


    def tag_line(self):
        try:
            f=open(userdir + sep +"tags.txt","r")
        except IOError:
            return "tags.txt not found"
        else:
            list=f.readlines()
            f.close()
            seed()
            if len(list)>0:
                tag=list[randint(0,len(list)-1)]
                best_enc=self.guess_encoding(tag)
                tag=unicode(tag,best_enc)
                tag_wrapped=self.wrap_line(tag)
                tag=""
                for line in tag_wrapped:
                    tag=tag+line+"\n"
                return tag
            else:
                return "Taglines not found"

    def add_sign(self,configs):
        sign=[]
        delimiter=False
        if configs["sign"]!="":
            try:
                sign_file=open(userdir + sep + configs["sign"],"r")
            except IOError:
                sign=""
                best_enc="utf-8"
            else:
                sign=sign_file.readlines()
                best_enc=self.guess_encoding("".join(sign))
                sign_file.close()
            self.insert_with_tags("\n-- \n","sign")
            delimiter=True
        use_tags=configs["use_tags"]
        if use_tags=="True":
            tag=self.tag_line()#unicode(self.tag_line(),"iso8859-1","replace")
            if delimiter==False:
                self.insert_with_tags("\n-- \n","sign")
            self.insert_with_tags(tag,"sign")
        for i in range(len(sign)):
            #self.insert_with_tags(unicode(sign[i],"iso8859-1","replace"),"sign")
            self.insert_with_tags(sign[i].decode(best_enc),"sign")


    def show_article(self,article):
        is_sign=False
        is_quote=False
        def quote_depth(line):
            count=0
            for char in line:
                if char==">":
                    count=count+1
                else:
                    break
            if count>3:
                count=3
            return str(count)
        for line in article:
            line=line.replace("\r","") #this is needed for some strange articles
            if len(line)>0:
                if line[0]==">":
                    is_quote=True
                elif (len(line)==2 and line[0:2]=="--") or (len(line)==3 and line[0:3]=="-- "):
                    is_sign=True
                    is_quote=False
                else:
                    is_quote=False
                if is_quote and not is_sign:
                    quote_level=quote_depth(line)
                    self.insert_with_tags(line,"quote"+quote_level)
                elif is_sign:
                    self.insert_with_tags(line,"sign")
                else:
                    self.insert_with_tags(line,"text")
            self.insert("\n")

    def set_text_color(self,color):
        text_color=gtk.gdk.color_parse(color)
        self.tag_table=self.buffer.get_tag_table()
        if not self.text_tag:
            self.text_tag=gtk.TextTag("text")
            self.tag_table.add(self.text_tag)
        self.text_tag.set_property("foreground-gdk",text_color)

    def set_quote_color(self,color,level):
        if level==1:
            quote1_color=gtk.gdk.color_parse(color)
            self.tag_table=self.buffer.get_tag_table()
            if not self.quote1_tag:
                self.quote1_tag=gtk.TextTag("quote1")
                self.tag_table.add(self.quote1_tag)
            self.quote1_tag.set_property("foreground-gdk",quote1_color)

        elif level==2: 
            quote2_color=gtk.gdk.color_parse(color)
            self.tag_table=self.buffer.get_tag_table()
            if not self.quote2_tag:
                self.quote2_tag=gtk.TextTag("quote2")
                self.tag_table.add(self.quote2_tag)
            self.quote2_tag.set_property("foreground-gdk",quote2_color)

        else:    
            quote3_color=gtk.gdk.color_parse(color)
            self.tag_table=self.buffer.get_tag_table()
            if not self.quote3_tag:
                self.quote3_tag=gtk.TextTag("quote3")
                self.tag_table.add(self.quote3_tag)
            self.quote3_tag.set_property("foreground-gdk",quote3_color)

    def set_sign_color(self,color):
        sign_color=gtk.gdk.color_parse(color)
        self.tag_table=self.buffer.get_tag_table()
        if not self.sign_tag:
            self.sign_tag=gtk.TextTag("sign")
            self.tag_table.add(self.sign_tag)
        self.sign_tag.set_property("foreground-gdk",sign_color)


    def set_background(self,configs):
        color=configs["background_color"]
        color=gtk.gdk.color_parse(color)
        self.textview.modify_base(gtk.STATE_NORMAL,color)

    def set_foreground(self,configs):
        color=configs["text_color"]
        color=gtk.gdk.color_parse(color)
        self.textview.modify_text(gtk.STATE_NORMAL,color)

    def insert(self,string):
        mark=self.buffer.get_insert()
        iter=self.buffer.get_iter_at_mark(mark)
        self.buffer.insert(iter,string.encode("utf-8"))

    def insert_with_tags(self,string,tag):
        self.buffer.insert_with_tags_by_name(self.buffer.get_end_iter(),string.encode("utf-8"),tag)

    def rot13(self,text):
        "Rot13 the string passed"
        string_coded = ""
        dic={'a':'n','b':'o','c':'p','d':'q','e':'r','f':'s','g':'t',
             'h':'u','i':'v','j':'w','k':'x','l':'y','m':'z',
             'n':'a','o':'b','p':'c','q':'d','r':'e','s':'f','t':'g',
             'u':'h','v':'i','w':'j','x':'k','y':'l','z':'m',
             'A':'N','B':'O','C':'P','D':'Q','E':'R','F':'S','G':'T',
             'H':'U','I':'V','J':'W','K':'X','L':'Y','M':'Z',
             'N':'A','O':'B','P':'C','Q':'D','R':'E','S':'F','T':'G',
             'U':'H','V':'I','W':'J','X':'K','Y':'L','Z':'M'}
        for c in text:
            char=dic.get(c,c)
            string_coded=string_coded+char
        return string_coded

    def apply_rot13(self,obj):
        bounds=self.buffer.get_selection_bounds()
        if bounds:
            start=bounds[0]
            stop=bounds[1]
            text=self.buffer.get_text(start,stop,gtk.TRUE).decode("utf-8")
            text_rotted=self.rot13(text)
            self.buffer.delete_selection(gtk.FALSE,gtk.FALSE)
            self.insert(text_rotted)

    def add_log(self,message,is_command):
        try:
            f=open(userdir + sep +"server_logs.dat","a")
        except IOError:
            pass
        else:
            if is_command:
                f.write(time.ctime(time.time())+" :: >> "+message+"\n")
            else:
                f.write(time.ctime(time.time())+" :: << "+message+"\n")
            f.close()


    def try_connection(self):
        if self.server==None:
            try:
                if self.server_username!="":
                    self.add_log("AUTHINFO USER "+self.server_username,True)
                    self.add_log("AUTHINFO PASS "+self.server_password,True)
                self.add_log("MODE READER",True)

                self.server=NNTP(self.server_name,port=self.port_number,user=self.server_username,password=self.server_password,readermode=True)
            except:
                message="No connection with server : "+self.server_name+". Configure NNTP Server Address or try later."
                self.add_log(str(sys.exc_info()[0])+","+str(sys.exc_info()[1]),False)
            else:
                message="Connection estabilished with:"+self.server_name
                self.add_log(self.server.getwelcome(),False)
            self.statusbar.push(1,message)

    def get_custom_headers(self,old_article):
        custom_names=[]
        custom_values=[]
        if self.reply_to_entry.get_text()!="":
            custom_names.append("Reply-To")
            custom_values.append(self.reply_to_entry.get_text().decode("utf-8"))
        if self.sender_entry.get_text()!="":
            custom_names.append("Sender")
            custom_values.append(self.sender_entry.get_text().decode("utf-8"))
        if self.organization_entry.get_text()!="":
            custom_names.append("Organization")
            custom_values.append(self.organization_entry.get_text().decode("utf-8"))
        if self.followup_to_entry.get_text()!="":
            custom_names.append("Followup-To")
            custom_values.append(self.followup_to_entry.get_text().decode("utf-8"))
        if self.mail_copies_to_entry.get_text()!="":
            custom_names.append("Mail-Copies-To")
            custom_values.append(self.mail_copies_to_entry.get_text().decode("utf-8"))
        if self.archive_entry.get_text()!="":
            custom_names.append("Archive")
            custom_values.append(self.archive_entry.get_text().decode("utf-8"))
        if self.supersedes_entry.get_text()!="":
            custom_names.append("Supersedes")
            custom_values.append(self.supersedes_entry.get_text().decode("utf-8"))
        if self.approved_entry.get_text()!="":
            custom_names.append("Approved")
            custom_values.append(self.approved_entry.get_text().decode("utf-8"))

        bounds=self.custom_headers_buffer.get_bounds()
        if bounds:
            start,stop=bounds
            headers=self.custom_headers_buffer.get_text(start,stop,gtk.TRUE).decode("utf-8").split("\n")
            for line in headers:
                if ":" in line:
                    div_pos=line.find(":")
                    name=line[:div_pos].strip()
                    value=line[div_pos+1:].strip()
                    if len(name)>2:
                        if name[0:2].lower()=="x-":
                            custom_names.append(name)
                        else:
                            custom_names.append("X-"+name)
                    if old_article!=None:
                        custom_values.append(value.replace("%n",old_article.nick).replace("%e",old_article.email).replace("%f",old_article.from_name).replace("%d",old_article.date_parsed).replace("%g",old_article.ngroups).replace("%s",old_article.subj))
                    else:
                        custom_values.append(value)
        return custom_names,custom_values

    def send_article(self,obj,configs,old_article):
        newsgroups=self.newsgroups_entry.child.get_text().decode("utf-8")
        from_name=self.from_entry.get_text().decode("utf-8")
        subject=self.subj_entry.get_text().decode("utf-8")
        if newsgroups=="" or from_name=="" or subject=="":
            self.statusbar.push(1,"Please fill the \"Newsgroups\", \"From\" and \"Subject\" fields")
        else:
            references=self.references
            user_agent=self.VERSION
            output_charset=self.charset_combo.child.get_text()
            bounds=self.buffer.get_bounds()
            if bounds:
                start,stop=bounds
                text=self.buffer.get_text(start,stop,gtk.TRUE).decode("utf-8")
                body=text.split("\n")
            else:
                body=[]
            custom_names,custom_values=self.get_custom_headers(old_article)
            article_to_send=Article_To_Send(newsgroups,from_name,subject,references,user_agent,output_charset,self.ordered_list,body,custom_names,custom_values)
            article=article_to_send.get_article()
            f=open(userdir + sep +"article","w")
            f.write(article)
            f.close()
            self.try_connection()
            if self.server!=None:
                f=open(userdir + sep +"article","r")
                try:
                    self.add_log("POST",True)
                    self.add_log(self.server.post(f),False)
                except :
                    self.statusbar.push(1,"Server error: "+str(sys.exc_info()[1]))
                    self.add_log(str(sys.exc_info()[0])+","+str(sys.exc_info()[1]),False)
                    self.add_log("QUIT",True)
                    self.add_log(self.server.quit(),False)
                    f.close()
                else:
                    f.close()
                    remove(userdir + sep +"article")
                    self.destroy(None)

    def update_position_and_cset(self,arg1=None,arg2=None,arg4=None):
        #getting the position
        pos_mark=self.buffer.get_insert()
        pos=self.buffer.get_iter_at_mark(pos_mark)
        line_number=pos.get_line()
        chars=pos.get_line_offset()

        #getting the encoding
        bounds=self.buffer.get_bounds()
        start,stop=bounds
        text=self.buffer.get_text(start,stop,gtk.TRUE).decode("utf-8")
        for best_enc in self.ordered_list:
            try:
                text.encode(best_enc,"strict")
            except:
                pass
            else:
                break
        self.statusbar.push(1,"row:"+str(line_number)+", col:"+str(chars)+"            Best Charset: "+best_enc)
        self.charset_combo.child.set_text(best_enc)


    def wrap_on_change(self,obj,configs):
        wrap=int(configs["wrap"])
        pos_mark=self.buffer.get_insert()
        start=self.buffer.get_start_iter()
        #pos is cursor position
        pos=self.buffer.get_iter_at_mark(pos_mark)
        line_number=pos.get_line()
        #start is the beginning of the line edited
        start.set_line(line_number)
        chars_in_line=pos.get_chars_in_line()-1
        if chars_in_line<0:
            chars_in_line=0
        end_line=start.copy()
        #end_line points to the end of the line
        end_line.set_line_offset(chars_in_line)
        line=self.buffer.get_text(start,end_line,gtk.TRUE).decode("utf-8")
        if chars_in_line>wrap and " " in line and line[0]!=">":
            pos_start=start.copy()
            #pos_start is equal to end_line-1
            pos_start.set_line_offset(wrap)
            char=self.buffer.get_text(pos_start,end_line,gtk.TRUE)
            if char!=" ":
                success=0
                i=0
                pos_end=pos_start.copy()
                while success==0:
                    pos_start.set_line_offset(wrap-i-1)
                    pos_end.set_line_offset(wrap-i)
                    char=self.buffer.get_text(pos_start,pos_end,gtk.TRUE)
                    if char==" ":
                        success=1
                        word=self.buffer.get_text(pos_end,end_line,gtk.TRUE)
                        self.buffer.delete(pos_start,end_line)
                        self.buffer.insert(pos_start,"\n"+word)
                    else:
                        i=i+1
            else:
                self.buffer.delete(pos_start,end_line)
                self.buffer.insert(pos_start,"\n")
        self.update_position_and_cset()

    def update_custom_headers(self,configs):
        self.reply_to_entry.set_text(configs["reply-to"].encode("utf-8"))
        self.organization_entry.set_text(configs["organization"].encode("utf-8"))
        self.mail_copies_to_entry.set_text(configs["mail-copies-to"].encode("utf-8"))
        try:
            f=open(userdir + sep +"custom_headers.txt","r")
        except IOError:
            pass
        else:
            headers=f.read().decode("utf-8")
            self.custom_headers_buffer.set_text(headers.encode("utf-8"))
            f.close()

    def insert_spoiler_char(self,obj):
        pos_mark=self.buffer.get_insert()
        pos=self.buffer.get_iter_at_mark(pos_mark)
        self.buffer.insert(pos,chr(12))
    
    def save_sizes(self):
        try:
            f=open(userdir + sep +"dats/sizes.dat","rb")
        except IOError:
            sizes={}        
        else:
            sizes=cPickle.load(f)
        if not self.editwin_width:
            sizes["editwin_width"],sizes["editwin_height"]=self.win.get_size()
        else:
            sizes["editwin_width"]=self.editwin_width
            sizes["editwin_height"]=self.editwin_height
        sizes["editwin_pos_x"],sizes["editwin_pos_y"]=self.win.get_position()
        try:
            f=open(userdir + sep +"dats/sizes.dat","wb")
        except IOError:
            pass
        else:
            cPickle.dump(sizes,f,1)
            f.close()



    def set_sizes(self):
        try:
            f=open(userdir + sep +"dats/sizes.dat","rb")
        except IOError:
            self.win.maximize()
        else:
            sizes=cPickle.load(f)
            f.close()
            editwin_width=sizes.get("editwin_width",None)
            editwin_height=sizes.get("editwin_height",None)
            if editwin_width and editwin_height:
                self.win.resize(int(editwin_width),int(editwin_height))
            else:
                self.win.maximize()
            editwin_pos_x=sizes.get("editwin_pos_x",None)
            editwin_pos_y=sizes.get("editwin_pos_y",None)
            if editwin_pos_x and editwin_pos_y:
                self.win.move(int(editwin_pos_x),int(editwin_pos_y))
            
    def __init__(self,configs,newsgroups,article,selected_text,subscribed_groups,mode="Normal"):
        if article==None:
            is_fup=False
        else:
            is_fup=True

        nick=configs["nick"]
        email=configs["email"]
        nick=nick+" <"+email+">"


        self.win=gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.win.connect("delete_event",self.delete_event)
        #self.win.connect("destroy",self.destroy)
        self.win.set_title("Edit Article")
        self.win.set_icon(gtk.gdk.pixbuf_new_from_file("pixmaps/xpn.xpm"))
        #self.win.maximize()

        #main_vbox
        main_vbox=gtk.VBox()
        self.win.add(main_vbox)

        self.MenuBar=EditMenuBar(self.win)
        main_vbox.pack_start(self.MenuBar.get_widget(),gtk.FALSE,gtk.TRUE,0)
        self.MenuBar.show()
        self.menuitems=self.MenuBar.get_menuitems()
        self.menuitems["discard"].connect("activate",self.destroy)
        self.menuitems["rot13"].connect("activate",self.apply_rot13)
        self.menuitems["send"].connect("activate",self.send_article,configs,article)
        self.menuitems["editor"].connect("activate",self.external_editor,configs["editor_launcher"])
        self.menuitems["spoiler"].connect("activate",self.insert_spoiler_char)


        self.ToolBar=EditToolBar()
        main_vbox.pack_start(self.ToolBar.get_widget(),gtk.FALSE,gtk.TRUE,0)
        self.ToolBar.show()
        self.buttons=self.ToolBar.get_buttons()
        self.buttons["discard"].connect("clicked",self.destroy)
        self.buttons["rot13"].connect("clicked",self.apply_rot13)
        self.buttons["send"].connect("clicked",self.send_article,configs,article)
        self.buttons["editor"].connect("clicked",self.external_editor,configs["editor_launcher"])
        self.buttons["spoiler"].connect("clicked",self.insert_spoiler_char)

        self.headers_notebook=gtk.Notebook()
        self.headers_label=gtk.Label("Article")

        self.headers_table=gtk.Table(3,2,gtk.FALSE)
        self.headers_table.set_border_width(2)
        self.newsgroups_label=gtk.Label("<b>Newsgroups : </b>")
        self.newsgroups_label.set_use_markup(gtk.TRUE)
        self.newsgroups_label.set_alignment(1,0.5)
        self.from_label=gtk.Label("<b>From : </b>")
        self.from_label.set_use_markup(gtk.TRUE)
        self.from_label.set_alignment(1,0.5)
        self.subj_label=gtk.Label("<b>Subject : </b>")
        self.subj_label.set_use_markup(gtk.TRUE)
        self.subj_label.set_alignment(1,0.5)
        #self.newsgroups_entry=gtk.Entry()
        self.newsgroups_entry=gtk.combo_box_entry_new_text()
        self.from_entry=gtk.Entry()
        self.subj_entry=gtk.Entry()
        self.headers_table.attach(self.newsgroups_label,0,1,0,1,gtk.FILL,gtk.FILL)
        self.headers_table.attach(self.from_label,0,1,1,2,gtk.FILL,gtk.FILL)
        self.headers_table.attach(self.subj_label,0,1,2,3,gtk.FILL,gtk.FILL)
        self.headers_table.attach(self.newsgroups_entry,1,2,0,1)
        self.headers_table.attach(self.from_entry,1,2,1,2)
        self.headers_table.attach(self.subj_entry,1,2,2,3)

        #buffer
        self.buffer=gtk.TextBuffer()

        self.quote1_tag=None
        self.quote2_tag=None
        self.quote3_tag=None
        self.sign_tag=None
        self.text_tag=None
        color=configs["text_color"]
        self.set_text_color(color)
        color=configs["quote1_color"]
        self.set_quote_color(color,1)
        color=configs["quote2_color"]
        self.set_quote_color(color,2)
        color=configs["quote3_color"]
        self.set_quote_color(color,3)
        color=configs["sign_color"]
        self.set_sign_color(color)

        #TextView
        text_scrolledwin=gtk.ScrolledWindow()
        text_scrolledwin.set_border_width(2)
        text_scrolledwin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_AUTOMATIC)
        text_scrolledwin.set_shadow_type(gtk.SHADOW_OUT)
        self.textview=gtk.TextView(self.buffer)
        self.textview.set_wrap_mode(gtk.WRAP_WORD)
        self.textview.set_indent(4)
        text_scrolledwin.add(self.textview)


        self.text_vbox=gtk.VBox()
        self.text_vbox.pack_start(self.headers_table,gtk.FALSE,gtk.FALSE)
        self.text_vbox.pack_start(text_scrolledwin,gtk.TRUE,gtk.TRUE)

        self.headers_notebook.append_page(self.text_vbox,self.headers_label)

        self.custom_headers_label=gtk.Label("More Headers")

        self.custom_headers_table=gtk.Table(8,2,gtk.FALSE)
        self.custom_headers_table.set_border_width(4)
        self.reply_to_label=gtk.Label("<b>Reply-To : </b>")
        self.reply_to_label.set_use_markup(gtk.TRUE)
        self.reply_to_label.set_alignment(1,0.5)
        self.sender_label=gtk.Label("<b>Sender : </b>")
        self.sender_label.set_use_markup(gtk.TRUE)
        self.sender_label.set_alignment(1,0.5)
        self.organization_label=gtk.Label("<b>Organization : </b>")
        self.organization_label.set_use_markup(gtk.TRUE)
        self.organization_label.set_alignment(1,0.5)
        self.followup_to_label=gtk.Label("<b>Followup-To : </b>")
        self.followup_to_label.set_use_markup(gtk.TRUE)
        self.followup_to_label.set_alignment(1,0.5)
        self.mail_copies_to_label=gtk.Label("<b>Mail-Copies-To : </b>")
        self.mail_copies_to_label.set_use_markup(gtk.TRUE)
        self.mail_copies_to_label.set_alignment(1,0.5)
        self.archive_label=gtk.Label("<b>Archive : </b>")
        self.archive_label.set_use_markup(gtk.TRUE)
        self.archive_label.set_alignment(1,0.5)
        self.supersedes_label=gtk.Label("<b>Supersedes : </b>")
        self.supersedes_label.set_use_markup(gtk.TRUE)
        self.supersedes_label.set_alignment(1,0.5)
        self.approved_label=gtk.Label("<b>Approved : </b>")
        self.approved_label.set_use_markup(gtk.TRUE)
        self.approved_label.set_alignment(1,0.5)
        self.charset_label=gtk.Label("<b>Charset : </b>")
        self.charset_label.set_use_markup(gtk.TRUE)
        self.charset_label.set_alignment(1,0.5)

        self.reply_to_entry=gtk.Entry()
        self.sender_entry=gtk.Entry()
        self.organization_entry=gtk.Entry()
        self.followup_to_entry=gtk.Entry()
        self.mail_copies_to_entry=gtk.Entry()
        self.archive_entry=gtk.Entry()
        self.supersedes_entry=gtk.Entry()
        self.supersedes_entry.set_sensitive(gtk.FALSE)
        self.approved_entry=gtk.Entry()
        self.charset_combo=gtk.combo_box_entry_new_text()
        for encoding in encodings_list:
            self.charset_combo.append_text(encoding)
        self.charset_tooltip=gtk.Tooltips()
        self.charset_tooltip.set_tip(self.charset_combo.child,encodings_tip) 
        
        self.charset_combo.child.set_editable(gtk.FALSE)
        self.custom_headers_table.attach(self.reply_to_label,0,1,0,1,gtk.FILL,gtk.FILL)
        self.custom_headers_table.attach(self.sender_label,0,1,1,2,gtk.FILL,gtk.FILL)
        self.custom_headers_table.attach(self.organization_label,0,1,2,3,gtk.FILL,gtk.FILL)
        self.custom_headers_table.attach(self.followup_to_label,0,1,3,4,gtk.FILL,gtk.FILL)
        self.custom_headers_table.attach(self.mail_copies_to_label,0,1,4,5,gtk.FILL,gtk.FILL)
        self.custom_headers_table.attach(self.archive_label,0,1,5,6,gtk.FILL,gtk.FILL)
        self.custom_headers_table.attach(self.supersedes_label,0,1,6,7,gtk.FILL,gtk.FILL)
        self.custom_headers_table.attach(self.approved_label,0,1,7,8,gtk.FILL,gtk.FILL)
        self.custom_headers_table.attach(self.charset_label,0,1,8,9,gtk.FILL,gtk.FILL)
        self.custom_headers_table.attach(self.reply_to_entry,1,2,0,1)
        self.custom_headers_table.attach(self.sender_entry,1,2,1,2)
        self.custom_headers_table.attach(self.organization_entry,1,2,2,3)
        self.custom_headers_table.attach(self.followup_to_entry,1,2,3,4)
        self.custom_headers_table.attach(self.mail_copies_to_entry,1,2,4,5)
        self.custom_headers_table.attach(self.archive_entry,1,2,5,6)
        self.custom_headers_table.attach(self.supersedes_entry,1,2,6,7)
        self.custom_headers_table.attach(self.approved_entry,1,2,7,8)
        self.custom_headers_table.attach(self.charset_combo,1,2,8,9)

        self.custom_headers_frame=gtk.Frame("Custom Headers (X-Headers)")
        self.custom_headers_frame.set_border_width(4)
        self.custom_headers_scrolledwin=gtk.ScrolledWindow()
        self.custom_headers_scrolledwin.set_border_width(4)
        self.custom_headers_scrolledwin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_AUTOMATIC)
        self.custom_headers_scrolledwin.set_shadow_type(gtk.SHADOW_OUT)
        self.custom_headers_buffer=gtk.TextBuffer()
        self.custom_headers_textview=gtk.TextView(self.custom_headers_buffer)
        self.custom_headers_scrolledwin.add(self.custom_headers_textview)
        self.custom_headers_frame.add(self.custom_headers_scrolledwin)

        self.custom_headers_vbox=gtk.VBox()
        self.custom_headers_vbox.pack_start(self.custom_headers_table,gtk.FALSE,gtk.FALSE)
        self.custom_headers_vbox.pack_start(self.custom_headers_frame,gtk.TRUE,gtk.TRUE)

        self.headers_notebook.append_page(self.custom_headers_vbox,self.custom_headers_label)
        main_vbox.pack_start(self.headers_notebook,gtk.TRUE,gtk.TRUE,0)

        #statusbar
        self.statusbar=gtk.Statusbar()
        main_vbox.pack_start(self.statusbar,gtk.FALSE,gtk.FALSE,0)

        #some updates
        self.server_name=configs["server"]
        self.port_number=int(configs["port"])
        self.server_username=configs["username"]
        self.server_password=configs["password"]
        self.server=None
        self.ordered_list=load_ordered_list()
        self.update_newsgroups_entry(newsgroups,subscribed_groups)
        self.from_entry.set_text(nick)
        self.references=""
        if is_fup:
            self.update_subject_entry(article.subj)
            self.references=self.update_references(article.ref+" "+article.msgid)
            self.add_attribution_line(article,configs)
            self.update_body(article,selected_text)
            start,insert_point=self.buffer.get_bounds()
            self.buffer.create_mark("insert_point_after_text",insert_point,gtk.TRUE)
        else:
            insert_point,stop=self.buffer.get_bounds()
            self.buffer.create_mark("insert_point",insert_point,gtk.TRUE)
        if mode=="Supersede":
            self.references=self.update_references(article.ref)
        self.update_custom_headers(configs)
        self.add_sign(configs)
        self.buffer.connect("changed",self.wrap_on_change,configs)
        self.buffer.connect("mark_set",self.update_position_and_cset)
        if selected_text==None:
            insert_pos=self.buffer.get_iter_at_mark(self.buffer.get_mark("insert_point"))
        else:
            insert_pos=self.buffer.get_iter_at_mark(self.buffer.get_mark("insert_point_after_text"))
        self.buffer.place_cursor(insert_pos)
        self.set_background(configs)
        self.set_foreground(configs)
        self.update_position_and_cset()
        self.is_fup=is_fup
        if mode=="Supersede":
            self.supersedes_entry.set_text(article.msgid.encode("utf-8"))
            self.subj_entry.set_text(article.subj.encode("utf-8"))
        if configs["external_editor"]=="True":
            self.external_editor(None,configs["editor_launcher"])
        self.set_sizes()
        self.editwin_width=None
        self.editwin_height=None
