import gtk
import re
from xpn_src.Article import Article
import cPickle
import shelve
from os import remove, sep
from xpn_src.UserDir import userdir

class Find_Win:
    def delete_event(self,widget,event,data=None):
        return gtk.FALSE

    def destroy(self,widget):
        self.window.destroy()

    def show(self):
        self.window.show_all()

    def is_match(self,non_empty,article,rule,match_rule,from_string,subj_string,msgid_string,ref_string,body_string):
        found_vet=[]
        if 0 in non_empty:
            if match_rule(article.from_name,from_string):
                found_vet.append(True)
            else:
                found_vet.append(False)
        if 1 in non_empty:
            if match_rule(article.subj,subj_string):
                found_vet.append(True)
            else:
                found_vet.append(False)
        if 2 in non_empty:
            if match_rule(article.msgid,msgid_string):
                found_vet.append(True)
            else:
                found_vet.append(False)
        if 3 in non_empty:
            if match_rule(article.ref,ref_string):
                found_vet.append(True)
            else:
                found_vet.append(False)
        if 4 in non_empty:
            body=article.get_body()
            if body!=None:
                body=" ".join(body)
                if match_rule(body,body_string):
                    found_vet.append(True)
                else:
                    found_vet.append(False)
            else:
                found_vet.append(False)

        if rule=="And":
            found=reduce(lambda x,y: x and y, found_vet,True)
        else:
            found=reduce(lambda x,y: x or y, found_vet,False)
        return found


    def next_match(self,obj):
        non_empty=[]
        from_string=self.entry_from.get_text().decode("utf-8")
        if from_string!="":
            non_empty.append(0)
        subj_string=self.entry_subject.get_text().decode("utf-8")
        if subj_string!="":
            non_empty.append(1)
        msgid_string=self.entry_msgid.get_text().decode("utf-8")
        if msgid_string!="":
            non_empty.append(2)
        ref_string=self.entry_ref.get_text().decode("utf-8")
        if ref_string!="":
            non_empty.append(3)
        body_string=self.entry_body.get_text().decode("utf-8")
        if body_string!="":
            non_empty.append(4)

        rule=["And","Or"][self.opt_menu.get_active()]
        case_insensitive=self.checkbutton_case.get_active()
        use_regex=self.checkbutton_regex.get_active()
        start_beginning=self.checkbutton_start.get_active()

        def match_re_case_ins(field,regex):
            try:
                match_rule=re.compile(regex,re.UNICODE|re.IGNORECASE).findall(field)
            except:
                match_rule=False
            return match_rule

        def match_re_case_sens(field,regex):
            try:
                match_rule=re.compile(regex,re.UNICODE).findall(field)
            except:
                match_rule=False
            return match_rule

        #select the correct function
        if use_regex:
            if case_insensitive:
                match_rule=lambda field,regex: match_re_case_ins(field,regex)
            else:
                match_rule=lambda field,regex: match_re_case_sens(field,regex)
        else:
            if case_insensitive:
                match_rule=lambda field,word: field.lower().find(word.lower())+1
            else:
                match_rule=lambda field,word: field.find(word)+1

        #select the iter
        treesel=self.main_win.threads_pane.threads_tree.get_selection()
        model,iter=treesel.get_selected()
        column=self.main_win.threads_pane.threads_tree.get_column(0)

        found=False
        if iter==None or start_beginning:
            iter=model.get_iter_first()

            if iter!=None:
                article=model.get_value(iter,4)
                found=self.is_match(non_empty,article,rule,match_rule,from_string,subj_string,msgid_string,ref_string,body_string)


        #begin the loop
        while (not found) and (iter!=None):
            iter=self.main_win.threads_pane.find_next_row(model,iter)
            if iter!=None:
                article=model.get_value(iter,4)
                found=self.is_match(non_empty,article,rule,match_rule,from_string,subj_string,msgid_string,ref_string,body_string)
            else:
                found=False


        if found:
            path=model.get_path(iter)
            root_path=[]
            root_path.append(path[0])
            root_path=tuple(root_path)
            self.main_win.threads_pane.threads_tree.expand_row(root_path,gtk.TRUE)
            self.main_win.threads_pane.threads_tree.grab_focus()
            self.main_win.threads_pane.threads_tree.scroll_to_cell(path,None,gtk.TRUE,0.4,0.0)
            self.main_win.threads_pane.threads_tree.set_cursor(path,None,gtk.FALSE)
            self.main_win.threads_pane.threads_tree.row_activated(path,column)
            self.checkbutton_start.set_active(gtk.FALSE)

    def __init__(self,main_win):
        self.main_win=main_win
        self.window=gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.window.connect("delete_event",self.delete_event)
        self.window.connect("destroy",self.destroy)
        self.window.set_title("Find Article")
        self.window.set_position(gtk.WIN_POS_CENTER)
        self.window.set_default_size(350,300)
        self.window.set_icon(gtk.gdk.pixbuf_new_from_file("pixmaps/find.xpm"))


        vbox=gtk.VBox()
        vbox.set_border_width(8)
        label_from=gtk.Label("\n<b>From </b>\n")
        label_from.set_use_markup(gtk.TRUE)
        label_from.set_alignment(1,0.5)
        label_subject=gtk.Label("\n<b>Subject </b>\n")
        label_subject.set_use_markup(gtk.TRUE)
        label_subject.set_alignment(1,0.5)
        label_msgid=gtk.Label("\n<b>Message-ID </b>\n")
        label_msgid.set_use_markup(gtk.TRUE)
        label_msgid.set_alignment(1,0.5)
        label_ref=gtk.Label("\n<b>References </b>\n")
        label_ref.set_use_markup(gtk.TRUE)
        label_ref.set_alignment(1,0.5)
        label_body=gtk.Label("\n<b>Body </b>\n")
        label_body.set_use_markup(gtk.TRUE)
        label_body.set_alignment(1,0.5)
        self.entry_from=gtk.Entry()
        self.entry_subject=gtk.Entry()
        self.entry_msgid=gtk.Entry()
        self.entry_ref=gtk.Entry()
        self.entry_body=gtk.Entry()
        fields_frame=gtk.Frame("Fields")
        fields_frame.set_border_width(4)
        find_table=gtk.Table(6,2,gtk.FALSE)
        find_table.set_border_width(4)

        find_table.attach(label_from,0,1,0,1,gtk.FILL,gtk.FILL)
        find_table.attach(label_subject,0,1,1,2,gtk.FILL,gtk.FILL)
        find_table.attach(label_msgid,0,1,2,3,gtk.FILL,gtk.FILL)
        find_table.attach(label_ref,0,1,4,5,gtk.FILL,gtk.FILL)
        find_table.attach(label_body,0,1,5,6,gtk.FILL,gtk.FILL)
        find_table.attach(self.entry_from,1,2,0,1,gtk.EXPAND|gtk.FILL)
        find_table.attach(self.entry_subject,1,2,1,2,gtk.EXPAND|gtk.FILL)
        find_table.attach(self.entry_msgid,1,2,2,3,gtk.EXPAND|gtk.FILL)
        find_table.attach(self.entry_ref,1,2,4,5,gtk.EXPAND|gtk.FILL)
        find_table.attach(self.entry_body,1,2,5,6,gtk.EXPAND|gtk.FILL)

        fields_frame.add(find_table)
        vbox.pack_start(fields_frame,gtk.TRUE,gtk.FALSE,2)

        rule_vbox=gtk.VBox()
        rule_vbox.set_border_width(4)
        hbox=gtk.HBox()
        self.checkbutton_start=gtk.CheckButton("Start from the Beginning")
        self.checkbutton_regex=gtk.CheckButton("Use Regular Expression")
        self.checkbutton_case=gtk.CheckButton("Case Insensitive")

        label=gtk.Label("Rule used to combine search results")
        self.opt_menu=gtk.combo_box_new_text()
        self.opt_menu.append_text("AND")
        self.opt_menu.append_text("OR")
        self.opt_menu.set_active(0)

        rule_vbox.pack_start(self.checkbutton_start,gtk.TRUE,gtk.FALSE,4)
        rule_vbox.pack_start(self.checkbutton_regex,gtk.TRUE,gtk.FALSE,4)
        rule_vbox.pack_start(self.checkbutton_case,gtk.TRUE,gtk.FALSE,4)
        hbox.pack_start(self.opt_menu,gtk.FALSE,gtk.TRUE,4)
        hbox.pack_start(label,gtk.FALSE,gtk.TRUE)
        rule_vbox.pack_start(hbox,gtk.TRUE,gtk.FALSE,8)
        rule_frame=gtk.Frame("Rules")
        rule_frame.set_border_width(4)
        rule_frame.add(rule_vbox)
        vbox.add(rule_frame)

        hbox_buttons=gtk.HBox()
        hbox_buttons.set_border_width(8)
        self.button_close=gtk.Button(None,gtk.STOCK_CLOSE)
        self.button_close.connect("clicked",self.destroy)
        self.button_next=gtk.Button(None,gtk.STOCK_GO_FORWARD)
        self.button_next.connect("clicked",self.next_match)
        hbox_buttons.pack_start(self.button_close,gtk.TRUE,gtk.TRUE,2)
        hbox_buttons.pack_start(self.button_next,gtk.TRUE,gtk.TRUE,2)
        vbox.pack_start(hbox_buttons,gtk.TRUE,gtk.FALSE,6)

        self.window.add(vbox)


class Search_Win:
    def delete_event(self,widget,event,data=None):
        return gtk.FALSE

    def destroy(self,widget):
        self.window.destroy()

    def show(self):
        self.window.show_all()

    def next_match(self,obj):
        text=self.entry_text.get_text().decode("utf-8")
        case_insensitive=self.checkbutton_case.get_active()
        use_regex=self.checkbutton_regex.get_active()
        start_beginning=self.checkbutton_start.get_active()

        def match_re_case_ins(field,regex):
            try:
                match_rule=re.compile(regex,re.UNICODE|re.IGNORECASE).search(field)
            except:
                match_rule=False
            return match_rule

        def match_re_case_sens(field,regex):
            try:
                match_rule=re.compile(regex,re.UNICODE).search(field)
            except:
                match_rule=False
            return match_rule


        if use_regex:
            if case_insensitive:
                #match_rule=lambda field,regex: re.compile(regex,re.UNICODE|re.IGNORECASE).search(field)
                match_rule=lambda field,regex: match_re_case_ins(field,regex)
            else:
                #match_rule=lambda field,regex: re.compile(regex,re.UNICODE).search(field)
                match_rule=lambda field,regex: match_re_case_sens(field,regex)
        else:
            if case_insensitive:
                match_rule=lambda field,word: field.lower().find(word.lower())+1
            else:
                match_rule=lambda field,word: field.find(word)+1

        if text!="":
            start,end=self.main_win.article_pane.buffer.get_bounds()
            sel_bounds=self.main_win.article_pane.buffer.get_selection_bounds()
            line_number=0
            char_offset=0
            if sel_bounds:
                #There is selected text, let's start after it
                start=sel_bounds[1]
                line_number=start.get_line()
                char_offset=start.get_line_offset()
            if start_beginning:
                start,end=self.main_win.article_pane.buffer.get_bounds()
                line_number=0
                char_offset=0
            body=self.main_win.article_pane.buffer.get_text(start,end,gtk.TRUE).decode("utf-8").split("\n")
            success=False
            for line in body:
                pos=match_rule(line,text)
                if pos:
                    if use_regex:
                        start=pos.start()
                        end=pos.end()
                    else:
                        start=pos-1
                        end=pos+len(text)-1
                    iter_start=self.main_win.article_pane.buffer.get_start_iter()
                    iter_start.set_line(line_number)
                    iter_stop=iter_start.copy()
                    iter_start.set_line_offset(start+char_offset)
                    iter_stop.set_line_offset(end+char_offset)
                    match=self.main_win.article_pane.buffer.get_text(iter_start,iter_stop,gtk.TRUE)
                    success=True
                    break
                line_number=line_number+1
                char_offset=0
            if success:
                self.main_win.article_pane.buffer.move_mark_by_name("insert",iter_start)
                self.main_win.article_pane.buffer.move_mark_by_name("selection_bound",iter_stop)
                self.checkbutton_start.set_active(gtk.FALSE)
                self.main_win.article_pane.textview.scroll_to_iter(iter_start,0.3)



    def __init__(self,main_win):
        self.main_win=main_win
        self.window=gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.window.connect("delete_event",self.delete_event)
        self.window.connect("destroy",self.destroy)
        self.window.set_title("Search in the Body")
        self.window.set_position(gtk.WIN_POS_CENTER)
        self.window.set_default_size(350,150)
        self.window.set_icon(gtk.gdk.pixbuf_new_from_file("pixmaps/search.xpm"))


        vbox=gtk.VBox()
        vbox.set_border_width(8)
        text_label=gtk.Label("Text or Regular Expression")
        self.entry_text=gtk.Entry()
        vbox.pack_start(text_label,gtk.TRUE,gtk.FALSE,2)
        vbox.pack_start(self.entry_text,gtk.TRUE,gtk.FALSE,2)
        self.checkbutton_start=gtk.CheckButton("Start from the Beginning")
        self.checkbutton_regex=gtk.CheckButton("Use Regular Expression")
        self.checkbutton_case=gtk.CheckButton("Case Insensitive")
        vbox.pack_start(self.checkbutton_start,gtk.TRUE,gtk.FALSE,4)
        vbox.pack_start(self.checkbutton_regex,gtk.TRUE,gtk.FALSE,4)
        vbox.pack_start(self.checkbutton_case,gtk.TRUE,gtk.FALSE,4)
        hbox_buttons=gtk.HBox()
        hbox_buttons.set_border_width(8)
        self.button_close=gtk.Button(None,gtk.STOCK_CLOSE)
        self.button_close.connect("clicked",self.destroy)
        self.button_next=gtk.Button(None,gtk.STOCK_GO_FORWARD)
        self.button_next.connect("clicked",self.next_match)
        hbox_buttons.pack_start(self.button_close,gtk.TRUE,gtk.TRUE,2)
        hbox_buttons.pack_start(self.button_next,gtk.TRUE,gtk.TRUE,2)
        vbox.pack_start(hbox_buttons,gtk.TRUE,gtk.FALSE,6)

        self.window.add(vbox)


class GlobalSearch:
    def delete_event(self,widget,event,data=None):
        return gtk.FALSE

    def destroy(self,widget):
        self.main_win.gb_show_subscribed_button.show()
        self.window.destroy()

    def show(self):
        self.window.show_all()

    def is_match(self,non_empty,article,rule,match_rule,from_string,subj_string,msgid_string,ref_string,body_string):
        found_vet=[]
        if 0 in non_empty:
            if match_rule(article.from_name,from_string):
                found_vet.append(True)
            else:
                found_vet.append(False)
        if 1 in non_empty:
            if match_rule(article.subj,subj_string):
                found_vet.append(True)
            else:
                found_vet.append(False)
        if 2 in non_empty:
            if match_rule(article.msgid,msgid_string):
                found_vet.append(True)
            else:
                found_vet.append(False)
        if 3 in non_empty:
            if match_rule(article.ref,ref_string):
                found_vet.append(True)
            else:
                found_vet.append(False)
        if 4 in non_empty:
            body=article.get_body()
            if body!=None:
                body=" ".join(body)
                if match_rule(body,body_string):
                    found_vet.append(True)
                else:
                    found_vet.append(False)
            else:
                found_vet.append(False)

        if rule=="And":
            found=reduce(lambda x,y: x and y, found_vet,True)
        else:
            found=reduce(lambda x,y: x or y, found_vet,False)
        return found


    def next_match(self,obj):
        non_empty=[]
        from_string=self.entry_from.get_text().decode("utf-8")
        if from_string!="":
            non_empty.append(0)
        subj_string=self.entry_subject.get_text().decode("utf-8")
        if subj_string!="":
            non_empty.append(1)
        msgid_string=self.entry_msgid.get_text().decode("utf-8")
        if msgid_string!="":
            non_empty.append(2)
        ref_string=self.entry_ref.get_text().decode("utf-8")
        if ref_string!="":
            non_empty.append(3)
        body_string=self.entry_body.get_text().decode("utf-8")
        if body_string!="":
            non_empty.append(4)

        rule=["And","Or"][self.opt_menu.get_active()]
        case_insensitive=self.checkbutton_case.get_active()
        use_regex=self.checkbutton_regex.get_active()

        def match_re_case_ins(field,regex):
            try:
                match_rule=re.compile(regex,re.UNICODE|re.IGNORECASE).findall(field)
            except:
                match_rule=False
            return match_rule

        def match_re_case_sens(field,regex):
            try:
                match_rule=re.compile(regex,re.UNICODE).findall(field)
            except:
                match_rule=False
            return match_rule

        #select the correct function
        if use_regex:
            if case_insensitive:
                match_rule=lambda field,regex: match_re_case_ins(field,regex)
            else:
                match_rule=lambda field,regex: match_re_case_sens(field,regex)
        else:
            if case_insensitive:
                match_rule=lambda field,word: field.lower().find(word.lower())+1
            else:
                match_rule=lambda field,word: field.find(word)+1

        #select the iter
        treesel=self.main_win.threads_pane.threads_tree.get_selection()
        model,iter=treesel.get_selected()
        column=self.main_win.threads_pane.threads_tree.get_column(0)

        try:
            f=open(userdir + sep +"groups_info/subscribed.dat","rb")
        except IOError:
            self.main_win.statusbar.push(1,"No Subscribed Groups")
            list=[]
        else:
            list=cPickle.load(f)
            results=shelve.open(userdir + sep +"groups_info/global.search.results")
            unread_number=0
            for group in list:
                try:
                    f2=open(userdir + sep +"groups_info/"+group[0],"rb")
                except IOError:
                    self.main_win.statusbar.push(1,"Missing "+group[0]+" file")
                else:
                    f2.close()
                    articles=shelve.open(userdir + sep +"groups_info/"+group[0])
                    for article in articles.itervalues():
                        found=self.is_match(non_empty,article,rule,match_rule,from_string,subj_string,msgid_string,ref_string,body_string)
                        if found:
                            results[article.msgid]=article
                            if not article.is_read:
                                unread_number=unread_number+1
                    articles.close()
            total=len(results.keys())
            results.close()
            self.main_win.groups_pane.show_list([("global.search.results",str(unread_number)+" ("+str(total)+")"),],True)
            self.main_win.threads_pane.clear()
            self.main_win.article_pane.delete_all()
            self.main_win.article_pane.update_headers_labels("","","")



    def __init__(self,main_win):
        try:
            remove("groups_info/global.search.results")
        except:
            pass
        self.main_win=main_win
        self.window=gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.window.connect("delete_event",self.delete_event)
        self.window.connect("destroy",self.destroy)
        self.window.set_title("Global Search")
        self.window.set_position(gtk.WIN_POS_CENTER)
        self.window.set_default_size(350,300)
        self.window.set_icon(gtk.gdk.pixbuf_new_from_file("pixmaps/global_search.xpm"))


        vbox=gtk.VBox()
        vbox.set_border_width(8)
        label_from=gtk.Label("\n<b>From </b>\n")
        label_from.set_use_markup(gtk.TRUE)
        label_from.set_alignment(1,0.5)
        label_subject=gtk.Label("\n<b>Subject </b>\n")
        label_subject.set_use_markup(gtk.TRUE)
        label_subject.set_alignment(1,0.5)
        label_msgid=gtk.Label("\n<b>Message-ID </b>\n")
        label_msgid.set_use_markup(gtk.TRUE)
        label_msgid.set_alignment(1,0.5)
        label_ref=gtk.Label("\n<b>References </b>\n")
        label_ref.set_use_markup(gtk.TRUE)
        label_ref.set_alignment(1,0.5)
        label_body=gtk.Label("\n<b>Body </b>\n")
        label_body.set_use_markup(gtk.TRUE)
        label_body.set_alignment(1,0.5)
        self.entry_from=gtk.Entry()
        self.entry_subject=gtk.Entry()
        self.entry_msgid=gtk.Entry()
        self.entry_ref=gtk.Entry()
        self.entry_body=gtk.Entry()
        fields_frame=gtk.Frame("Fields")
        fields_frame.set_border_width(4)
        find_table=gtk.Table(6,2,gtk.FALSE)
        find_table.set_border_width(4)

        find_table.attach(label_from,0,1,0,1,gtk.FILL,gtk.FILL)
        find_table.attach(label_subject,0,1,1,2,gtk.FILL,gtk.FILL)
        find_table.attach(label_msgid,0,1,2,3,gtk.FILL,gtk.FILL)
        find_table.attach(label_ref,0,1,4,5,gtk.FILL,gtk.FILL)
        find_table.attach(label_body,0,1,5,6,gtk.FILL,gtk.FILL)
        find_table.attach(self.entry_from,1,2,0,1,gtk.EXPAND|gtk.FILL)
        find_table.attach(self.entry_subject,1,2,1,2,gtk.EXPAND|gtk.FILL)
        find_table.attach(self.entry_msgid,1,2,2,3,gtk.EXPAND|gtk.FILL)
        find_table.attach(self.entry_ref,1,2,4,5,gtk.EXPAND|gtk.FILL)
        find_table.attach(self.entry_body,1,2,5,6,gtk.EXPAND|gtk.FILL)

        fields_frame.add(find_table)
        vbox.pack_start(fields_frame,gtk.TRUE,gtk.FALSE,2)

        rule_vbox=gtk.VBox()
        rule_vbox.set_border_width(4)
        hbox=gtk.HBox()
        #self.checkbutton_start=gtk.CheckButton("Start from the Beginning")
        self.checkbutton_regex=gtk.CheckButton("Use Regular Expression")
        self.checkbutton_case=gtk.CheckButton("Case Insensitive")

        label=gtk.Label("Rule used to combine search results")
        self.opt_menu=gtk.combo_box_new_text()
        self.opt_menu.append_text("AND")
        self.opt_menu.append_text("OR")
        self.opt_menu.set_active(0)

        rule_vbox.pack_start(self.checkbutton_regex,gtk.TRUE,gtk.FALSE,4)
        rule_vbox.pack_start(self.checkbutton_case,gtk.TRUE,gtk.FALSE,4)
        hbox.pack_start(self.opt_menu,gtk.FALSE,gtk.TRUE,4)
        hbox.pack_start(label,gtk.FALSE,gtk.TRUE)
        rule_vbox.pack_start(hbox,gtk.TRUE,gtk.FALSE,8)
        rule_frame=gtk.Frame("Rules")
        rule_frame.set_border_width(4)
        rule_frame.add(rule_vbox)
        vbox.add(rule_frame)

        hbox_buttons=gtk.HBox()
        hbox_buttons.set_border_width(8)
        self.button_close=gtk.Button(None,gtk.STOCK_CLOSE)
        self.button_close.connect("clicked",self.destroy)
        self.button_next=gtk.Button(None,gtk.STOCK_FIND)
        self.button_next.connect("clicked",self.next_match)
        hbox_buttons.pack_start(self.button_close,gtk.TRUE,gtk.TRUE,2)
        hbox_buttons.pack_start(self.button_next,gtk.TRUE,gtk.TRUE,2)
        vbox.pack_start(hbox_buttons,gtk.TRUE,gtk.FALSE,6)
        self.window.add(vbox)
