import sys
import shelve
import gtk
import gobject
import socket
import cPickle
import time
import re
import threading, Queue
from nntplib import *
from string import find
from os import remove, sep

from rfc822 import parsedate_tz,mktime_tz

from xpn_src.Groups_Pane import Groups_Pane,Groups_List
from xpn_src.ConnectionThreads import ListThread
from xpn_src.Article import Article
from xpn_src.Config_File import Config_File
from xpn_src.Score import Score_Rules
from xpn_src.UserDir import userdir

class Groups_Win:
    def show(self):
        self.win.show_all()

    def delete_event(self,widget,event,data=None):
        return gtk.FALSE

    def destroy(self,obj):
        if self.server!=None:
            self.add_log("QUIT",True)
            self.add_log(self.server.quit(),False)
        self.win.destroy()

    def handle_error(self, error_strings):
        self.statusbar.push(1, error_strings[0])
        self.add_log(error_strings[0],False)
        self.server=None
        return 1

    def connected(self, response):
        self.statusbar.push(1, response[1])
        self.add_log(response[1],False)

    def ended_listing(self, data):
        lock = threading.Lock()
        lock.acquire()
        list = self.listThread.queue.get()
        lock.release()
        list.sort()
        flist = file(userdir + sep +"groups_info/groups.dat",'wb')
        cPickle.dump(list,flist,1)
        flist.close()
        self.total_list=list
        self.groups_list.show_list(list)
        return 1

    def get_list(self,obj):
        lock = threading.Lock()
        self.try_connection()
        if self.server != None:
            self.listThread = ListThread(self.server)
            self.listThread.start()
            self.statusbar.push(1,"Please wait, I'm downloading the list")
            finished = 0
            timer=10
            while 1:
                while gtk.events_pending():
                    gtk.main_iteration(gtk.FALSE)
                time.sleep(0.001)
                lock.acquire()
                try:
                    evt = self.listThread.queue.get_nowait()
                except Queue.Empty:
                    evt = [None, None]
                lock.release()
                _dispatch = {"Connected":self.connected,
                             "Server er":self.handle_error,
                             "Finished ":self.ended_listing
                             }
                if evt[0]!=None:
                    handler = _dispatch.get(evt[0][:9],None)
                else:
                    handler = None
                if handler: finished = handler(evt)
                else:
                    timer=timer-1
                    if timer<0:
                        self.progressbar.pulse()
                        timer=10
                if finished:
                    self.progressbar.set_fraction(0)
                    break




    def show_subscribed(self):
        try:
            f=open(userdir + sep +"groups_info/subscribed.dat","rb")
        except IOError:
            self.statusbar.push(1,"No Subscribed Groups")
        else:
            list=cPickle.load(f)
            new_list=[]
            for group in list:
                try:
                    f2=open(userdir + sep +"groups_info/"+group[0],"rb")
                except IOError:
                    self.statusbar.push(1,"Missing "+group[0]+" file")
                else:
                    f2.close()
                    articles=shelve.open(userdir + sep +"groups_info/"+group[0])
                    new_list.append((group[0],str(len(articles.keys()))))
                    articles.close()
            self.subscribed_list.show_list(new_list)
            f.close()


    def search_group(self,obj):
        group_to_search=self.group_entry.get_text()
        use_regex=self.regex_checkbutton.get_active()

        def match_regex(field,regex):
            try:
                match_rule=re.compile(regex,re.UNICODE).findall(field)
            except:
                match_rule=False
            return match_rule

        if use_regex:
            match_rule=lambda field,regex: match_regex(field,regex)
        else:
            match_rule=lambda field,word: field.find(word)+1

        list=self.total_list
        i=0
        found=[]
        #self.groups_list.clear()
        self.statusbar.push(1,"Searching...")
        while (i<len(list)):
            if  match_rule(list[i][0],group_to_search):
                found.append(list[i])
            i=i+1
        self.groups_list.show_list(found)
        self.statusbar.push(1,"")

    def show_full_list(self,obj):
        self.groups_list.show_list(self.total_list)

    def retrieve_body(self,article_to_read):
        body=article_to_read.get_body()
        if body==None:
            self.try_connection()
            body=[]
            if self.server!=None:
                try:
                    self.add_log("HEAD "+article_to_read.number,True)
                    resp,number,msgid,header_list=self.server.head(article_to_read.number)
                except NNTPTemporaryError:
                    if str(sys.exc_info()[1])[:1]=="4":
                        #article is not on the server, we use a phantom article
                        link=r"http://groups.google.com/groups?ie=UTF-8&oe=UTF-8&as_umsgid="+url_quote(article_to_read.msgid[1:-1])
                        body=("Server Error: "+str(sys.exc_info()[1]),"","You can try on Google:","",link)
                    else:
                        self.statusbar.push(1,"Server Error: str(sys.exc_info()[1])")
                        #VALUTARE SE BISOGNA GESTIRE LA SITUAZIONE!!!
                else:
                    self.add_log(resp,False)
                    article_to_read.parse_header_list(header_list)
                    self.add_log("BODY "+article_to_read.number,True)
                    resp,number,id,list=self.server.body(article_to_read.number)
                    self.add_log(resp,False)
                    article_to_read.set_body(list)
                    body=article_to_read.get_body()
        return body

    def subscribe_group(self,obj):
        treesel=self.groups_list.groups_list.get_selection()
        model,iter=treesel.get_selected()
        score_rules=Score_Rules()
        if iter!=None:
            group_to_subscribe=model.get_value(iter,0)
            self.try_connection()
            if self.server!=None:
                try:
                    self.add_log("GROUP "+group_to_subscribe,True)
                    resp,count,first,last,name=self.server.group(group_to_subscribe)
                except:
                    self.statusbar.push(1,"Server error: "+str(sys.exc_info()[1]))
                    self.add_log(str(sys.exc_info()[0])+","+str(sys.exc_info()[1]),False)
                    #self.add_log("QUIT",True)
                    #self.add_log(self.server.quit(),False)
                else:
                    watched=self.get_watched()
                    ignored=self.get_ignored()
                    subscribed_groups=[]
                    self.add_log(resp,False)
                    try:
                        f=open(userdir + sep +"groups_info/subscribed.dat","rb")
                    except IOError:
                        subscribed_groups.append([group_to_subscribe,last])
                    else:
                        subscribed_groups=cPickle.load(f)
                        if subscribed_groups !="":
                            already_in=0
                            for group in subscribed_groups:
                                if group[0]==group_to_subscribe:
                                    already_in=1
                                    to_remove=group
                            if already_in==1:
                                subscribed_groups.remove(to_remove)
                            subscribed_groups.append([group_to_subscribe,last])
                        f.close()
                    #refresh the subscribed file
                    try:
                        f=open(userdir + sep +"groups_info/subscribed.dat","wb")
                    except IOError:
                        self.statusbar.push(1,"Problems while opening subscribed.dat")
                    else:
                        articles_number=self.articles_spinbutton.get_value_as_int()
                        if articles_number>int(count):
                            articles_number=int(count)
                        subscribed_groups.sort()
                        cPickle.dump(subscribed_groups,f,1)
                        f.close()

                        #dowload the headers for the subscribed group
                        articles=shelve.open(userdir + sep +"groups_info/"+group_to_subscribe)
                        articles.clear()
                        first=repr(int(last)-articles_number+1)

                        self.progressbar.set_text("Fetching Headers")
                        self.progressbar.set_fraction(1/float(2))
                        while gtk.events_pending():
                            gtk.main_iteration(gtk.FALSE)
                        self.add_log("XOVER "+first+"-"+last,True)
                        resp,total_headers=self.server.my_xover(first,last)
                        self.add_log(resp,False)
                        self.statusbar.push(1,self.configs["server"]+" response : "+resp)

                        self.progressbar.set_text("Building Articles")
                        self.progressbar.set_fraction(2/float(2))
                        while gtk.events_pending():
                            gtk.main_iteration(gtk.FALSE)
                        for headers in total_headers:
                            number,subject,from_name,date,msgid,references,bytes,lines,xref=headers
                            xpn_article=Article(number,msgid,from_name,references,subject,date,self.configs["fallback_charset"],group_to_subscribe)
                            try:
                                index=references.rindex("<")
                            except ValueError:
                                last_ref=""
                            else:
                                last_ref=references[index:]

                            #applying score rules
                            score=score_rules.apply_score_rules(xpn_article,group_to_subscribe,xref,bytes,lines)
                            xpn_article.set_score(score)
                            
                            #applying score actions
                            xpn_article,actions,watched,ignored=score_rules.apply_action_rules(xpn_article,group_to_subscribe,xref,bytes,lines,watched,ignored)
                            if not "kill" in actions:
                                if ((self.configs["download_bodies"]=="True" and not "markread" in actions) or ("retrieve" in actions) or (last_ref in watched)) and not last_ref in ignored:
                                    body=self.retrieve_body(xpn_article)
                                if last_ref in ignored:
                                    xpn_article.is_read=True
                                    xpn_article.ignore=True
                                    ignored.add(xpn_article.msgid)
                                    watched.discard(xpn_article.msgid)
                                    xpn_article.watch=False
                                if last_ref in watched:
                                    xpn_article.watch=True
                                    watched.add(xpn_article.msgid)
                                    ignored.discard(xpn_article.msgid)
                                    xpn_article.ignore=False
                                articles[xpn_article.msgid]=xpn_article

                        self.statusbar.push(1,"Group subscribed")
                        self.progressbar.set_fraction(0)
                        self.progressbar.set_text("")
                        articles.close()
                    self.dump_watched(watched)
                    self.dump_ignored(ignored)
                self.show_subscribed()
                self.main_win.show_subscribed()


    def unsubscribe_group(self,obj):
        treesel=self.subscribed_list.groups_list.get_selection()
        model,iter=treesel.get_selected()
        if iter!=None:
            group_to_unsubscribe=model.get_value(iter,0)
            try:
                f=open(userdir + sep +"groups_info/subscribed.dat","rb")
            except IOError:
                self.statusbar.push(1,"Missing subscribed.dat")
            else:
                subscribed=cPickle.load(f)
                f.close()
                i=0
                success=0
                while (i<len(subscribed)) and (success==0):
                    if group_to_unsubscribe==subscribed[i][0]:
                        success=1
                        subscribed.remove(subscribed[i])
                        remove(userdir + sep +"groups_info/"+group_to_unsubscribe)
                        self.statusbar.push(1,"Group removed")
                    i=i+1
                try:
                    f=open(userdir + sep +"groups_info/subscribed.dat","wb")
                except IOError:
                    self.statusbar.push(1,"Problems while opening subscribed.dat")
                else:
                    cPickle.dump(subscribed,f,1)
                    f.close()
            self.main_win.show_subscribed()
            self.show_subscribed()


    def try_connection(self):
        if self.server==None:
            try:
                if self.server_username!="":
                    self.add_log("AUTHINFO USER "+self.server_username,True)
                    self.add_log("AUTHINFO PASS "+self.server_password,True)
                self.add_log("MODE READER",True)

                self.server=NNTP(self.server_name,port=self.port_number,user=self.server_username,password=self.server_password,readermode=True)
            except:
                message="No connection with server : "+self.server_name+". Configure NNTP Server Address or try later."
                self.add_log(str(sys.exc_info()[0])+","+str(sys.exc_info()[1]),False)
            else:
                message="Connection estabilished with:"+self.server_name
                self.add_log(self.server.getwelcome(),False)
            self.statusbar.push(1,message)

    def add_log(self,message,is_command):
        try:
            f=open(userdir + sep +"server_logs.dat","a")
        except IOError:
            pass
        else:
            if is_command:
                f.write(time.ctime(time.time())+" :: >> "+message+"\n")
            else:
                f.write(time.ctime(time.time())+" :: << "+message+"\n")
            f.close()
    
    def get_watched(self):
        try:
            f=open(userdir + sep +"dats/watch.dat","rb")
        except IOError:
            watched=set()
        else:
            watched=cPickle.load(f)
            f.close()
        return watched

    def dump_watched(self,watched):
        f=open(userdir + sep +"dats/watch.dat","wb")
        cPickle.dump(watched,f,1)
        f.close()

    def get_ignored(self):
        try:
            f=open(userdir + sep +"dats/ignore.dat","rb")
        except IOError:
            ignored=set()
        else:
            ignored=cPickle.load(f)
            f.close()
        return ignored

    def dump_ignored(self,ignored):
        f=open(userdir + sep +"dats/ignore.dat","wb")
        cPickle.dump(ignored,f,1)
        f.close()

    def change_live_search_status(self,obj):
        live_search=self.live_search_checkbutton.get_active()
        if live_search:
            self.search_button.set_sensitive(gtk.FALSE)
            self.live_search_handler=self.group_entry.connect("changed",self.search_group)
        else:
            self.search_button.set_sensitive(gtk.TRUE)
            self.group_entry.disconnect(self.live_search_handler)

        
    def __init__(self,server_name,port_number,server_username,server_password,main_win):
        self.conf=Config_File()
        self.configs=self.conf.get_configs()
        self.server_name=server_name
        self.port_number=int(port_number)
        self.server_username=server_username
        self.server_password=server_password
        self.server=None
        self.main_win=main_win
        self.win=gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.win.set_modal(gtk.TRUE)
        self.win.set_transient_for(main_win.window)
        self.win.connect("delete_event",self.delete_event)
        self.win.set_title("NewsGroups")
        self.win.set_icon(gtk.gdk.pixbuf_new_from_file("pixmaps/groups.xpm"))
        self.win.set_default_size(600,400)
        self.win.set_position(gtk.WIN_POS_CENTER)

        #main vbox
        self.vbox1 = gtk.VBox(gtk.FALSE,0)
        self.vbox1.set_border_width(2)
        self.win.add(self.vbox1)

        #hpaned
        self.hpaned =gtk.HPaned()
        self.hpaned.set_position(250)
        self.vbox1.pack_start(self.hpaned,gtk.TRUE,gtk.TRUE,0)

        #FrameList
        self.frame_list=gtk.Frame("List")
        self.hpaned.add(self.frame_list)


        #VBoxList
        self.vbox_list=gtk.VBox()
        self.vbox_list.set_border_width(2)
        self.frame_list.add(self.vbox_list)

        #HBoxList
        self.hbox_list=gtk.HBox()
        self.vbox_list.pack_start(self.hbox_list,gtk.FALSE,gtk.TRUE,2)

        #group_entry
        self.group_entry=gtk.Entry()
        self.hbox_list.pack_start(self.group_entry,gtk.TRUE,gtk.TRUE,2)

        #search_button
        self.search_button=gtk.Button("Search Group")
        self.search_button.connect("clicked",self.search_group)
        self.hbox_list.pack_start(self.search_button,gtk.FALSE,gtk.TRUE,2)
        self.search_button_tooltip=gtk.Tooltips()
        self.search_button_tooltip.set_tip(self.search_button,"Start searching")

        #live search check_button
        self.live_search_checkbutton=gtk.CheckButton("Perform Live Search")
        self.vbox_list.pack_start(self.live_search_checkbutton,gtk.FALSE,gtk.TRUE,2)
        self.live_search_checkbutton.connect("clicked",self.change_live_search_status)

        #regex check_button
        self.regex_checkbutton=gtk.CheckButton("Use Regular Expression")
        self.vbox_list.pack_start(self.regex_checkbutton,gtk.FALSE,gtk.TRUE,2)
        
        #full list button
        self.full_button=gtk.Button("Show Full List")
        self.full_button.connect("clicked",self.show_full_list)
        self.vbox_list.pack_start(self.full_button,gtk.FALSE,gtk.TRUE,2)

        #GroupsList
        self.groups_list=Groups_List("NewsGroups","Mode")
        self.vbox_list.pack_start(self.groups_list.get_widget(),gtk.TRUE,gtk.TRUE,2)

        #right_vbox
        self.right_vbox =gtk.VBox()
        self.hpaned.add(self.right_vbox)

        #right_hbox
        self.right_hbox=gtk.HBox()
        self.right_vbox.pack_start(self.right_hbox,gtk.FALSE,gtk.TRUE,0)


        #Server Frame
        self.server_frame =gtk.Frame("Server")
        self.right_hbox.pack_start(self.server_frame,gtk.TRUE,gtk.TRUE,0)

        #Server HBox
        self.server_hbox=gtk.HBox()
        self.server_frame.add(self.server_hbox)
        self.server_hbox.set_border_width(5)


        #Server Button
        self.server_button=gtk.Button("Get Newsgroups List")
        self.server_button.connect("clicked",self.get_list)
        self.server_hbox.pack_start(self.server_button,gtk.FALSE,gtk.TRUE,5)
        self.server_button_tooltip=gtk.Tooltips()
        self.server_button_tooltip.set_tip(self.server_button,"This could take several minutes")
        if self.server_name=="":
            self.server_button.set_sensitive(gtk.FALSE)

        #Server Label
        self.server_label =gtk.Label(server_name)
        self.server_hbox.pack_start(self.server_label,gtk.FALSE,gtk.TRUE,5)



        #Article Frame
        self.articles_frame =gtk.Frame("Articles Number")
        self.right_hbox.pack_start(self.articles_frame,gtk.FALSE,gtk.TRUE,0)

        #Articles SpinButton
        self.articles_spinbutton =gtk.SpinButton(gtk.Adjustment(value=500,lower=0,upper=10000,step_incr=1,page_incr=50))
        self.articles_spinbutton_tooltip=gtk.Tooltips()
        self.articles_spinbutton_tooltip.set_tip(self.articles_spinbutton,"Download this number of articles (headers only)")
        self.articles_frame.add(self.articles_spinbutton)

        #Subscribed Frame
        self.subscribed_frame= gtk.Frame("Subscribed Groups")
        self.right_vbox.pack_start(self.subscribed_frame,gtk.TRUE,gtk.TRUE,2)

        #Subscribed_hbox
        self.subscribed_hbox = gtk.HBox()
        self.subscribed_frame.add(self.subscribed_hbox)

        #button_box
        self.vbutton_box=gtk.VButtonBox()
        self.subscribed_hbox.pack_start(self.vbutton_box,gtk.FALSE,gtk.FALSE,0)
        self.vbutton_box.set_layout(gtk.BUTTONBOX_SPREAD)

        #button_subscribe
        self.button_subscribe=gtk.Button()
        self.button_subscribe.connect("clicked",self.subscribe_group)
        self.button_subscribe_image=gtk.Image()
        self.button_subscribe_image.set_from_file("pixmaps/next.xpm")
        self.button_subscribe.add(self.button_subscribe_image)
        self.vbutton_box.pack_start(self.button_subscribe,gtk.FALSE,gtk.FALSE,0)
        self.subscribe_button_tooltip=gtk.Tooltips()
        self.subscribe_button_tooltip.set_tip(self.button_subscribe,"Subscribe selected group")

        #button_unsubscribe
        self.button_unsubscribe=gtk.Button()
        self.button_unsubscribe.connect("clicked",self.unsubscribe_group)
        self.button_unsubscribe_image=gtk.Image()
        self.button_unsubscribe_image.set_from_file("pixmaps/previous.xpm")
        self.button_unsubscribe.add(self.button_unsubscribe_image)
        self.vbutton_box.pack_start(self.button_unsubscribe,gtk.FALSE,gtk.FALSE,0)
        self.unsubscribe_button_tooltip=gtk.Tooltips()
        self.unsubscribe_button_tooltip.set_tip(self.button_unsubscribe,"Unsubscribe selected group")

        #subscribed_groups
        self.subscribed_list=Groups_Pane("NewsGroups","Articles",gtk.FALSE,self.configs)
        self.subscribed_hbox.pack_start(self.subscribed_list.get_widget(),gtk.TRUE,gtk.TRUE,5)


        #button_close
        self.button_close= gtk.Button(None,gtk.STOCK_OK)
        self.vbox1.pack_start(self.button_close,gtk.FALSE,gtk.TRUE,4)
        self.button_close.connect("clicked",self.destroy)
        self.button_close_tooltip=gtk.Tooltips()
        self.button_close_tooltip.set_tip(self.button_close,"Close this window")

        #hbox_bottom
        self.hbox_bottom=gtk.HBox()
        self.vbox1.pack_start(self.hbox_bottom,gtk.FALSE,gtk.FALSE,0)

        #progressbar
        self.progressbar=gtk.ProgressBar()
        self.hbox_bottom.pack_start(self.progressbar,gtk.FALSE,gtk.FALSE,0)

        #statusbar
        self.statusbar=gtk.Statusbar()
        self.hbox_bottom.pack_start(self.statusbar,gtk.TRUE,gtk.TRUE,0)

        #some inits
        self.show_subscribed()
        self.show()
        self.statusbar.push(1,"Building Newsgroups list")
        self.total_list=[]
        while gtk.events_pending():
            gtk.main_iteration(gtk.FALSE)
        try:
            f=open(userdir + sep +"groups_info/groups.dat","rb")
        except IOError:
            self.statusbar.push(1,"You have to download newsgroups list")
        else:
            try:
                list=cPickle.load(f)
            except EOFError:
                self.statusbar.push(1,"You have to download newsgroups list")
            else:
                self.total_list=list
                self.groups_list.show_list(list)
                self.statusbar.push(1,"Newsgroups list loaded")
            f.close()
