import gtk

class MainToolBar:
    def get_widget(self):
        return self.toolbar

    def show(self):
        self.toolbar.show_all()

    def get_buttons(self):
        return self.buttons

    def insert(self,name,icon_name,shortname,tooltip):
        icon=gtk.Image()
        icon.set_from_file("pixmaps/"+icon_name)
        toolbutton=gtk.ToolButton(icon,name)
        toolbutton.set_tooltip(self.tips,tooltip,tooltip)
        self.toolbar.insert(toolbutton,-1)
        self.buttons[shortname]=toolbutton
        self.toolbar.set_tooltips(gtk.TRUE)

    def append_space(self):
        separator=gtk.SeparatorToolItem()
        self.toolbar.insert(separator,-1)

    def append_label(self,label_text):
        toolitem=gtk.ToolItem()
        label=gtk.Label(label_text)
        toolitem.add(label)
        self.toolbar.insert(toolitem,-1)

    def __init__(self):

        self.buttons={}

        #Toolbar
        self.toolbar=gtk.Toolbar()
        self.toolbar.set_border_width(1)
        self.toolbar.set_orientation(gtk.ORIENTATION_HORIZONTAL)
        self.toolbar.set_style(gtk.TOOLBAR_ICONS)
        self.toolbar.set_tooltips(gtk.TRUE)
        self.tips=gtk.Tooltips()

        #Groups
        self.append_label("Groups:")
        self.insert("Groups","groups.xpm","groups","Manage Groups")
        self.insert("Headers","receive_headers.xpm","gethdrs","Get New Headers in Subscribe Groups")
        self.insert("Bodies","receive_bodies.xpm","getbodies","Get Marked Article Bodies in Subscribed Groups")
        self.insert("Mark","mark.xpm","mark","Mark Group as Read")
        self.insert("Mark All","mark_all.xpm","markall","Mark All Groups as Read")
        self.append_space()


        #Write
        self.append_label("Write:")
        self.insert("Post","post.xpm","post","Post New Article")
        self.insert("Follow-Up","followup.xpm","followup","Follow-Up To Newsgroup")
        self.insert("Reply","reply.xpm","reply","Reply by Mail")
        self.append_space()


        #Read
        self.append_label("Read:")
        self.insert("Previous","previous.xpm","previous","Read Previous Article")
        self.insert("Next","next.xpm","next","Read Next Article")
        self.insert("Next Unread","next_unread.xpm","next_unread","Read Next Unread Article")
        self.insert("Raw","raw.xpm","raw","View Raw Article")
        self.insert("Rot13","rot13.xpm","rot13","ROT13 Selected Text")
        self.append_space()


        #Threads
        self.append_label("Threads:")
        self.insert("Expand","expand.xpm","expand","Expand All")
        self.insert("Collapse","collapse.xpm","collapse","Collapse All")
        self.append_space()


        #Conf
        self.append_label("Configure:")
        self.insert("Score","score.xpm","score","Edit Scoring Rules")
        self.insert("Preferences","conf.xpm","conf","Preferences")

        self.tips.enable()


class EditToolBar:
    def get_widget(self):
        return self.toolbar

    def show(self):
        self.toolbar.show_all()

    def get_buttons(self):
        return self.buttons

    def insert(self,name,icon_name,shortname,tooltip):
        icon=gtk.Image()
        icon.set_from_file("pixmaps/"+icon_name)
        toolbutton=gtk.ToolButton(icon,name)
        toolbutton.set_tooltip(self.tips,tooltip,tooltip)
        self.toolbar.insert(toolbutton,-1)
        self.buttons[shortname]=toolbutton
        self.toolbar.set_tooltips(gtk.TRUE)

    def append_space(self):
        separator=gtk.SeparatorToolItem()
        self.toolbar.insert(separator,-1)

    def append_label(self,label_text):
        toolitem=gtk.ToolItem()
        label=gtk.Label(label_text)
        toolitem.add(label)
        self.toolbar.insert(toolitem,-1)

    def __init__(self):
        self.buttons={}

        #Toolbar
        self.toolbar=gtk.Toolbar()
        self.toolbar.set_border_width(1)
        self.toolbar.set_orientation(gtk.ORIENTATION_HORIZONTAL)
        self.toolbar.set_style(gtk.TOOLBAR_ICONS)
        self.toolbar.set_tooltips(gtk.TRUE)
        self.tips=gtk.Tooltips()

        #Groups
        self.append_label("Send:")
        self.insert("Send","send.xpm","send","Send Article")
        self.insert("Discard","discard.xpm","discard","Discard Article")
        self.append_space()

        #Edit
        self.append_label("Edit:")
        self.insert("Rot13","rot13.xpm","rot13","ROT13 Selected Text")
        self.insert("Spoiler Char","spoiler_char.xpm","spoiler","Insert Spoiler Char")
        self.insert("Editor","editor.xpm","editor","Launch External Editor")

        self.tips.enable()
