#!/usr/bin/env python
import gtk
from locale import getdefaultlocale
from os import sep
from xpn_src.UserDir import userdir

FILENAME=userdir + sep +"tags.txt"

class Tags_Window:
    def delete_event(self,widget,event,data=None):
        return gtk.FALSE  

    def destroy(self,widget):
        self.window.destroy()
        if __name__=="__main__":
            gtk.main_quit()
    
    def append_tag(self,widget):
        try:
            f=open(FILENAME,"a")
        except IOError:
            f=open(FILENAME,"w") 
        system_enc=getdefaultlocale()[1]
        tag=self.entry.get_text().decode("utf-8").encode(system_enc,"replace")
        if tag!="":
            f.write(tag+"\n")
            self.statusbar.push(1,"Tag Added")
            self.entry.set_text("")
        f.close()

    def show_length(self,widget):
        length=len(self.entry.get_text().decode("utf-8"))
        self.statusbar.push(1,"Tag length: "+repr(length))
        if length>80:
            self.statusbar.push(1,"Please reduce to 78 chars")

    def load_state(self):
        try:
            f=open(FILENAME,"r")
        except IOError:
            length="0"
        else:
            length=repr(len(f.readlines()))
            f.close()
        self.statusbar.push(1,"Found "+length+" tags")
        
    def __init__(self):
        self.window=gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.window.connect("delete_event",self.delete_event)
        self.window.connect("destroy",self.destroy)
        self.window.set_title("XPN Tags Manager")
        self.window.set_position(gtk.WIN_POS_CENTER)
        vbox=gtk.VBox(gtk.FALSE,0)
        vbox.set_border_width(2)
        label=gtk.Label("\n<b>Insert here a tagline</b>\n")
        label.set_use_markup(gtk.TRUE)
        vbox.pack_start(label,gtk.TRUE,gtk.TRUE,0)
        self.entry=gtk.Entry()
        self.entry.connect("changed",self.show_length)
        vbox.pack_start(self.entry,gtk.FALSE,gtk.TRUE,0)
        hbox_buttons=gtk.HBox()
        hbox_buttons.set_border_width(4)
        self.button_ok=gtk.Button(None,gtk.STOCK_ADD)
        self.button_ok.connect("clicked",self.append_tag)
        self.button_close=gtk.Button(None,gtk.STOCK_CLOSE)
        self.button_close.connect("clicked",self.destroy)
        hbox_buttons.pack_start(self.button_close,gtk.TRUE,gtk.TRUE,2)
        hbox_buttons.pack_start(self.button_ok,gtk.TRUE,gtk.TRUE,2)
        vbox.pack_start(hbox_buttons,gtk.TRUE,gtk.TRUE,0)
        self.statusbar=gtk.Statusbar()
        vbox.pack_start(self.statusbar,gtk.FALSE,gtk.TRUE,0)
        self.window.add(vbox)
        self.window.set_default_size(550,60)
        self.window.show_all()
        self.load_state()

if __name__=="__main__":
    tags_win=Tags_Window()
    gtk.main()
